/* sudoku-board.c generated by valac 0.44.0, the Vala compiler
 * generated from sudoku-board.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/*
 * Copyright © 2014 Parin Porecha
 * Copyright © 2014 Michael Catanzaro
 *
 * This file is part of GNOME Sudoku.
 *
 * GNOME Sudoku is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * GNOME Sudoku is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GNOME Sudoku. If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib-object.h>
#include <glib.h>
#include <gee.h>
#include <float.h>
#include <math.h>
#include <qqwing-wrapper.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>

#define TYPE_SUDOKU_BOARD (sudoku_board_get_type ())
#define SUDOKU_BOARD(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SUDOKU_BOARD, SudokuBoard))
#define SUDOKU_BOARD_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SUDOKU_BOARD, SudokuBoardClass))
#define IS_SUDOKU_BOARD(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SUDOKU_BOARD))
#define IS_SUDOKU_BOARD_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SUDOKU_BOARD))
#define SUDOKU_BOARD_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SUDOKU_BOARD, SudokuBoardClass))

typedef struct _SudokuBoard SudokuBoard;
typedef struct _SudokuBoardClass SudokuBoardClass;
typedef struct _SudokuBoardPrivate SudokuBoardPrivate;

#define TYPE_COORD (coord_get_type ())
typedef struct _Coord Coord;
typedef enum  {
	DIFFICULTY_CATEGORY_UNKNOWN,
	DIFFICULTY_CATEGORY_EASY,
	DIFFICULTY_CATEGORY_MEDIUM,
	DIFFICULTY_CATEGORY_HARD,
	DIFFICULTY_CATEGORY_VERY_HARD,
	DIFFICULTY_CATEGORY_CUSTOM
} DifficultyCategory;

#define TYPE_DIFFICULTY_CATEGORY (difficulty_category_get_type ())
enum  {
	SUDOKU_BOARD_0_PROPERTY,
	SUDOKU_BOARD_PREVIOUS_PLAYED_TIME_PROPERTY,
	SUDOKU_BOARD_DIFFICULTY_CATEGORY_PROPERTY,
	SUDOKU_BOARD_BLOCK_ROWS_PROPERTY,
	SUDOKU_BOARD_BLOCK_COLS_PROPERTY,
	SUDOKU_BOARD_ROWS_PROPERTY,
	SUDOKU_BOARD_COLS_PROPERTY,
	SUDOKU_BOARD_MAX_VAL_PROPERTY,
	SUDOKU_BOARD_BROKEN_PROPERTY,
	SUDOKU_BOARD_FILLED_PROPERTY,
	SUDOKU_BOARD_FIXED_PROPERTY,
	SUDOKU_BOARD_SIZE_PROPERTY,
	SUDOKU_BOARD_COMPLETE_PROPERTY,
	SUDOKU_BOARD_NUM_PROPERTIES
};
static GParamSpec* sudoku_board_properties[SUDOKU_BOARD_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _coord_free0(var) ((var == NULL) ? NULL : (var = (coord_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	SUDOKU_BOARD_COMPLETED_SIGNAL,
	SUDOKU_BOARD_NUM_SIGNALS
};
static guint sudoku_board_signals[SUDOKU_BOARD_NUM_SIGNALS] = {0};
typedef enum  {
	HOUSE_ROW,
	HOUSE_COLUMN,
	HOUSE_BLOCK
} House;

#define TYPE_HOUSE (house_get_type ())

#define TYPE_CELL (cell_get_type ())
typedef struct _Cell Cell;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _Coord {
	gint row;
	gint col;
};

struct _SudokuBoard {
	GObject parent_instance;
	SudokuBoardPrivate * priv;
	gint* cells;
	gint cells_length1;
	gint cells_length2;
	gboolean* is_fixed;
	gint is_fixed_length1;
	gint is_fixed_length2;
	GeeSet* broken_coords;
	GeeList* coords_for_col;
	GeeList* coords_for_row;
	GeeMap* coords_for_block;
};

struct _SudokuBoardClass {
	GObjectClass parent_class;
};

struct _SudokuBoardPrivate {
	gboolean* possible_in_row;
	gint possible_in_row_length1;
	gint possible_in_row_length2;
	gboolean* possible_in_col;
	gint possible_in_col_length1;
	gint possible_in_col_length2;
	gboolean* possible_in_block;
	gint possible_in_block_length1;
	gint possible_in_block_length2;
	gint possible_in_block_length3;
	gboolean* earmarks;
	gint earmarks_length1;
	gint earmarks_length2;
	gint earmarks_length3;
	gint n_earmarks;
	gdouble _previous_played_time;
	DifficultyCategory _difficulty_category;
	gint _block_rows;
	gint _block_cols;
	gint _rows;
	gint _cols;
	gint _filled;
	gint _fixed;
};

struct _Cell {
	Coord coord;
	gint val;
};

static gint SudokuBoard_private_offset;
static gpointer sudoku_board_parent_class = NULL;

GType sudoku_board_get_type (void) G_GNUC_CONST;
GType coord_get_type (void) G_GNUC_CONST;
Coord* coord_dup (const Coord* self);
void coord_free (Coord* self);
GType difficulty_category_get_type (void) G_GNUC_CONST;
gboolean sudoku_board_is_empty (SudokuBoard* self);
gint sudoku_board_get_filled (SudokuBoard* self);
gint sudoku_board_get_fixed (SudokuBoard* self);
gboolean sudoku_board_is_fully_filled (SudokuBoard* self);
gint sudoku_board_get_cols (SudokuBoard* self);
gint sudoku_board_get_rows (SudokuBoard* self);
SudokuBoard* sudoku_board_new (gint block_rows,
                               gint block_cols);
SudokuBoard* sudoku_board_construct (GType object_type,
                                     gint block_rows,
                                     gint block_cols);
static void sudoku_board_set_cols (SudokuBoard* self,
                            gint value);
static void sudoku_board_set_rows (SudokuBoard* self,
                            gint value);
static void sudoku_board_set_block_rows (SudokuBoard* self,
                                  gint value);
static void sudoku_board_set_block_cols (SudokuBoard* self,
                                  gint value);
gint sudoku_board_get_max_val (SudokuBoard* self);
gint coord_hash (Coord* coord);
gboolean coord_equal (Coord* a,
                      Coord* b);
void coord_init (Coord *self,
                 gint row,
                 gint col);
SudokuBoard* sudoku_board_clone (SudokuBoard* self);
gint sudoku_board_get_block_rows (SudokuBoard* self);
gint sudoku_board_get_block_cols (SudokuBoard* self);
static gint* _vala_array_dup1 (gint* self,
                        int length);
static gboolean* _vala_array_dup2 (gboolean* self,
                            int length);
static gboolean* _vala_array_dup3 (gboolean* self,
                            int length);
static gboolean* _vala_array_dup4 (gboolean* self,
                            int length);
static gboolean* _vala_array_dup5 (gboolean* self,
                            int length);
static void sudoku_board_set_filled (SudokuBoard* self,
                              gint value);
static void sudoku_board_set_fixed (SudokuBoard* self,
                             gint value);
static gboolean* _vala_array_dup6 (gboolean* self,
                            int length);
DifficultyCategory sudoku_board_get_difficulty_category (SudokuBoard* self);
void sudoku_board_set_difficulty_category (SudokuBoard* self,
                                           DifficultyCategory value);
void sudoku_board_enable_earmark (SudokuBoard* self,
                                  gint row,
                                  gint column,
                                  gint digit);
void sudoku_board_disable_earmark (SudokuBoard* self,
                                   gint row,
                                   gint column,
                                   gint digit);
void sudoku_board_disable_all_earmarks (SudokuBoard* self,
                                        gint row,
                                        gint column);
gboolean sudoku_board_is_earmark_enabled (SudokuBoard* self,
                                          gint row,
                                          gint column,
                                          gint digit);
gboolean sudoku_board_is_possible (SudokuBoard* self,
                                   gint row,
                                   gint col,
                                   gint val);
gint sudoku_board_count_possibilities (SudokuBoard* self,
                                       gint row,
                                       gint col);
gint* sudoku_board_get_possibilities (SudokuBoard* self,
                                      gint row,
                                      gint col,
                                      gint* result_length1);
static gint* _vala_array_dup7 (gint* self,
                        int length);
gboolean* sudoku_board_get_possibilities_as_bool_array (SudokuBoard* self,
                                                        gint row,
                                                        gint col,
                                                        gint* result_length1);
void sudoku_board_get_block_for (SudokuBoard* self,
                                 gint row,
                                 gint col,
                                 Coord* result);
void sudoku_board_insert (SudokuBoard* self,
                          gint row,
                          gint col,
                          gint val,
                          gboolean is_fixed);
void sudoku_board_remove (SudokuBoard* self,
                          gint row,
                          gint col,
                          gboolean is_fixed);
static void sudoku_board_mark_breakages_for (SudokuBoard* self,
                                      GeeList* coords,
                                      gint val);
gboolean sudoku_board_get_complete (SudokuBoard* self);
void sudoku_board_set (SudokuBoard* self,
                       gint row,
                       gint col,
                       gint val);
gint sudoku_board_get (SudokuBoard* self,
                       gint row,
                       gint col);
static void sudoku_board_remove_breakages_for (SudokuBoard* self,
                                        GeeList* coords,
                                        gint val);
GeeSet* sudoku_board_get_occurances (SudokuBoard* self,
                                     GeeList* coords,
                                     gint val);
gint sudoku_board_count_solutions_limited (SudokuBoard* self);
gboolean sudoku_board_row_contains (SudokuBoard* self,
                                    gint row,
                                    gint val);
gboolean sudoku_board_col_contains (SudokuBoard* self,
                                    gint col,
                                    gint val);
gboolean sudoku_board_block_contains (SudokuBoard* self,
                                      Coord* block,
                                      gint val);
void sudoku_board_to_initial_state (SudokuBoard* self);
void sudoku_board_print (SudokuBoard* self,
                         gint indent);
void sudoku_board_get_string (SudokuBoard* self);
gchar* sudoku_board_to_string (SudokuBoard* self,
                               gboolean get_original_state);
gint* sudoku_board_get_cells (SudokuBoard* self,
                              gint* result_length1,
                              gint* result_length2);
static gint* _vala_array_dup8 (gint* self,
                        int length);
GeeHashMap* sudoku_board_calculate_open_squares (SudokuBoard* self);
gboolean sudoku_board_is_finished (SudokuBoard* self);
const gchar* sudoku_saver_get_finishgame_dir (void);
gchar* sudoku_board_get_earmarks_string (SudokuBoard* self,
                                         gint row,
                                         gint col);
gdouble sudoku_board_get_previous_played_time (SudokuBoard* self);
void sudoku_board_set_previous_played_time (SudokuBoard* self,
                                            gdouble value);
gboolean sudoku_board_get_broken (SudokuBoard* self);
gint sudoku_board_get_size (SudokuBoard* self);
static void sudoku_board_finalize (GObject * obj);
static void _vala_sudoku_board_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec);
static void _vala_sudoku_board_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec);
GType house_get_type (void) G_GNUC_CONST;
GType cell_get_type (void) G_GNUC_CONST;
Cell* cell_dup (const Cell* self);
void cell_free (Cell* self);
void cell_init (Cell *self,
                Coord* coord,
                gint val);
gint cell_hash (Cell* cell);
gboolean cell_equal (Cell* a,
                     Cell* b);
gchar* difficulty_category_to_string (DifficultyCategory self);
gchar* difficulty_category_to_untranslated_string (DifficultyCategory self);
DifficultyCategory difficulty_category_from_string (const gchar* input);

static inline gpointer
sudoku_board_get_instance_private (SudokuBoard* self)
{
	return G_STRUCT_MEMBER_P (self, SudokuBoard_private_offset);
}

gboolean
sudoku_board_is_empty (SudokuBoard* self)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gint _tmp1_;
	gint _tmp2_;
#line 80 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 82 "../lib/sudoku-board.vala"
	_tmp1_ = self->priv->_filled;
#line 82 "../lib/sudoku-board.vala"
	_tmp2_ = self->priv->_fixed;
#line 82 "../lib/sudoku-board.vala"
	if (_tmp1_ == _tmp2_) {
#line 82 "../lib/sudoku-board.vala"
		_tmp0_ = self->priv->n_earmarks == 0;
#line 352 "sudoku-board.c"
	} else {
#line 82 "../lib/sudoku-board.vala"
		_tmp0_ = FALSE;
#line 356 "sudoku-board.c"
	}
#line 82 "../lib/sudoku-board.vala"
	result = _tmp0_;
#line 82 "../lib/sudoku-board.vala"
	return result;
#line 362 "sudoku-board.c"
}

gboolean
sudoku_board_is_fully_filled (SudokuBoard* self)
{
	gboolean result = FALSE;
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 85 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 87 "../lib/sudoku-board.vala"
	_tmp0_ = self->priv->_filled;
#line 87 "../lib/sudoku-board.vala"
	_tmp1_ = self->priv->_cols;
#line 87 "../lib/sudoku-board.vala"
	_tmp2_ = self->priv->_rows;
#line 87 "../lib/sudoku-board.vala"
	result = _tmp0_ == (_tmp1_ * _tmp2_);
#line 87 "../lib/sudoku-board.vala"
	return result;
#line 384 "sudoku-board.c"
}

SudokuBoard*
sudoku_board_construct (GType object_type,
                        gint block_rows,
                        gint block_cols)
{
	SudokuBoard * self = NULL;
	gint _tmp0_;
	gint _tmp1_;
	gint* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gboolean* _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	gboolean* _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	gboolean* _tmp11_;
	gboolean* _tmp12_;
	gint _tmp13_;
	gint _tmp14_;
	gint _tmp15_;
	gint _tmp16_;
	gboolean* _tmp17_;
	GeeHashSet* _tmp37_;
	GeeArrayList* _tmp38_;
	GeeList* _tmp59_;
	GeeList* _tmp60_;
	GeeList* _tmp61_;
	GeeArrayList* _tmp62_;
	GeeList* _tmp83_;
	GeeList* _tmp84_;
	GeeList* _tmp85_;
	GeeHashMap* _tmp86_;
	GeeMap* _tmp119_;
	GeeMap* _tmp120_;
	GeeMap* _tmp121_;
#line 104 "../lib/sudoku-board.vala"
	self = (SudokuBoard*) g_object_new (object_type, NULL);
#line 106 "../lib/sudoku-board.vala"
	sudoku_board_set_cols (self, block_rows * block_cols);
#line 106 "../lib/sudoku-board.vala"
	sudoku_board_set_rows (self, block_rows * block_cols);
#line 107 "../lib/sudoku-board.vala"
	sudoku_board_set_block_rows (self, block_rows);
#line 108 "../lib/sudoku-board.vala"
	sudoku_board_set_block_cols (self, block_cols);
#line 109 "../lib/sudoku-board.vala"
	_tmp0_ = self->priv->_rows;
#line 109 "../lib/sudoku-board.vala"
	_tmp1_ = self->priv->_cols;
#line 109 "../lib/sudoku-board.vala"
	_tmp2_ = g_new0 (gint, _tmp0_ * _tmp1_);
#line 109 "../lib/sudoku-board.vala"
	self->cells = (g_free (self->cells), NULL);
#line 109 "../lib/sudoku-board.vala"
	self->cells = _tmp2_;
#line 109 "../lib/sudoku-board.vala"
	self->cells_length1 = _tmp0_;
#line 109 "../lib/sudoku-board.vala"
	self->cells_length2 = _tmp1_;
#line 110 "../lib/sudoku-board.vala"
	_tmp3_ = self->priv->_rows;
#line 110 "../lib/sudoku-board.vala"
	_tmp4_ = self->priv->_cols;
#line 110 "../lib/sudoku-board.vala"
	_tmp5_ = g_new0 (gboolean, _tmp3_ * _tmp4_);
#line 110 "../lib/sudoku-board.vala"
	self->is_fixed = (g_free (self->is_fixed), NULL);
#line 110 "../lib/sudoku-board.vala"
	self->is_fixed = _tmp5_;
#line 110 "../lib/sudoku-board.vala"
	self->is_fixed_length1 = _tmp3_;
#line 110 "../lib/sudoku-board.vala"
	self->is_fixed_length2 = _tmp4_;
#line 111 "../lib/sudoku-board.vala"
	_tmp6_ = self->priv->_rows;
#line 111 "../lib/sudoku-board.vala"
	_tmp7_ = self->priv->_cols;
#line 111 "../lib/sudoku-board.vala"
	_tmp8_ = g_new0 (gboolean, _tmp6_ * _tmp7_);
#line 111 "../lib/sudoku-board.vala"
	self->priv->possible_in_row = (g_free (self->priv->possible_in_row), NULL);
#line 111 "../lib/sudoku-board.vala"
	self->priv->possible_in_row = _tmp8_;
#line 111 "../lib/sudoku-board.vala"
	self->priv->possible_in_row_length1 = _tmp6_;
#line 111 "../lib/sudoku-board.vala"
	self->priv->possible_in_row_length2 = _tmp7_;
#line 112 "../lib/sudoku-board.vala"
	_tmp9_ = self->priv->_cols;
#line 112 "../lib/sudoku-board.vala"
	_tmp10_ = self->priv->_rows;
#line 112 "../lib/sudoku-board.vala"
	_tmp11_ = g_new0 (gboolean, _tmp9_ * _tmp10_);
#line 112 "../lib/sudoku-board.vala"
	self->priv->possible_in_col = (g_free (self->priv->possible_in_col), NULL);
#line 112 "../lib/sudoku-board.vala"
	self->priv->possible_in_col = _tmp11_;
#line 112 "../lib/sudoku-board.vala"
	self->priv->possible_in_col_length1 = _tmp9_;
#line 112 "../lib/sudoku-board.vala"
	self->priv->possible_in_col_length2 = _tmp10_;
#line 113 "../lib/sudoku-board.vala"
	_tmp12_ = g_new0 (gboolean, (block_rows * block_cols) * (block_rows * block_cols));
#line 113 "../lib/sudoku-board.vala"
	self->priv->possible_in_block = (g_free (self->priv->possible_in_block), NULL);
#line 113 "../lib/sudoku-board.vala"
	self->priv->possible_in_block = _tmp12_;
#line 113 "../lib/sudoku-board.vala"
	self->priv->possible_in_block_length1 = block_rows;
#line 113 "../lib/sudoku-board.vala"
	self->priv->possible_in_block_length2 = block_cols;
#line 113 "../lib/sudoku-board.vala"
	self->priv->possible_in_block_length3 = block_rows * block_cols;
#line 114 "../lib/sudoku-board.vala"
	_tmp13_ = self->priv->_rows;
#line 114 "../lib/sudoku-board.vala"
	_tmp14_ = self->priv->_cols;
#line 114 "../lib/sudoku-board.vala"
	_tmp15_ = sudoku_board_get_max_val (self);
#line 114 "../lib/sudoku-board.vala"
	_tmp16_ = _tmp15_;
#line 114 "../lib/sudoku-board.vala"
	_tmp17_ = g_new0 (gboolean, (_tmp13_ * _tmp14_) * _tmp16_);
#line 114 "../lib/sudoku-board.vala"
	self->priv->earmarks = (g_free (self->priv->earmarks), NULL);
#line 114 "../lib/sudoku-board.vala"
	self->priv->earmarks = _tmp17_;
#line 114 "../lib/sudoku-board.vala"
	self->priv->earmarks_length1 = _tmp13_;
#line 114 "../lib/sudoku-board.vala"
	self->priv->earmarks_length2 = _tmp14_;
#line 114 "../lib/sudoku-board.vala"
	self->priv->earmarks_length3 = _tmp16_;
#line 522 "sudoku-board.c"
	{
		gint l1 = 0;
#line 116 "../lib/sudoku-board.vala"
		l1 = 0;
#line 527 "sudoku-board.c"
		{
			gboolean _tmp18_ = FALSE;
#line 116 "../lib/sudoku-board.vala"
			_tmp18_ = TRUE;
#line 116 "../lib/sudoku-board.vala"
			while (TRUE) {
#line 534 "sudoku-board.c"
				gint _tmp20_;
#line 116 "../lib/sudoku-board.vala"
				if (!_tmp18_) {
#line 538 "sudoku-board.c"
					gint _tmp19_;
#line 116 "../lib/sudoku-board.vala"
					_tmp19_ = l1;
#line 116 "../lib/sudoku-board.vala"
					l1 = _tmp19_ + 1;
#line 544 "sudoku-board.c"
				}
#line 116 "../lib/sudoku-board.vala"
				_tmp18_ = FALSE;
#line 116 "../lib/sudoku-board.vala"
				_tmp20_ = self->priv->_rows;
#line 116 "../lib/sudoku-board.vala"
				if (!(l1 < _tmp20_)) {
#line 116 "../lib/sudoku-board.vala"
					break;
#line 554 "sudoku-board.c"
				}
				{
					gint l2 = 0;
#line 118 "../lib/sudoku-board.vala"
					l2 = 0;
#line 560 "sudoku-board.c"
					{
						gboolean _tmp21_ = FALSE;
#line 118 "../lib/sudoku-board.vala"
						_tmp21_ = TRUE;
#line 118 "../lib/sudoku-board.vala"
						while (TRUE) {
#line 567 "sudoku-board.c"
							gint _tmp23_;
							gint* _tmp24_;
							gint _tmp24__length1;
							gint _tmp24__length2;
							gboolean* _tmp25_;
							gint _tmp25__length1;
							gint _tmp25__length2;
							gboolean* _tmp26_;
							gint _tmp26__length1;
							gint _tmp26__length2;
							gboolean* _tmp27_;
							gint _tmp27__length1;
							gint _tmp27__length2;
#line 118 "../lib/sudoku-board.vala"
							if (!_tmp21_) {
#line 583 "sudoku-board.c"
								gint _tmp22_;
#line 118 "../lib/sudoku-board.vala"
								_tmp22_ = l2;
#line 118 "../lib/sudoku-board.vala"
								l2 = _tmp22_ + 1;
#line 589 "sudoku-board.c"
							}
#line 118 "../lib/sudoku-board.vala"
							_tmp21_ = FALSE;
#line 118 "../lib/sudoku-board.vala"
							_tmp23_ = self->priv->_cols;
#line 118 "../lib/sudoku-board.vala"
							if (!(l2 < _tmp23_)) {
#line 118 "../lib/sudoku-board.vala"
								break;
#line 599 "sudoku-board.c"
							}
#line 120 "../lib/sudoku-board.vala"
							_tmp24_ = self->cells;
#line 120 "../lib/sudoku-board.vala"
							_tmp24__length1 = self->cells_length1;
#line 120 "../lib/sudoku-board.vala"
							_tmp24__length2 = self->cells_length2;
#line 120 "../lib/sudoku-board.vala"
							_tmp24_[(l1 * _tmp24__length2) + l2] = 0;
#line 121 "../lib/sudoku-board.vala"
							_tmp25_ = self->is_fixed;
#line 121 "../lib/sudoku-board.vala"
							_tmp25__length1 = self->is_fixed_length1;
#line 121 "../lib/sudoku-board.vala"
							_tmp25__length2 = self->is_fixed_length2;
#line 121 "../lib/sudoku-board.vala"
							_tmp25_[(l1 * _tmp25__length2) + l2] = FALSE;
#line 122 "../lib/sudoku-board.vala"
							_tmp26_ = self->priv->possible_in_row;
#line 122 "../lib/sudoku-board.vala"
							_tmp26__length1 = self->priv->possible_in_row_length1;
#line 122 "../lib/sudoku-board.vala"
							_tmp26__length2 = self->priv->possible_in_row_length2;
#line 122 "../lib/sudoku-board.vala"
							_tmp26_[(l1 * _tmp26__length2) + l2] = TRUE;
#line 123 "../lib/sudoku-board.vala"
							_tmp27_ = self->priv->possible_in_col;
#line 123 "../lib/sudoku-board.vala"
							_tmp27__length1 = self->priv->possible_in_col_length1;
#line 123 "../lib/sudoku-board.vala"
							_tmp27__length2 = self->priv->possible_in_col_length2;
#line 123 "../lib/sudoku-board.vala"
							_tmp27_[(l2 * _tmp27__length2) + l1] = TRUE;
#line 633 "sudoku-board.c"
						}
					}
				}
			}
		}
	}
	{
		gint l1 = 0;
#line 126 "../lib/sudoku-board.vala"
		l1 = 0;
#line 644 "sudoku-board.c"
		{
			gboolean _tmp28_ = FALSE;
#line 126 "../lib/sudoku-board.vala"
			_tmp28_ = TRUE;
#line 126 "../lib/sudoku-board.vala"
			while (TRUE) {
#line 126 "../lib/sudoku-board.vala"
				if (!_tmp28_) {
#line 653 "sudoku-board.c"
					gint _tmp29_;
#line 126 "../lib/sudoku-board.vala"
					_tmp29_ = l1;
#line 126 "../lib/sudoku-board.vala"
					l1 = _tmp29_ + 1;
#line 659 "sudoku-board.c"
				}
#line 126 "../lib/sudoku-board.vala"
				_tmp28_ = FALSE;
#line 126 "../lib/sudoku-board.vala"
				if (!(l1 < block_rows)) {
#line 126 "../lib/sudoku-board.vala"
					break;
#line 667 "sudoku-board.c"
				}
				{
					gint l2 = 0;
#line 127 "../lib/sudoku-board.vala"
					l2 = 0;
#line 673 "sudoku-board.c"
					{
						gboolean _tmp30_ = FALSE;
#line 127 "../lib/sudoku-board.vala"
						_tmp30_ = TRUE;
#line 127 "../lib/sudoku-board.vala"
						while (TRUE) {
#line 127 "../lib/sudoku-board.vala"
							if (!_tmp30_) {
#line 682 "sudoku-board.c"
								gint _tmp31_;
#line 127 "../lib/sudoku-board.vala"
								_tmp31_ = l2;
#line 127 "../lib/sudoku-board.vala"
								l2 = _tmp31_ + 1;
#line 688 "sudoku-board.c"
							}
#line 127 "../lib/sudoku-board.vala"
							_tmp30_ = FALSE;
#line 127 "../lib/sudoku-board.vala"
							if (!(l2 < block_cols)) {
#line 127 "../lib/sudoku-board.vala"
								break;
#line 696 "sudoku-board.c"
							}
							{
								gint l3 = 0;
#line 128 "../lib/sudoku-board.vala"
								l3 = 0;
#line 702 "sudoku-board.c"
								{
									gboolean _tmp32_ = FALSE;
#line 128 "../lib/sudoku-board.vala"
									_tmp32_ = TRUE;
#line 128 "../lib/sudoku-board.vala"
									while (TRUE) {
#line 709 "sudoku-board.c"
										gint _tmp34_;
										gint _tmp35_;
										gboolean* _tmp36_;
										gint _tmp36__length1;
										gint _tmp36__length2;
										gint _tmp36__length3;
#line 128 "../lib/sudoku-board.vala"
										if (!_tmp32_) {
#line 718 "sudoku-board.c"
											gint _tmp33_;
#line 128 "../lib/sudoku-board.vala"
											_tmp33_ = l3;
#line 128 "../lib/sudoku-board.vala"
											l3 = _tmp33_ + 1;
#line 724 "sudoku-board.c"
										}
#line 128 "../lib/sudoku-board.vala"
										_tmp32_ = FALSE;
#line 128 "../lib/sudoku-board.vala"
										_tmp34_ = sudoku_board_get_max_val (self);
#line 128 "../lib/sudoku-board.vala"
										_tmp35_ = _tmp34_;
#line 128 "../lib/sudoku-board.vala"
										if (!(l3 < _tmp35_)) {
#line 128 "../lib/sudoku-board.vala"
											break;
#line 736 "sudoku-board.c"
										}
#line 129 "../lib/sudoku-board.vala"
										_tmp36_ = self->priv->possible_in_block;
#line 129 "../lib/sudoku-board.vala"
										_tmp36__length1 = self->priv->possible_in_block_length1;
#line 129 "../lib/sudoku-board.vala"
										_tmp36__length2 = self->priv->possible_in_block_length2;
#line 129 "../lib/sudoku-board.vala"
										_tmp36__length3 = self->priv->possible_in_block_length3;
#line 129 "../lib/sudoku-board.vala"
										_tmp36_[(((l1 * _tmp36__length2) + l2) * _tmp36__length3) + l3] = TRUE;
#line 748 "sudoku-board.c"
									}
								}
							}
						}
					}
				}
			}
		}
	}
#line 131 "../lib/sudoku-board.vala"
	_tmp37_ = gee_hash_set_new (TYPE_COORD, (GBoxedCopyFunc) coord_dup, (GDestroyNotify) coord_free, (GeeHashDataFunc) coord_hash, NULL, NULL, (GeeEqualDataFunc) coord_equal, NULL, NULL);
#line 131 "../lib/sudoku-board.vala"
	_g_object_unref0 (self->broken_coords);
#line 131 "../lib/sudoku-board.vala"
	self->broken_coords = (GeeSet*) _tmp37_;
#line 133 "../lib/sudoku-board.vala"
	_tmp38_ = gee_array_list_new (GEE_TYPE_ARRAY_LIST, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 133 "../lib/sudoku-board.vala"
	_g_object_unref0 (self->coords_for_col);
#line 133 "../lib/sudoku-board.vala"
	self->coords_for_col = (GeeList*) _tmp38_;
#line 770 "sudoku-board.c"
	{
		gint col = 0;
#line 134 "../lib/sudoku-board.vala"
		col = 0;
#line 775 "sudoku-board.c"
		{
			gboolean _tmp39_ = FALSE;
#line 134 "../lib/sudoku-board.vala"
			_tmp39_ = TRUE;
#line 134 "../lib/sudoku-board.vala"
			while (TRUE) {
#line 782 "sudoku-board.c"
				gint _tmp41_;
				GeeList* _tmp42_;
				GeeArrayList* _tmp43_;
				GeeArrayList* _tmp44_;
				GeeList* _tmp52_;
				GeeList* _tmp53_;
				gpointer _tmp54_;
				GeeList* _tmp55_;
				GeeList* _tmp56_;
				GeeList* _tmp57_;
				GeeList* _tmp58_;
#line 134 "../lib/sudoku-board.vala"
				if (!_tmp39_) {
#line 796 "sudoku-board.c"
					gint _tmp40_;
#line 134 "../lib/sudoku-board.vala"
					_tmp40_ = col;
#line 134 "../lib/sudoku-board.vala"
					col = _tmp40_ + 1;
#line 802 "sudoku-board.c"
				}
#line 134 "../lib/sudoku-board.vala"
				_tmp39_ = FALSE;
#line 134 "../lib/sudoku-board.vala"
				_tmp41_ = self->priv->_cols;
#line 134 "../lib/sudoku-board.vala"
				if (!(col < _tmp41_)) {
#line 134 "../lib/sudoku-board.vala"
					break;
#line 812 "sudoku-board.c"
				}
#line 136 "../lib/sudoku-board.vala"
				_tmp42_ = self->coords_for_col;
#line 136 "../lib/sudoku-board.vala"
				_tmp43_ = gee_array_list_new (TYPE_COORD, (GBoxedCopyFunc) coord_dup, (GDestroyNotify) coord_free, (GeeEqualDataFunc) coord_equal, NULL, NULL);
#line 136 "../lib/sudoku-board.vala"
				_tmp44_ = _tmp43_;
#line 136 "../lib/sudoku-board.vala"
				gee_collection_add ((GeeCollection*) _tmp42_, (GeeList*) _tmp44_);
#line 136 "../lib/sudoku-board.vala"
				_g_object_unref0 (_tmp44_);
#line 824 "sudoku-board.c"
				{
					gint row = 0;
#line 137 "../lib/sudoku-board.vala"
					row = 0;
#line 829 "sudoku-board.c"
					{
						gboolean _tmp45_ = FALSE;
#line 137 "../lib/sudoku-board.vala"
						_tmp45_ = TRUE;
#line 137 "../lib/sudoku-board.vala"
						while (TRUE) {
#line 836 "sudoku-board.c"
							gint _tmp47_;
							GeeList* _tmp48_;
							gpointer _tmp49_;
							GeeList* _tmp50_;
							Coord _tmp51_ = {0};
#line 137 "../lib/sudoku-board.vala"
							if (!_tmp45_) {
#line 844 "sudoku-board.c"
								gint _tmp46_;
#line 137 "../lib/sudoku-board.vala"
								_tmp46_ = row;
#line 137 "../lib/sudoku-board.vala"
								row = _tmp46_ + 1;
#line 850 "sudoku-board.c"
							}
#line 137 "../lib/sudoku-board.vala"
							_tmp45_ = FALSE;
#line 137 "../lib/sudoku-board.vala"
							_tmp47_ = self->priv->_rows;
#line 137 "../lib/sudoku-board.vala"
							if (!(row < _tmp47_)) {
#line 137 "../lib/sudoku-board.vala"
								break;
#line 860 "sudoku-board.c"
							}
#line 138 "../lib/sudoku-board.vala"
							_tmp48_ = self->coords_for_col;
#line 138 "../lib/sudoku-board.vala"
							_tmp49_ = gee_list_get (_tmp48_, col);
#line 138 "../lib/sudoku-board.vala"
							_tmp50_ = (GeeList*) _tmp49_;
#line 138 "../lib/sudoku-board.vala"
							coord_init (&_tmp51_, row, col);
#line 138 "../lib/sudoku-board.vala"
							gee_collection_add ((GeeCollection*) _tmp50_, &_tmp51_);
#line 138 "../lib/sudoku-board.vala"
							_g_object_unref0 (_tmp50_);
#line 874 "sudoku-board.c"
						}
					}
				}
#line 140 "../lib/sudoku-board.vala"
				_tmp52_ = self->coords_for_col;
#line 140 "../lib/sudoku-board.vala"
				_tmp53_ = self->coords_for_col;
#line 140 "../lib/sudoku-board.vala"
				_tmp54_ = gee_list_get (_tmp53_, col);
#line 140 "../lib/sudoku-board.vala"
				_tmp55_ = (GeeList*) _tmp54_;
#line 140 "../lib/sudoku-board.vala"
				_tmp56_ = gee_list_get_read_only_view (_tmp55_);
#line 140 "../lib/sudoku-board.vala"
				_tmp57_ = _tmp56_;
#line 140 "../lib/sudoku-board.vala"
				_tmp58_ = _tmp57_;
#line 140 "../lib/sudoku-board.vala"
				gee_list_set (_tmp52_, col, _tmp58_);
#line 140 "../lib/sudoku-board.vala"
				_g_object_unref0 (_tmp58_);
#line 140 "../lib/sudoku-board.vala"
				_g_object_unref0 (_tmp55_);
#line 898 "sudoku-board.c"
			}
		}
	}
#line 142 "../lib/sudoku-board.vala"
	_tmp59_ = self->coords_for_col;
#line 142 "../lib/sudoku-board.vala"
	_tmp60_ = gee_list_get_read_only_view (_tmp59_);
#line 142 "../lib/sudoku-board.vala"
	_tmp61_ = _tmp60_;
#line 142 "../lib/sudoku-board.vala"
	_g_object_unref0 (self->coords_for_col);
#line 142 "../lib/sudoku-board.vala"
	self->coords_for_col = _tmp61_;
#line 144 "../lib/sudoku-board.vala"
	_tmp62_ = gee_array_list_new (GEE_TYPE_ARRAY_LIST, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 144 "../lib/sudoku-board.vala"
	_g_object_unref0 (self->coords_for_row);
#line 144 "../lib/sudoku-board.vala"
	self->coords_for_row = (GeeList*) _tmp62_;
#line 918 "sudoku-board.c"
	{
		gint row = 0;
#line 145 "../lib/sudoku-board.vala"
		row = 0;
#line 923 "sudoku-board.c"
		{
			gboolean _tmp63_ = FALSE;
#line 145 "../lib/sudoku-board.vala"
			_tmp63_ = TRUE;
#line 145 "../lib/sudoku-board.vala"
			while (TRUE) {
#line 930 "sudoku-board.c"
				gint _tmp65_;
				GeeList* _tmp66_;
				GeeArrayList* _tmp67_;
				GeeArrayList* _tmp68_;
				GeeList* _tmp76_;
				GeeList* _tmp77_;
				gpointer _tmp78_;
				GeeList* _tmp79_;
				GeeList* _tmp80_;
				GeeList* _tmp81_;
				GeeList* _tmp82_;
#line 145 "../lib/sudoku-board.vala"
				if (!_tmp63_) {
#line 944 "sudoku-board.c"
					gint _tmp64_;
#line 145 "../lib/sudoku-board.vala"
					_tmp64_ = row;
#line 145 "../lib/sudoku-board.vala"
					row = _tmp64_ + 1;
#line 950 "sudoku-board.c"
				}
#line 145 "../lib/sudoku-board.vala"
				_tmp63_ = FALSE;
#line 145 "../lib/sudoku-board.vala"
				_tmp65_ = self->priv->_rows;
#line 145 "../lib/sudoku-board.vala"
				if (!(row < _tmp65_)) {
#line 145 "../lib/sudoku-board.vala"
					break;
#line 960 "sudoku-board.c"
				}
#line 147 "../lib/sudoku-board.vala"
				_tmp66_ = self->coords_for_row;
#line 147 "../lib/sudoku-board.vala"
				_tmp67_ = gee_array_list_new (TYPE_COORD, (GBoxedCopyFunc) coord_dup, (GDestroyNotify) coord_free, (GeeEqualDataFunc) coord_equal, NULL, NULL);
#line 147 "../lib/sudoku-board.vala"
				_tmp68_ = _tmp67_;
#line 147 "../lib/sudoku-board.vala"
				gee_collection_add ((GeeCollection*) _tmp66_, (GeeList*) _tmp68_);
#line 147 "../lib/sudoku-board.vala"
				_g_object_unref0 (_tmp68_);
#line 972 "sudoku-board.c"
				{
					gint col = 0;
#line 148 "../lib/sudoku-board.vala"
					col = 0;
#line 977 "sudoku-board.c"
					{
						gboolean _tmp69_ = FALSE;
#line 148 "../lib/sudoku-board.vala"
						_tmp69_ = TRUE;
#line 148 "../lib/sudoku-board.vala"
						while (TRUE) {
#line 984 "sudoku-board.c"
							gint _tmp71_;
							GeeList* _tmp72_;
							gpointer _tmp73_;
							GeeList* _tmp74_;
							Coord _tmp75_ = {0};
#line 148 "../lib/sudoku-board.vala"
							if (!_tmp69_) {
#line 992 "sudoku-board.c"
								gint _tmp70_;
#line 148 "../lib/sudoku-board.vala"
								_tmp70_ = col;
#line 148 "../lib/sudoku-board.vala"
								col = _tmp70_ + 1;
#line 998 "sudoku-board.c"
							}
#line 148 "../lib/sudoku-board.vala"
							_tmp69_ = FALSE;
#line 148 "../lib/sudoku-board.vala"
							_tmp71_ = self->priv->_cols;
#line 148 "../lib/sudoku-board.vala"
							if (!(col < _tmp71_)) {
#line 148 "../lib/sudoku-board.vala"
								break;
#line 1008 "sudoku-board.c"
							}
#line 149 "../lib/sudoku-board.vala"
							_tmp72_ = self->coords_for_row;
#line 149 "../lib/sudoku-board.vala"
							_tmp73_ = gee_list_get (_tmp72_, row);
#line 149 "../lib/sudoku-board.vala"
							_tmp74_ = (GeeList*) _tmp73_;
#line 149 "../lib/sudoku-board.vala"
							coord_init (&_tmp75_, row, col);
#line 149 "../lib/sudoku-board.vala"
							gee_collection_add ((GeeCollection*) _tmp74_, &_tmp75_);
#line 149 "../lib/sudoku-board.vala"
							_g_object_unref0 (_tmp74_);
#line 1022 "sudoku-board.c"
						}
					}
				}
#line 151 "../lib/sudoku-board.vala"
				_tmp76_ = self->coords_for_row;
#line 151 "../lib/sudoku-board.vala"
				_tmp77_ = self->coords_for_row;
#line 151 "../lib/sudoku-board.vala"
				_tmp78_ = gee_list_get (_tmp77_, row);
#line 151 "../lib/sudoku-board.vala"
				_tmp79_ = (GeeList*) _tmp78_;
#line 151 "../lib/sudoku-board.vala"
				_tmp80_ = gee_list_get_read_only_view (_tmp79_);
#line 151 "../lib/sudoku-board.vala"
				_tmp81_ = _tmp80_;
#line 151 "../lib/sudoku-board.vala"
				_tmp82_ = _tmp81_;
#line 151 "../lib/sudoku-board.vala"
				gee_list_set (_tmp76_, row, _tmp82_);
#line 151 "../lib/sudoku-board.vala"
				_g_object_unref0 (_tmp82_);
#line 151 "../lib/sudoku-board.vala"
				_g_object_unref0 (_tmp79_);
#line 1046 "sudoku-board.c"
			}
		}
	}
#line 153 "../lib/sudoku-board.vala"
	_tmp83_ = self->coords_for_row;
#line 153 "../lib/sudoku-board.vala"
	_tmp84_ = gee_list_get_read_only_view (_tmp83_);
#line 153 "../lib/sudoku-board.vala"
	_tmp85_ = _tmp84_;
#line 153 "../lib/sudoku-board.vala"
	_g_object_unref0 (self->coords_for_row);
#line 153 "../lib/sudoku-board.vala"
	self->coords_for_row = _tmp85_;
#line 155 "../lib/sudoku-board.vala"
	_tmp86_ = gee_hash_map_new (TYPE_COORD, (GBoxedCopyFunc) coord_dup, (GDestroyNotify) coord_free, GEE_TYPE_LIST, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, (GeeHashDataFunc) coord_hash, NULL, NULL, (GeeEqualDataFunc) coord_equal, NULL, NULL, NULL, NULL, NULL);
#line 155 "../lib/sudoku-board.vala"
	_g_object_unref0 (self->coords_for_block);
#line 155 "../lib/sudoku-board.vala"
	self->coords_for_block = (GeeMap*) _tmp86_;
#line 1066 "sudoku-board.c"
	{
		gint col = 0;
#line 156 "../lib/sudoku-board.vala"
		col = 0;
#line 1071 "sudoku-board.c"
		{
			gboolean _tmp87_ = FALSE;
#line 156 "../lib/sudoku-board.vala"
			_tmp87_ = TRUE;
#line 156 "../lib/sudoku-board.vala"
			while (TRUE) {
#line 156 "../lib/sudoku-board.vala"
				if (!_tmp87_) {
#line 1080 "sudoku-board.c"
					gint _tmp88_;
#line 156 "../lib/sudoku-board.vala"
					_tmp88_ = col;
#line 156 "../lib/sudoku-board.vala"
					col = _tmp88_ + 1;
#line 1086 "sudoku-board.c"
				}
#line 156 "../lib/sudoku-board.vala"
				_tmp87_ = FALSE;
#line 156 "../lib/sudoku-board.vala"
				if (!(col < block_cols)) {
#line 156 "../lib/sudoku-board.vala"
					break;
#line 1094 "sudoku-board.c"
				}
				{
					gint row = 0;
#line 157 "../lib/sudoku-board.vala"
					row = 0;
#line 1100 "sudoku-board.c"
					{
						gboolean _tmp89_ = FALSE;
#line 157 "../lib/sudoku-board.vala"
						_tmp89_ = TRUE;
#line 157 "../lib/sudoku-board.vala"
						while (TRUE) {
#line 1107 "sudoku-board.c"
							GeeMap* _tmp91_;
							Coord _tmp92_ = {0};
							GeeArrayList* _tmp93_;
							GeeArrayList* _tmp94_;
#line 157 "../lib/sudoku-board.vala"
							if (!_tmp89_) {
#line 1114 "sudoku-board.c"
								gint _tmp90_;
#line 157 "../lib/sudoku-board.vala"
								_tmp90_ = row;
#line 157 "../lib/sudoku-board.vala"
								row = _tmp90_ + 1;
#line 1120 "sudoku-board.c"
							}
#line 157 "../lib/sudoku-board.vala"
							_tmp89_ = FALSE;
#line 157 "../lib/sudoku-board.vala"
							if (!(row < block_rows)) {
#line 157 "../lib/sudoku-board.vala"
								break;
#line 1128 "sudoku-board.c"
							}
#line 158 "../lib/sudoku-board.vala"
							_tmp91_ = self->coords_for_block;
#line 158 "../lib/sudoku-board.vala"
							coord_init (&_tmp92_, row, col);
#line 158 "../lib/sudoku-board.vala"
							_tmp93_ = gee_array_list_new (TYPE_COORD, (GBoxedCopyFunc) coord_dup, (GDestroyNotify) coord_free, (GeeEqualDataFunc) coord_equal, NULL, NULL);
#line 158 "../lib/sudoku-board.vala"
							_tmp94_ = _tmp93_;
#line 158 "../lib/sudoku-board.vala"
							gee_map_set (_tmp91_, &_tmp92_, (GeeList*) _tmp94_);
#line 158 "../lib/sudoku-board.vala"
							_g_object_unref0 (_tmp94_);
#line 1142 "sudoku-board.c"
						}
					}
				}
			}
		}
	}
	{
		gint col = 0;
#line 160 "../lib/sudoku-board.vala"
		col = 0;
#line 1153 "sudoku-board.c"
		{
			gboolean _tmp95_ = FALSE;
#line 160 "../lib/sudoku-board.vala"
			_tmp95_ = TRUE;
#line 160 "../lib/sudoku-board.vala"
			while (TRUE) {
#line 1160 "sudoku-board.c"
				gint _tmp97_;
#line 160 "../lib/sudoku-board.vala"
				if (!_tmp95_) {
#line 1164 "sudoku-board.c"
					gint _tmp96_;
#line 160 "../lib/sudoku-board.vala"
					_tmp96_ = col;
#line 160 "../lib/sudoku-board.vala"
					col = _tmp96_ + 1;
#line 1170 "sudoku-board.c"
				}
#line 160 "../lib/sudoku-board.vala"
				_tmp95_ = FALSE;
#line 160 "../lib/sudoku-board.vala"
				_tmp97_ = self->priv->_cols;
#line 160 "../lib/sudoku-board.vala"
				if (!(col < _tmp97_)) {
#line 160 "../lib/sudoku-board.vala"
					break;
#line 1180 "sudoku-board.c"
				}
				{
					gint row = 0;
#line 161 "../lib/sudoku-board.vala"
					row = 0;
#line 1186 "sudoku-board.c"
					{
						gboolean _tmp98_ = FALSE;
#line 161 "../lib/sudoku-board.vala"
						_tmp98_ = TRUE;
#line 161 "../lib/sudoku-board.vala"
						while (TRUE) {
#line 1193 "sudoku-board.c"
							gint _tmp100_;
							GeeMap* _tmp101_;
							Coord _tmp102_ = {0};
							gpointer _tmp103_;
							GeeList* _tmp104_;
							Coord _tmp105_ = {0};
#line 161 "../lib/sudoku-board.vala"
							if (!_tmp98_) {
#line 1202 "sudoku-board.c"
								gint _tmp99_;
#line 161 "../lib/sudoku-board.vala"
								_tmp99_ = row;
#line 161 "../lib/sudoku-board.vala"
								row = _tmp99_ + 1;
#line 1208 "sudoku-board.c"
							}
#line 161 "../lib/sudoku-board.vala"
							_tmp98_ = FALSE;
#line 161 "../lib/sudoku-board.vala"
							_tmp100_ = self->priv->_rows;
#line 161 "../lib/sudoku-board.vala"
							if (!(row < _tmp100_)) {
#line 161 "../lib/sudoku-board.vala"
								break;
#line 1218 "sudoku-board.c"
							}
#line 162 "../lib/sudoku-board.vala"
							_tmp101_ = self->coords_for_block;
#line 162 "../lib/sudoku-board.vala"
							coord_init (&_tmp102_, row / block_rows, col / block_cols);
#line 162 "../lib/sudoku-board.vala"
							_tmp103_ = gee_map_get (_tmp101_, &_tmp102_);
#line 162 "../lib/sudoku-board.vala"
							_tmp104_ = (GeeList*) _tmp103_;
#line 162 "../lib/sudoku-board.vala"
							coord_init (&_tmp105_, row, col);
#line 162 "../lib/sudoku-board.vala"
							gee_collection_add ((GeeCollection*) _tmp104_, &_tmp105_);
#line 162 "../lib/sudoku-board.vala"
							_g_object_unref0 (_tmp104_);
#line 1234 "sudoku-board.c"
						}
					}
				}
			}
		}
	}
	{
		gint col = 0;
#line 164 "../lib/sudoku-board.vala"
		col = 0;
#line 1245 "sudoku-board.c"
		{
			gboolean _tmp106_ = FALSE;
#line 164 "../lib/sudoku-board.vala"
			_tmp106_ = TRUE;
#line 164 "../lib/sudoku-board.vala"
			while (TRUE) {
#line 164 "../lib/sudoku-board.vala"
				if (!_tmp106_) {
#line 1254 "sudoku-board.c"
					gint _tmp107_;
#line 164 "../lib/sudoku-board.vala"
					_tmp107_ = col;
#line 164 "../lib/sudoku-board.vala"
					col = _tmp107_ + 1;
#line 1260 "sudoku-board.c"
				}
#line 164 "../lib/sudoku-board.vala"
				_tmp106_ = FALSE;
#line 164 "../lib/sudoku-board.vala"
				if (!(col < block_cols)) {
#line 164 "../lib/sudoku-board.vala"
					break;
#line 1268 "sudoku-board.c"
				}
				{
					gint row = 0;
#line 165 "../lib/sudoku-board.vala"
					row = 0;
#line 1274 "sudoku-board.c"
					{
						gboolean _tmp108_ = FALSE;
#line 165 "../lib/sudoku-board.vala"
						_tmp108_ = TRUE;
#line 165 "../lib/sudoku-board.vala"
						while (TRUE) {
#line 1281 "sudoku-board.c"
							GeeMap* _tmp110_;
							Coord _tmp111_ = {0};
							GeeMap* _tmp112_;
							Coord _tmp113_ = {0};
							gpointer _tmp114_;
							GeeList* _tmp115_;
							GeeList* _tmp116_;
							GeeList* _tmp117_;
							GeeList* _tmp118_;
#line 165 "../lib/sudoku-board.vala"
							if (!_tmp108_) {
#line 1293 "sudoku-board.c"
								gint _tmp109_;
#line 165 "../lib/sudoku-board.vala"
								_tmp109_ = row;
#line 165 "../lib/sudoku-board.vala"
								row = _tmp109_ + 1;
#line 1299 "sudoku-board.c"
							}
#line 165 "../lib/sudoku-board.vala"
							_tmp108_ = FALSE;
#line 165 "../lib/sudoku-board.vala"
							if (!(row < block_rows)) {
#line 165 "../lib/sudoku-board.vala"
								break;
#line 1307 "sudoku-board.c"
							}
#line 166 "../lib/sudoku-board.vala"
							_tmp110_ = self->coords_for_block;
#line 166 "../lib/sudoku-board.vala"
							coord_init (&_tmp111_, row, col);
#line 166 "../lib/sudoku-board.vala"
							_tmp112_ = self->coords_for_block;
#line 166 "../lib/sudoku-board.vala"
							coord_init (&_tmp113_, row, col);
#line 166 "../lib/sudoku-board.vala"
							_tmp114_ = gee_map_get (_tmp112_, &_tmp113_);
#line 166 "../lib/sudoku-board.vala"
							_tmp115_ = (GeeList*) _tmp114_;
#line 166 "../lib/sudoku-board.vala"
							_tmp116_ = gee_list_get_read_only_view (_tmp115_);
#line 166 "../lib/sudoku-board.vala"
							_tmp117_ = _tmp116_;
#line 166 "../lib/sudoku-board.vala"
							_tmp118_ = _tmp117_;
#line 166 "../lib/sudoku-board.vala"
							gee_map_set (_tmp110_, &_tmp111_, _tmp118_);
#line 166 "../lib/sudoku-board.vala"
							_g_object_unref0 (_tmp118_);
#line 166 "../lib/sudoku-board.vala"
							_g_object_unref0 (_tmp115_);
#line 1333 "sudoku-board.c"
						}
					}
				}
			}
		}
	}
#line 168 "../lib/sudoku-board.vala"
	_tmp119_ = self->coords_for_block;
#line 168 "../lib/sudoku-board.vala"
	_tmp120_ = gee_map_get_read_only_view (_tmp119_);
#line 168 "../lib/sudoku-board.vala"
	_tmp121_ = _tmp120_;
#line 168 "../lib/sudoku-board.vala"
	_g_object_unref0 (self->coords_for_block);
#line 168 "../lib/sudoku-board.vala"
	self->coords_for_block = _tmp121_;
#line 104 "../lib/sudoku-board.vala"
	return self;
#line 1352 "sudoku-board.c"
}

SudokuBoard*
sudoku_board_new (gint block_rows,
                  gint block_cols)
{
#line 104 "../lib/sudoku-board.vala"
	return sudoku_board_construct (TYPE_SUDOKU_BOARD, block_rows, block_cols);
#line 1361 "sudoku-board.c"
}

static gint*
_vala_array_dup1 (gint* self,
                  int length)
{
#line 174 "../lib/sudoku-board.vala"
	return g_memdup (self, length * sizeof (gint));
#line 1370 "sudoku-board.c"
}

static gboolean*
_vala_array_dup2 (gboolean* self,
                  int length)
{
#line 175 "../lib/sudoku-board.vala"
	return g_memdup (self, length * sizeof (gboolean));
#line 1379 "sudoku-board.c"
}

static gboolean*
_vala_array_dup3 (gboolean* self,
                  int length)
{
#line 176 "../lib/sudoku-board.vala"
	return g_memdup (self, length * sizeof (gboolean));
#line 1388 "sudoku-board.c"
}

static gboolean*
_vala_array_dup4 (gboolean* self,
                  int length)
{
#line 177 "../lib/sudoku-board.vala"
	return g_memdup (self, length * sizeof (gboolean));
#line 1397 "sudoku-board.c"
}

static gboolean*
_vala_array_dup5 (gboolean* self,
                  int length)
{
#line 178 "../lib/sudoku-board.vala"
	return g_memdup (self, length * sizeof (gboolean));
#line 1406 "sudoku-board.c"
}

static gboolean*
_vala_array_dup6 (gboolean* self,
                  int length)
{
#line 183 "../lib/sudoku-board.vala"
	return g_memdup (self, length * sizeof (gboolean));
#line 1415 "sudoku-board.c"
}

SudokuBoard*
sudoku_board_clone (SudokuBoard* self)
{
	SudokuBoard* result = NULL;
	SudokuBoard* board = NULL;
	gint _tmp0_;
	gint _tmp1_;
	SudokuBoard* _tmp2_;
	gint* _tmp3_;
	gint _tmp3__length1;
	gint _tmp3__length2;
	gint* _tmp4_;
	gint _tmp4__length1;
	gint _tmp4__length2;
	gboolean* _tmp5_;
	gint _tmp5__length1;
	gint _tmp5__length2;
	gboolean* _tmp6_;
	gint _tmp6__length1;
	gint _tmp6__length2;
	gboolean* _tmp7_;
	gint _tmp7__length1;
	gint _tmp7__length2;
	gboolean* _tmp8_;
	gint _tmp8__length1;
	gint _tmp8__length2;
	gboolean* _tmp9_;
	gint _tmp9__length1;
	gint _tmp9__length2;
	gboolean* _tmp10_;
	gint _tmp10__length1;
	gint _tmp10__length2;
	gboolean* _tmp11_;
	gint _tmp11__length1;
	gint _tmp11__length2;
	gint _tmp11__length3;
	gboolean* _tmp12_;
	gint _tmp12__length1;
	gint _tmp12__length2;
	gint _tmp12__length3;
	gint _tmp13_;
	gint _tmp14_;
	GeeSet* _tmp15_;
	GeeSet* _tmp16_;
	gboolean* _tmp17_;
	gint _tmp17__length1;
	gint _tmp17__length2;
	gint _tmp17__length3;
	gboolean* _tmp18_;
	gint _tmp18__length1;
	gint _tmp18__length2;
	gint _tmp18__length3;
	DifficultyCategory _tmp19_;
#line 171 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 173 "../lib/sudoku-board.vala"
	_tmp0_ = self->priv->_block_rows;
#line 173 "../lib/sudoku-board.vala"
	_tmp1_ = self->priv->_block_cols;
#line 173 "../lib/sudoku-board.vala"
	_tmp2_ = sudoku_board_new (_tmp0_, _tmp1_);
#line 173 "../lib/sudoku-board.vala"
	board = _tmp2_;
#line 174 "../lib/sudoku-board.vala"
	_tmp3_ = self->cells;
#line 174 "../lib/sudoku-board.vala"
	_tmp3__length1 = self->cells_length1;
#line 174 "../lib/sudoku-board.vala"
	_tmp3__length2 = self->cells_length2;
#line 174 "../lib/sudoku-board.vala"
	_tmp4_ = (_tmp3_ != NULL) ? _vala_array_dup1 (_tmp3_, _tmp3__length1 * _tmp3__length2) : ((gpointer) _tmp3_);
#line 174 "../lib/sudoku-board.vala"
	_tmp4__length1 = _tmp3__length1;
#line 174 "../lib/sudoku-board.vala"
	_tmp4__length2 = _tmp3__length2;
#line 174 "../lib/sudoku-board.vala"
	board->cells = (g_free (board->cells), NULL);
#line 174 "../lib/sudoku-board.vala"
	board->cells = _tmp4_;
#line 174 "../lib/sudoku-board.vala"
	board->cells_length1 = _tmp4__length1;
#line 174 "../lib/sudoku-board.vala"
	board->cells_length2 = _tmp4__length2;
#line 175 "../lib/sudoku-board.vala"
	_tmp5_ = self->is_fixed;
#line 175 "../lib/sudoku-board.vala"
	_tmp5__length1 = self->is_fixed_length1;
#line 175 "../lib/sudoku-board.vala"
	_tmp5__length2 = self->is_fixed_length2;
#line 175 "../lib/sudoku-board.vala"
	_tmp6_ = (_tmp5_ != NULL) ? _vala_array_dup2 (_tmp5_, _tmp5__length1 * _tmp5__length2) : ((gpointer) _tmp5_);
#line 175 "../lib/sudoku-board.vala"
	_tmp6__length1 = _tmp5__length1;
#line 175 "../lib/sudoku-board.vala"
	_tmp6__length2 = _tmp5__length2;
#line 175 "../lib/sudoku-board.vala"
	board->is_fixed = (g_free (board->is_fixed), NULL);
#line 175 "../lib/sudoku-board.vala"
	board->is_fixed = _tmp6_;
#line 175 "../lib/sudoku-board.vala"
	board->is_fixed_length1 = _tmp6__length1;
#line 175 "../lib/sudoku-board.vala"
	board->is_fixed_length2 = _tmp6__length2;
#line 176 "../lib/sudoku-board.vala"
	_tmp7_ = self->priv->possible_in_row;
#line 176 "../lib/sudoku-board.vala"
	_tmp7__length1 = self->priv->possible_in_row_length1;
#line 176 "../lib/sudoku-board.vala"
	_tmp7__length2 = self->priv->possible_in_row_length2;
#line 176 "../lib/sudoku-board.vala"
	_tmp8_ = (_tmp7_ != NULL) ? _vala_array_dup3 (_tmp7_, _tmp7__length1 * _tmp7__length2) : ((gpointer) _tmp7_);
#line 176 "../lib/sudoku-board.vala"
	_tmp8__length1 = _tmp7__length1;
#line 176 "../lib/sudoku-board.vala"
	_tmp8__length2 = _tmp7__length2;
#line 176 "../lib/sudoku-board.vala"
	board->priv->possible_in_row = (g_free (board->priv->possible_in_row), NULL);
#line 176 "../lib/sudoku-board.vala"
	board->priv->possible_in_row = _tmp8_;
#line 176 "../lib/sudoku-board.vala"
	board->priv->possible_in_row_length1 = _tmp8__length1;
#line 176 "../lib/sudoku-board.vala"
	board->priv->possible_in_row_length2 = _tmp8__length2;
#line 177 "../lib/sudoku-board.vala"
	_tmp9_ = self->priv->possible_in_col;
#line 177 "../lib/sudoku-board.vala"
	_tmp9__length1 = self->priv->possible_in_col_length1;
#line 177 "../lib/sudoku-board.vala"
	_tmp9__length2 = self->priv->possible_in_col_length2;
#line 177 "../lib/sudoku-board.vala"
	_tmp10_ = (_tmp9_ != NULL) ? _vala_array_dup4 (_tmp9_, _tmp9__length1 * _tmp9__length2) : ((gpointer) _tmp9_);
#line 177 "../lib/sudoku-board.vala"
	_tmp10__length1 = _tmp9__length1;
#line 177 "../lib/sudoku-board.vala"
	_tmp10__length2 = _tmp9__length2;
#line 177 "../lib/sudoku-board.vala"
	board->priv->possible_in_col = (g_free (board->priv->possible_in_col), NULL);
#line 177 "../lib/sudoku-board.vala"
	board->priv->possible_in_col = _tmp10_;
#line 177 "../lib/sudoku-board.vala"
	board->priv->possible_in_col_length1 = _tmp10__length1;
#line 177 "../lib/sudoku-board.vala"
	board->priv->possible_in_col_length2 = _tmp10__length2;
#line 178 "../lib/sudoku-board.vala"
	_tmp11_ = self->priv->possible_in_block;
#line 178 "../lib/sudoku-board.vala"
	_tmp11__length1 = self->priv->possible_in_block_length1;
#line 178 "../lib/sudoku-board.vala"
	_tmp11__length2 = self->priv->possible_in_block_length2;
#line 178 "../lib/sudoku-board.vala"
	_tmp11__length3 = self->priv->possible_in_block_length3;
#line 178 "../lib/sudoku-board.vala"
	_tmp12_ = (_tmp11_ != NULL) ? _vala_array_dup5 (_tmp11_, (_tmp11__length1 * _tmp11__length2) * _tmp11__length3) : ((gpointer) _tmp11_);
#line 178 "../lib/sudoku-board.vala"
	_tmp12__length1 = _tmp11__length1;
#line 178 "../lib/sudoku-board.vala"
	_tmp12__length2 = _tmp11__length2;
#line 178 "../lib/sudoku-board.vala"
	_tmp12__length3 = _tmp11__length3;
#line 178 "../lib/sudoku-board.vala"
	board->priv->possible_in_block = (g_free (board->priv->possible_in_block), NULL);
#line 178 "../lib/sudoku-board.vala"
	board->priv->possible_in_block = _tmp12_;
#line 178 "../lib/sudoku-board.vala"
	board->priv->possible_in_block_length1 = _tmp12__length1;
#line 178 "../lib/sudoku-board.vala"
	board->priv->possible_in_block_length2 = _tmp12__length2;
#line 178 "../lib/sudoku-board.vala"
	board->priv->possible_in_block_length3 = _tmp12__length3;
#line 179 "../lib/sudoku-board.vala"
	_tmp13_ = self->priv->_filled;
#line 179 "../lib/sudoku-board.vala"
	sudoku_board_set_filled (board, _tmp13_);
#line 180 "../lib/sudoku-board.vala"
	_tmp14_ = self->priv->_fixed;
#line 180 "../lib/sudoku-board.vala"
	sudoku_board_set_fixed (board, _tmp14_);
#line 181 "../lib/sudoku-board.vala"
	board->priv->n_earmarks = self->priv->n_earmarks;
#line 182 "../lib/sudoku-board.vala"
	_tmp15_ = board->broken_coords;
#line 182 "../lib/sudoku-board.vala"
	_tmp16_ = self->broken_coords;
#line 182 "../lib/sudoku-board.vala"
	gee_collection_add_all ((GeeCollection*) _tmp15_, (GeeCollection*) _tmp16_);
#line 183 "../lib/sudoku-board.vala"
	_tmp17_ = self->priv->earmarks;
#line 183 "../lib/sudoku-board.vala"
	_tmp17__length1 = self->priv->earmarks_length1;
#line 183 "../lib/sudoku-board.vala"
	_tmp17__length2 = self->priv->earmarks_length2;
#line 183 "../lib/sudoku-board.vala"
	_tmp17__length3 = self->priv->earmarks_length3;
#line 183 "../lib/sudoku-board.vala"
	_tmp18_ = (_tmp17_ != NULL) ? _vala_array_dup6 (_tmp17_, (_tmp17__length1 * _tmp17__length2) * _tmp17__length3) : ((gpointer) _tmp17_);
#line 183 "../lib/sudoku-board.vala"
	_tmp18__length1 = _tmp17__length1;
#line 183 "../lib/sudoku-board.vala"
	_tmp18__length2 = _tmp17__length2;
#line 183 "../lib/sudoku-board.vala"
	_tmp18__length3 = _tmp17__length3;
#line 183 "../lib/sudoku-board.vala"
	board->priv->earmarks = (g_free (board->priv->earmarks), NULL);
#line 183 "../lib/sudoku-board.vala"
	board->priv->earmarks = _tmp18_;
#line 183 "../lib/sudoku-board.vala"
	board->priv->earmarks_length1 = _tmp18__length1;
#line 183 "../lib/sudoku-board.vala"
	board->priv->earmarks_length2 = _tmp18__length2;
#line 183 "../lib/sudoku-board.vala"
	board->priv->earmarks_length3 = _tmp18__length3;
#line 184 "../lib/sudoku-board.vala"
	_tmp19_ = self->priv->_difficulty_category;
#line 184 "../lib/sudoku-board.vala"
	sudoku_board_set_difficulty_category (board, _tmp19_);
#line 186 "../lib/sudoku-board.vala"
	result = board;
#line 186 "../lib/sudoku-board.vala"
	return result;
#line 1637 "sudoku-board.c"
}

void
sudoku_board_enable_earmark (SudokuBoard* self,
                             gint row,
                             gint column,
                             gint digit)
{
	gboolean* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	gint _tmp0__length3;
	gboolean _tmp1_;
#line 189 "../lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 192 "../lib/sudoku-board.vala"
	_tmp0_ = self->priv->earmarks;
#line 192 "../lib/sudoku-board.vala"
	_tmp0__length1 = self->priv->earmarks_length1;
#line 192 "../lib/sudoku-board.vala"
	_tmp0__length2 = self->priv->earmarks_length2;
#line 192 "../lib/sudoku-board.vala"
	_tmp0__length3 = self->priv->earmarks_length3;
#line 192 "../lib/sudoku-board.vala"
	_tmp1_ = _tmp0_[(((row * _tmp0__length2) + column) * _tmp0__length3) + (digit - 1)];
#line 192 "../lib/sudoku-board.vala"
	if (!_tmp1_) {
#line 1665 "sudoku-board.c"
		gboolean* _tmp2_;
		gint _tmp2__length1;
		gint _tmp2__length2;
		gint _tmp2__length3;
		gint _tmp3_;
#line 194 "../lib/sudoku-board.vala"
		_tmp2_ = self->priv->earmarks;
#line 194 "../lib/sudoku-board.vala"
		_tmp2__length1 = self->priv->earmarks_length1;
#line 194 "../lib/sudoku-board.vala"
		_tmp2__length2 = self->priv->earmarks_length2;
#line 194 "../lib/sudoku-board.vala"
		_tmp2__length3 = self->priv->earmarks_length3;
#line 194 "../lib/sudoku-board.vala"
		_tmp2_[(((row * _tmp2__length2) + column) * _tmp2__length3) + (digit - 1)] = TRUE;
#line 195 "../lib/sudoku-board.vala"
		_tmp3_ = self->priv->n_earmarks;
#line 195 "../lib/sudoku-board.vala"
		self->priv->n_earmarks = _tmp3_ + 1;
#line 1685 "sudoku-board.c"
	}
#line 189 "../lib/sudoku-board.vala"
	_vala_warn_if_fail (self->priv->n_earmarks > 0, "n_earmarks > 0");
#line 1689 "sudoku-board.c"
}

void
sudoku_board_disable_earmark (SudokuBoard* self,
                              gint row,
                              gint column,
                              gint digit)
{
	gboolean* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	gint _tmp0__length3;
	gboolean _tmp1_;
#line 199 "../lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 202 "../lib/sudoku-board.vala"
	_tmp0_ = self->priv->earmarks;
#line 202 "../lib/sudoku-board.vala"
	_tmp0__length1 = self->priv->earmarks_length1;
#line 202 "../lib/sudoku-board.vala"
	_tmp0__length2 = self->priv->earmarks_length2;
#line 202 "../lib/sudoku-board.vala"
	_tmp0__length3 = self->priv->earmarks_length3;
#line 202 "../lib/sudoku-board.vala"
	_tmp1_ = _tmp0_[(((row * _tmp0__length2) + column) * _tmp0__length3) + (digit - 1)];
#line 202 "../lib/sudoku-board.vala"
	if (_tmp1_) {
#line 1717 "sudoku-board.c"
		gboolean* _tmp2_;
		gint _tmp2__length1;
		gint _tmp2__length2;
		gint _tmp2__length3;
		gint _tmp3_;
#line 204 "../lib/sudoku-board.vala"
		_tmp2_ = self->priv->earmarks;
#line 204 "../lib/sudoku-board.vala"
		_tmp2__length1 = self->priv->earmarks_length1;
#line 204 "../lib/sudoku-board.vala"
		_tmp2__length2 = self->priv->earmarks_length2;
#line 204 "../lib/sudoku-board.vala"
		_tmp2__length3 = self->priv->earmarks_length3;
#line 204 "../lib/sudoku-board.vala"
		_tmp2_[(((row * _tmp2__length2) + column) * _tmp2__length3) + (digit - 1)] = FALSE;
#line 205 "../lib/sudoku-board.vala"
		_tmp3_ = self->priv->n_earmarks;
#line 205 "../lib/sudoku-board.vala"
		self->priv->n_earmarks = _tmp3_ - 1;
#line 1737 "sudoku-board.c"
	}
#line 199 "../lib/sudoku-board.vala"
	_vala_warn_if_fail (self->priv->n_earmarks >= 0, "n_earmarks >= 0");
#line 1741 "sudoku-board.c"
}

void
sudoku_board_disable_all_earmarks (SudokuBoard* self,
                                   gint row,
                                   gint column)
{
#line 209 "../lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 1751 "sudoku-board.c"
	{
		gint i = 0;
#line 212 "../lib/sudoku-board.vala"
		i = 1;
#line 1756 "sudoku-board.c"
		{
			gboolean _tmp0_ = FALSE;
#line 212 "../lib/sudoku-board.vala"
			_tmp0_ = TRUE;
#line 212 "../lib/sudoku-board.vala"
			while (TRUE) {
#line 1763 "sudoku-board.c"
				gint _tmp2_;
				gint _tmp3_;
				gboolean* _tmp4_;
				gint _tmp4__length1;
				gint _tmp4__length2;
				gint _tmp4__length3;
				gboolean _tmp5_;
#line 212 "../lib/sudoku-board.vala"
				if (!_tmp0_) {
#line 1773 "sudoku-board.c"
					gint _tmp1_;
#line 212 "../lib/sudoku-board.vala"
					_tmp1_ = i;
#line 212 "../lib/sudoku-board.vala"
					i = _tmp1_ + 1;
#line 1779 "sudoku-board.c"
				}
#line 212 "../lib/sudoku-board.vala"
				_tmp0_ = FALSE;
#line 212 "../lib/sudoku-board.vala"
				_tmp2_ = sudoku_board_get_max_val (self);
#line 212 "../lib/sudoku-board.vala"
				_tmp3_ = _tmp2_;
#line 212 "../lib/sudoku-board.vala"
				if (!(i <= _tmp3_)) {
#line 212 "../lib/sudoku-board.vala"
					break;
#line 1791 "sudoku-board.c"
				}
#line 213 "../lib/sudoku-board.vala"
				_tmp4_ = self->priv->earmarks;
#line 213 "../lib/sudoku-board.vala"
				_tmp4__length1 = self->priv->earmarks_length1;
#line 213 "../lib/sudoku-board.vala"
				_tmp4__length2 = self->priv->earmarks_length2;
#line 213 "../lib/sudoku-board.vala"
				_tmp4__length3 = self->priv->earmarks_length3;
#line 213 "../lib/sudoku-board.vala"
				_tmp5_ = _tmp4_[(((row * _tmp4__length2) + column) * _tmp4__length3) + (i - 1)];
#line 213 "../lib/sudoku-board.vala"
				if (_tmp5_) {
#line 214 "../lib/sudoku-board.vala"
					sudoku_board_disable_earmark (self, row, column, i);
#line 1807 "sudoku-board.c"
				}
			}
		}
	}
#line 209 "../lib/sudoku-board.vala"
	_vala_warn_if_fail (self->priv->n_earmarks >= 0, "n_earmarks >= 0");
#line 1814 "sudoku-board.c"
}

gboolean
sudoku_board_is_earmark_enabled (SudokuBoard* self,
                                 gint row,
                                 gint column,
                                 gint digit)
{
	gboolean result = FALSE;
	gboolean* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	gint _tmp0__length3;
	gboolean _tmp1_;
#line 217 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 219 "../lib/sudoku-board.vala"
	_tmp0_ = self->priv->earmarks;
#line 219 "../lib/sudoku-board.vala"
	_tmp0__length1 = self->priv->earmarks_length1;
#line 219 "../lib/sudoku-board.vala"
	_tmp0__length2 = self->priv->earmarks_length2;
#line 219 "../lib/sudoku-board.vala"
	_tmp0__length3 = self->priv->earmarks_length3;
#line 219 "../lib/sudoku-board.vala"
	_tmp1_ = _tmp0_[(((row * _tmp0__length2) + column) * _tmp0__length3) + (digit - 1)];
#line 219 "../lib/sudoku-board.vala"
	result = _tmp1_;
#line 219 "../lib/sudoku-board.vala"
	return result;
#line 1845 "sudoku-board.c"
}

gboolean
sudoku_board_is_possible (SudokuBoard* self,
                          gint row,
                          gint col,
                          gint val)
{
	gboolean result = FALSE;
	gint _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean* _tmp3_;
	gint _tmp3__length1;
	gint _tmp3__length2;
	gboolean _tmp4_;
#line 222 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 224 "../lib/sudoku-board.vala"
	_tmp0_ = val;
#line 224 "../lib/sudoku-board.vala"
	val = _tmp0_ - 1;
#line 225 "../lib/sudoku-board.vala"
	_tmp3_ = self->priv->possible_in_row;
#line 225 "../lib/sudoku-board.vala"
	_tmp3__length1 = self->priv->possible_in_row_length1;
#line 225 "../lib/sudoku-board.vala"
	_tmp3__length2 = self->priv->possible_in_row_length2;
#line 225 "../lib/sudoku-board.vala"
	_tmp4_ = _tmp3_[(row * _tmp3__length2) + val];
#line 225 "../lib/sudoku-board.vala"
	if (_tmp4_) {
#line 1878 "sudoku-board.c"
		gboolean* _tmp5_;
		gint _tmp5__length1;
		gint _tmp5__length2;
		gboolean _tmp6_;
#line 225 "../lib/sudoku-board.vala"
		_tmp5_ = self->priv->possible_in_col;
#line 225 "../lib/sudoku-board.vala"
		_tmp5__length1 = self->priv->possible_in_col_length1;
#line 225 "../lib/sudoku-board.vala"
		_tmp5__length2 = self->priv->possible_in_col_length2;
#line 225 "../lib/sudoku-board.vala"
		_tmp6_ = _tmp5_[(col * _tmp5__length2) + val];
#line 225 "../lib/sudoku-board.vala"
		_tmp2_ = _tmp6_;
#line 1893 "sudoku-board.c"
	} else {
#line 225 "../lib/sudoku-board.vala"
		_tmp2_ = FALSE;
#line 1897 "sudoku-board.c"
	}
#line 225 "../lib/sudoku-board.vala"
	if (_tmp2_) {
#line 1901 "sudoku-board.c"
		gboolean* _tmp7_;
		gint _tmp7__length1;
		gint _tmp7__length2;
		gint _tmp7__length3;
		gint _tmp8_;
		gint _tmp9_;
		gboolean _tmp10_;
#line 225 "../lib/sudoku-board.vala"
		_tmp7_ = self->priv->possible_in_block;
#line 225 "../lib/sudoku-board.vala"
		_tmp7__length1 = self->priv->possible_in_block_length1;
#line 225 "../lib/sudoku-board.vala"
		_tmp7__length2 = self->priv->possible_in_block_length2;
#line 225 "../lib/sudoku-board.vala"
		_tmp7__length3 = self->priv->possible_in_block_length3;
#line 225 "../lib/sudoku-board.vala"
		_tmp8_ = self->priv->_block_cols;
#line 225 "../lib/sudoku-board.vala"
		_tmp9_ = self->priv->_block_rows;
#line 225 "../lib/sudoku-board.vala"
		_tmp10_ = _tmp7_[((((row / _tmp8_) * _tmp7__length2) + (col / _tmp9_)) * _tmp7__length3) + val];
#line 225 "../lib/sudoku-board.vala"
		_tmp1_ = _tmp10_;
#line 1925 "sudoku-board.c"
	} else {
#line 225 "../lib/sudoku-board.vala"
		_tmp1_ = FALSE;
#line 1929 "sudoku-board.c"
	}
#line 225 "../lib/sudoku-board.vala"
	result = _tmp1_;
#line 225 "../lib/sudoku-board.vala"
	return result;
#line 1935 "sudoku-board.c"
}

gint
sudoku_board_count_possibilities (SudokuBoard* self,
                                  gint row,
                                  gint col)
{
	gint result = 0;
	gint _tmp0_ = 0;
	gint* _tmp1_;
	gint* _tmp2_;
	gint _tmp2__length1;
	gint _tmp3_;
#line 228 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 230 "../lib/sudoku-board.vala"
	_tmp1_ = sudoku_board_get_possibilities (self, row, col, &_tmp0_);
#line 230 "../lib/sudoku-board.vala"
	_tmp2_ = _tmp1_;
#line 230 "../lib/sudoku-board.vala"
	_tmp2__length1 = _tmp0_;
#line 230 "../lib/sudoku-board.vala"
	_tmp3_ = _tmp0_;
#line 230 "../lib/sudoku-board.vala"
	_tmp2_ = (g_free (_tmp2_), NULL);
#line 230 "../lib/sudoku-board.vala"
	result = _tmp3_;
#line 230 "../lib/sudoku-board.vala"
	return result;
#line 1965 "sudoku-board.c"
}

static gint*
_vala_array_dup7 (gint* self,
                  int length)
{
#line 249 "../lib/sudoku-board.vala"
	return g_memdup (self, length * sizeof (gint));
#line 1974 "sudoku-board.c"
}

gint*
sudoku_board_get_possibilities (SudokuBoard* self,
                                gint row,
                                gint col,
                                gint* result_length1)
{
	gint* result = NULL;
	gint* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	gint _tmp1_;
	gint* possibilities = NULL;
	gint* _tmp4_;
	gint possibilities_length1;
	gint _possibilities_size_;
	gint count = 0;
	gint* _tmp11_;
	gint _tmp11__length1;
	gint* _tmp12_;
	gint _tmp12__length1;
	gint* _tmp13_;
	gint _tmp13__length1;
#line 233 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 235 "../lib/sudoku-board.vala"
	_tmp0_ = self->cells;
#line 235 "../lib/sudoku-board.vala"
	_tmp0__length1 = self->cells_length1;
#line 235 "../lib/sudoku-board.vala"
	_tmp0__length2 = self->cells_length2;
#line 235 "../lib/sudoku-board.vala"
	_tmp1_ = _tmp0_[(row * _tmp0__length2) + col];
#line 235 "../lib/sudoku-board.vala"
	if (_tmp1_ != 0) {
#line 2011 "sudoku-board.c"
		gint* _tmp2_;
		gint* _tmp3_;
		gint _tmp3__length1;
#line 236 "../lib/sudoku-board.vala"
		_tmp2_ = g_new0 (gint, 0);
#line 236 "../lib/sudoku-board.vala"
		_tmp3_ = _tmp2_;
#line 236 "../lib/sudoku-board.vala"
		_tmp3__length1 = 0;
#line 236 "../lib/sudoku-board.vala"
		if (result_length1) {
#line 236 "../lib/sudoku-board.vala"
			*result_length1 = _tmp3__length1;
#line 2025 "sudoku-board.c"
		}
#line 236 "../lib/sudoku-board.vala"
		result = _tmp3_;
#line 236 "../lib/sudoku-board.vala"
		return result;
#line 2031 "sudoku-board.c"
	}
#line 238 "../lib/sudoku-board.vala"
	_tmp4_ = g_new0 (gint, 9);
#line 238 "../lib/sudoku-board.vala"
	possibilities = _tmp4_;
#line 238 "../lib/sudoku-board.vala"
	possibilities_length1 = 9;
#line 238 "../lib/sudoku-board.vala"
	_possibilities_size_ = possibilities_length1;
#line 239 "../lib/sudoku-board.vala"
	count = 0;
#line 2043 "sudoku-board.c"
	{
		gint l = 0;
#line 241 "../lib/sudoku-board.vala"
		l = 1;
#line 2048 "sudoku-board.c"
		{
			gboolean _tmp5_ = FALSE;
#line 241 "../lib/sudoku-board.vala"
			_tmp5_ = TRUE;
#line 241 "../lib/sudoku-board.vala"
			while (TRUE) {
#line 2055 "sudoku-board.c"
				gint _tmp7_;
				gint _tmp8_;
#line 241 "../lib/sudoku-board.vala"
				if (!_tmp5_) {
#line 2060 "sudoku-board.c"
					gint _tmp6_;
#line 241 "../lib/sudoku-board.vala"
					_tmp6_ = l;
#line 241 "../lib/sudoku-board.vala"
					l = _tmp6_ + 1;
#line 2066 "sudoku-board.c"
				}
#line 241 "../lib/sudoku-board.vala"
				_tmp5_ = FALSE;
#line 241 "../lib/sudoku-board.vala"
				_tmp7_ = sudoku_board_get_max_val (self);
#line 241 "../lib/sudoku-board.vala"
				_tmp8_ = _tmp7_;
#line 241 "../lib/sudoku-board.vala"
				if (!(l <= _tmp8_)) {
#line 241 "../lib/sudoku-board.vala"
					break;
#line 2078 "sudoku-board.c"
				}
#line 243 "../lib/sudoku-board.vala"
				if (sudoku_board_is_possible (self, row, col, l)) {
#line 2082 "sudoku-board.c"
					gint* _tmp9_;
					gint _tmp9__length1;
					gint _tmp10_;
#line 245 "../lib/sudoku-board.vala"
					_tmp9_ = possibilities;
#line 245 "../lib/sudoku-board.vala"
					_tmp9__length1 = possibilities_length1;
#line 245 "../lib/sudoku-board.vala"
					_tmp9_[count] = l;
#line 246 "../lib/sudoku-board.vala"
					_tmp10_ = count;
#line 246 "../lib/sudoku-board.vala"
					count = _tmp10_ + 1;
#line 2096 "sudoku-board.c"
				}
			}
		}
	}
#line 249 "../lib/sudoku-board.vala"
	_tmp11_ = possibilities;
#line 249 "../lib/sudoku-board.vala"
	_tmp11__length1 = possibilities_length1;
#line 249 "../lib/sudoku-board.vala"
	_tmp12_ = ((_tmp11_ + 0) != NULL) ? _vala_array_dup7 (_tmp11_ + 0, count - 0) : ((gpointer) (_tmp11_ + 0));
#line 249 "../lib/sudoku-board.vala"
	_tmp12__length1 = count - 0;
#line 249 "../lib/sudoku-board.vala"
	_tmp13_ = _tmp12_;
#line 249 "../lib/sudoku-board.vala"
	_tmp13__length1 = _tmp12__length1;
#line 249 "../lib/sudoku-board.vala"
	if (result_length1) {
#line 249 "../lib/sudoku-board.vala"
		*result_length1 = _tmp13__length1;
#line 2117 "sudoku-board.c"
	}
#line 249 "../lib/sudoku-board.vala"
	result = _tmp13_;
#line 249 "../lib/sudoku-board.vala"
	possibilities = (g_free (possibilities), NULL);
#line 249 "../lib/sudoku-board.vala"
	return result;
#line 2125 "sudoku-board.c"
}

gboolean*
sudoku_board_get_possibilities_as_bool_array (SudokuBoard* self,
                                              gint row,
                                              gint col,
                                              gint* result_length1)
{
	gboolean* result = NULL;
	gboolean* possibilities = NULL;
	gint _tmp0_;
	gint _tmp1_;
	gboolean* _tmp2_;
	gint possibilities_length1;
	gint _possibilities_size_;
	gboolean* _tmp8_;
	gint _tmp8__length1;
#line 252 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 254 "../lib/sudoku-board.vala"
	_tmp0_ = sudoku_board_get_max_val (self);
#line 254 "../lib/sudoku-board.vala"
	_tmp1_ = _tmp0_;
#line 254 "../lib/sudoku-board.vala"
	_tmp2_ = g_new0 (gboolean, _tmp1_);
#line 254 "../lib/sudoku-board.vala"
	possibilities = _tmp2_;
#line 254 "../lib/sudoku-board.vala"
	possibilities_length1 = _tmp1_;
#line 254 "../lib/sudoku-board.vala"
	_possibilities_size_ = possibilities_length1;
#line 2157 "sudoku-board.c"
	{
		gint l = 0;
#line 256 "../lib/sudoku-board.vala"
		l = 1;
#line 2162 "sudoku-board.c"
		{
			gboolean _tmp3_ = FALSE;
#line 256 "../lib/sudoku-board.vala"
			_tmp3_ = TRUE;
#line 256 "../lib/sudoku-board.vala"
			while (TRUE) {
#line 2169 "sudoku-board.c"
				gint _tmp5_;
				gint _tmp6_;
				gboolean* _tmp7_;
				gint _tmp7__length1;
#line 256 "../lib/sudoku-board.vala"
				if (!_tmp3_) {
#line 2176 "sudoku-board.c"
					gint _tmp4_;
#line 256 "../lib/sudoku-board.vala"
					_tmp4_ = l;
#line 256 "../lib/sudoku-board.vala"
					l = _tmp4_ + 1;
#line 2182 "sudoku-board.c"
				}
#line 256 "../lib/sudoku-board.vala"
				_tmp3_ = FALSE;
#line 256 "../lib/sudoku-board.vala"
				_tmp5_ = sudoku_board_get_max_val (self);
#line 256 "../lib/sudoku-board.vala"
				_tmp6_ = _tmp5_;
#line 256 "../lib/sudoku-board.vala"
				if (!(l <= _tmp6_)) {
#line 256 "../lib/sudoku-board.vala"
					break;
#line 2194 "sudoku-board.c"
				}
#line 257 "../lib/sudoku-board.vala"
				_tmp7_ = possibilities;
#line 257 "../lib/sudoku-board.vala"
				_tmp7__length1 = possibilities_length1;
#line 257 "../lib/sudoku-board.vala"
				_tmp7_[l - 1] = sudoku_board_is_possible (self, row, col, l);
#line 2202 "sudoku-board.c"
			}
		}
	}
#line 259 "../lib/sudoku-board.vala"
	_tmp8_ = possibilities;
#line 259 "../lib/sudoku-board.vala"
	_tmp8__length1 = possibilities_length1;
#line 259 "../lib/sudoku-board.vala"
	if (result_length1) {
#line 259 "../lib/sudoku-board.vala"
		*result_length1 = _tmp8__length1;
#line 2214 "sudoku-board.c"
	}
#line 259 "../lib/sudoku-board.vala"
	result = _tmp8_;
#line 259 "../lib/sudoku-board.vala"
	return result;
#line 2220 "sudoku-board.c"
}

void
sudoku_board_get_block_for (SudokuBoard* self,
                            gint row,
                            gint col,
                            Coord* result)
{
	gint _tmp0_;
	gint _tmp1_;
	Coord _tmp2_ = {0};
#line 262 "../lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 264 "../lib/sudoku-board.vala"
	_tmp0_ = self->priv->_block_rows;
#line 264 "../lib/sudoku-board.vala"
	_tmp1_ = self->priv->_block_cols;
#line 264 "../lib/sudoku-board.vala"
	coord_init (&_tmp2_, row / _tmp0_, col / _tmp1_);
#line 264 "../lib/sudoku-board.vala"
	*result = _tmp2_;
#line 264 "../lib/sudoku-board.vala"
	return;
#line 2244 "sudoku-board.c"
}

void
sudoku_board_insert (SudokuBoard* self,
                     gint row,
                     gint col,
                     gint val,
                     gboolean is_fixed)
{
	gint _tmp0_;
	gint _tmp1_;
	gint* _tmp4_;
	gint _tmp4__length1;
	gint _tmp4__length2;
	gint _tmp5_;
	gint* _tmp6_;
	gint _tmp6__length1;
	gint _tmp6__length2;
	gboolean* _tmp7_;
	gint _tmp7__length1;
	gint _tmp7__length2;
	gint _tmp8_;
	gboolean* _tmp10_;
	gint _tmp10__length1;
	gint _tmp10__length2;
	gboolean _tmp11_;
	gboolean* _tmp15_;
	gint _tmp15__length1;
	gint _tmp15__length2;
	gboolean _tmp16_;
	gboolean* _tmp20_;
	gint _tmp20__length1;
	gint _tmp20__length2;
	gint _tmp20__length3;
	gint _tmp21_;
	gint _tmp22_;
	gboolean _tmp23_;
	gint _tmp30_;
	gboolean* _tmp31_;
	gint _tmp31__length1;
	gint _tmp31__length2;
	gboolean* _tmp32_;
	gint _tmp32__length1;
	gint _tmp32__length2;
	gboolean* _tmp33_;
	gint _tmp33__length1;
	gint _tmp33__length2;
	gint _tmp33__length3;
	gint _tmp34_;
	gint _tmp35_;
	gboolean _tmp36_;
	gboolean _tmp37_;
#line 267 "../lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 270 "../lib/sudoku-board.vala"
	_vala_assert (val > 0, "val > 0");
#line 271 "../lib/sudoku-board.vala"
	_tmp0_ = sudoku_board_get_max_val (self);
#line 271 "../lib/sudoku-board.vala"
	_tmp1_ = _tmp0_;
#line 271 "../lib/sudoku-board.vala"
	_vala_assert (val <= _tmp1_, "val <= max_val");
#line 274 "../lib/sudoku-board.vala"
	if (!is_fixed) {
#line 2309 "sudoku-board.c"
		gboolean* _tmp2_;
		gint _tmp2__length1;
		gint _tmp2__length2;
		gboolean _tmp3_;
#line 275 "../lib/sudoku-board.vala"
		_tmp2_ = self->is_fixed;
#line 275 "../lib/sudoku-board.vala"
		_tmp2__length1 = self->is_fixed_length1;
#line 275 "../lib/sudoku-board.vala"
		_tmp2__length2 = self->is_fixed_length2;
#line 275 "../lib/sudoku-board.vala"
		_tmp3_ = _tmp2_[(row * _tmp2__length2) + col];
#line 275 "../lib/sudoku-board.vala"
		_vala_assert (!_tmp3_, "!this.is_fixed[row, col]");
#line 2324 "sudoku-board.c"
	}
#line 278 "../lib/sudoku-board.vala"
	_tmp4_ = self->cells;
#line 278 "../lib/sudoku-board.vala"
	_tmp4__length1 = self->cells_length1;
#line 278 "../lib/sudoku-board.vala"
	_tmp4__length2 = self->cells_length2;
#line 278 "../lib/sudoku-board.vala"
	_tmp5_ = _tmp4_[(row * _tmp4__length2) + col];
#line 278 "../lib/sudoku-board.vala"
	if (_tmp5_ != 0) {
#line 279 "../lib/sudoku-board.vala"
		sudoku_board_remove (self, row, col, is_fixed);
#line 2338 "sudoku-board.c"
	}
#line 281 "../lib/sudoku-board.vala"
	_tmp6_ = self->cells;
#line 281 "../lib/sudoku-board.vala"
	_tmp6__length1 = self->cells_length1;
#line 281 "../lib/sudoku-board.vala"
	_tmp6__length2 = self->cells_length2;
#line 281 "../lib/sudoku-board.vala"
	_tmp6_[(row * _tmp6__length2) + col] = val;
#line 282 "../lib/sudoku-board.vala"
	_tmp7_ = self->is_fixed;
#line 282 "../lib/sudoku-board.vala"
	_tmp7__length1 = self->is_fixed_length1;
#line 282 "../lib/sudoku-board.vala"
	_tmp7__length2 = self->is_fixed_length2;
#line 282 "../lib/sudoku-board.vala"
	_tmp7_[(row * _tmp7__length2) + col] = is_fixed;
#line 283 "../lib/sudoku-board.vala"
	_tmp8_ = self->priv->_filled;
#line 283 "../lib/sudoku-board.vala"
	sudoku_board_set_filled (self, _tmp8_ + 1);
#line 284 "../lib/sudoku-board.vala"
	if (is_fixed) {
#line 2362 "sudoku-board.c"
		gint _tmp9_;
#line 285 "../lib/sudoku-board.vala"
		_tmp9_ = self->priv->_fixed;
#line 285 "../lib/sudoku-board.vala"
		sudoku_board_set_fixed (self, _tmp9_ + 1);
#line 2368 "sudoku-board.c"
	}
#line 287 "../lib/sudoku-board.vala"
	_tmp10_ = self->priv->possible_in_row;
#line 287 "../lib/sudoku-board.vala"
	_tmp10__length1 = self->priv->possible_in_row_length1;
#line 287 "../lib/sudoku-board.vala"
	_tmp10__length2 = self->priv->possible_in_row_length2;
#line 287 "../lib/sudoku-board.vala"
	_tmp11_ = _tmp10_[(row * _tmp10__length2) + (val - 1)];
#line 287 "../lib/sudoku-board.vala"
	if (!_tmp11_) {
#line 2380 "sudoku-board.c"
		GeeList* _tmp12_;
		gpointer _tmp13_;
		GeeList* _tmp14_;
#line 288 "../lib/sudoku-board.vala"
		_tmp12_ = self->coords_for_row;
#line 288 "../lib/sudoku-board.vala"
		_tmp13_ = gee_list_get (_tmp12_, row);
#line 288 "../lib/sudoku-board.vala"
		_tmp14_ = (GeeList*) _tmp13_;
#line 288 "../lib/sudoku-board.vala"
		sudoku_board_mark_breakages_for (self, _tmp14_, val);
#line 288 "../lib/sudoku-board.vala"
		_g_object_unref0 (_tmp14_);
#line 2394 "sudoku-board.c"
	}
#line 290 "../lib/sudoku-board.vala"
	_tmp15_ = self->priv->possible_in_col;
#line 290 "../lib/sudoku-board.vala"
	_tmp15__length1 = self->priv->possible_in_col_length1;
#line 290 "../lib/sudoku-board.vala"
	_tmp15__length2 = self->priv->possible_in_col_length2;
#line 290 "../lib/sudoku-board.vala"
	_tmp16_ = _tmp15_[(col * _tmp15__length2) + (val - 1)];
#line 290 "../lib/sudoku-board.vala"
	if (!_tmp16_) {
#line 2406 "sudoku-board.c"
		GeeList* _tmp17_;
		gpointer _tmp18_;
		GeeList* _tmp19_;
#line 291 "../lib/sudoku-board.vala"
		_tmp17_ = self->coords_for_col;
#line 291 "../lib/sudoku-board.vala"
		_tmp18_ = gee_list_get (_tmp17_, col);
#line 291 "../lib/sudoku-board.vala"
		_tmp19_ = (GeeList*) _tmp18_;
#line 291 "../lib/sudoku-board.vala"
		sudoku_board_mark_breakages_for (self, _tmp19_, val);
#line 291 "../lib/sudoku-board.vala"
		_g_object_unref0 (_tmp19_);
#line 2420 "sudoku-board.c"
	}
#line 293 "../lib/sudoku-board.vala"
	_tmp20_ = self->priv->possible_in_block;
#line 293 "../lib/sudoku-board.vala"
	_tmp20__length1 = self->priv->possible_in_block_length1;
#line 293 "../lib/sudoku-board.vala"
	_tmp20__length2 = self->priv->possible_in_block_length2;
#line 293 "../lib/sudoku-board.vala"
	_tmp20__length3 = self->priv->possible_in_block_length3;
#line 293 "../lib/sudoku-board.vala"
	_tmp21_ = self->priv->_block_cols;
#line 293 "../lib/sudoku-board.vala"
	_tmp22_ = self->priv->_block_rows;
#line 293 "../lib/sudoku-board.vala"
	_tmp23_ = _tmp20_[((((row / _tmp21_) * _tmp20__length2) + (col / _tmp22_)) * _tmp20__length3) + (val - 1)];
#line 293 "../lib/sudoku-board.vala"
	if (!_tmp23_) {
#line 2438 "sudoku-board.c"
		GeeMap* _tmp24_;
		gint _tmp25_;
		gint _tmp26_;
		Coord _tmp27_ = {0};
		gpointer _tmp28_;
		GeeList* _tmp29_;
#line 294 "../lib/sudoku-board.vala"
		_tmp24_ = self->coords_for_block;
#line 294 "../lib/sudoku-board.vala"
		_tmp25_ = self->priv->_block_cols;
#line 294 "../lib/sudoku-board.vala"
		_tmp26_ = self->priv->_block_rows;
#line 294 "../lib/sudoku-board.vala"
		coord_init (&_tmp27_, row / _tmp25_, col / _tmp26_);
#line 294 "../lib/sudoku-board.vala"
		_tmp28_ = gee_map_get (_tmp24_, &_tmp27_);
#line 294 "../lib/sudoku-board.vala"
		_tmp29_ = (GeeList*) _tmp28_;
#line 294 "../lib/sudoku-board.vala"
		sudoku_board_mark_breakages_for (self, _tmp29_, val);
#line 294 "../lib/sudoku-board.vala"
		_g_object_unref0 (_tmp29_);
#line 2461 "sudoku-board.c"
	}
#line 297 "../lib/sudoku-board.vala"
	_tmp30_ = val;
#line 297 "../lib/sudoku-board.vala"
	val = _tmp30_ - 1;
#line 298 "../lib/sudoku-board.vala"
	_tmp31_ = self->priv->possible_in_row;
#line 298 "../lib/sudoku-board.vala"
	_tmp31__length1 = self->priv->possible_in_row_length1;
#line 298 "../lib/sudoku-board.vala"
	_tmp31__length2 = self->priv->possible_in_row_length2;
#line 298 "../lib/sudoku-board.vala"
	_tmp31_[(row * _tmp31__length2) + val] = FALSE;
#line 299 "../lib/sudoku-board.vala"
	_tmp32_ = self->priv->possible_in_col;
#line 299 "../lib/sudoku-board.vala"
	_tmp32__length1 = self->priv->possible_in_col_length1;
#line 299 "../lib/sudoku-board.vala"
	_tmp32__length2 = self->priv->possible_in_col_length2;
#line 299 "../lib/sudoku-board.vala"
	_tmp32_[(col * _tmp32__length2) + val] = FALSE;
#line 300 "../lib/sudoku-board.vala"
	_tmp33_ = self->priv->possible_in_block;
#line 300 "../lib/sudoku-board.vala"
	_tmp33__length1 = self->priv->possible_in_block_length1;
#line 300 "../lib/sudoku-board.vala"
	_tmp33__length2 = self->priv->possible_in_block_length2;
#line 300 "../lib/sudoku-board.vala"
	_tmp33__length3 = self->priv->possible_in_block_length3;
#line 300 "../lib/sudoku-board.vala"
	_tmp34_ = self->priv->_block_cols;
#line 300 "../lib/sudoku-board.vala"
	_tmp35_ = self->priv->_block_rows;
#line 300 "../lib/sudoku-board.vala"
	_tmp33_[((((row / _tmp34_) * _tmp33__length2) + (col / _tmp35_)) * _tmp33__length3) + val] = FALSE;
#line 302 "../lib/sudoku-board.vala"
	_tmp36_ = sudoku_board_get_complete (self);
#line 302 "../lib/sudoku-board.vala"
	_tmp37_ = _tmp36_;
#line 302 "../lib/sudoku-board.vala"
	if (_tmp37_) {
#line 303 "../lib/sudoku-board.vala"
		g_signal_emit (self, sudoku_board_signals[SUDOKU_BOARD_COMPLETED_SIGNAL], 0);
#line 2505 "sudoku-board.c"
	}
}

void
sudoku_board_set (SudokuBoard* self,
                  gint row,
                  gint col,
                  gint val)
{
#line 306 "../lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 308 "../lib/sudoku-board.vala"
	if (val == 0) {
#line 309 "../lib/sudoku-board.vala"
		sudoku_board_remove (self, row, col, FALSE);
#line 2521 "sudoku-board.c"
	} else {
		gboolean _tmp0_ = FALSE;
#line 310 "../lib/sudoku-board.vala"
		if (val > 0) {
#line 2526 "sudoku-board.c"
			gint _tmp1_;
			gint _tmp2_;
#line 310 "../lib/sudoku-board.vala"
			_tmp1_ = sudoku_board_get_max_val (self);
#line 310 "../lib/sudoku-board.vala"
			_tmp2_ = _tmp1_;
#line 310 "../lib/sudoku-board.vala"
			_tmp0_ = val <= _tmp2_;
#line 2535 "sudoku-board.c"
		} else {
#line 310 "../lib/sudoku-board.vala"
			_tmp0_ = FALSE;
#line 2539 "sudoku-board.c"
		}
#line 310 "../lib/sudoku-board.vala"
		if (_tmp0_) {
#line 311 "../lib/sudoku-board.vala"
			sudoku_board_insert (self, row, col, val, FALSE);
#line 2545 "sudoku-board.c"
		} else {
#line 313 "../lib/sudoku-board.vala"
			g_assert_not_reached ();
#line 2549 "sudoku-board.c"
		}
	}
}

gint
sudoku_board_get (SudokuBoard* self,
                  gint row,
                  gint col)
{
	gint result = 0;
	gint* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	gint _tmp1_;
#line 316 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 318 "../lib/sudoku-board.vala"
	_tmp0_ = self->cells;
#line 318 "../lib/sudoku-board.vala"
	_tmp0__length1 = self->cells_length1;
#line 318 "../lib/sudoku-board.vala"
	_tmp0__length2 = self->cells_length2;
#line 318 "../lib/sudoku-board.vala"
	_tmp1_ = _tmp0_[(row * _tmp0__length2) + col];
#line 318 "../lib/sudoku-board.vala"
	result = _tmp1_;
#line 318 "../lib/sudoku-board.vala"
	return result;
#line 2578 "sudoku-board.c"
}

void
sudoku_board_remove (SudokuBoard* self,
                     gint row,
                     gint col,
                     gboolean is_fixed)
{
	gint* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	gint _tmp1_;
	gint previous_val = 0;
	gint* _tmp4_;
	gint _tmp4__length1;
	gint _tmp4__length2;
	gint _tmp5_;
	gint* _tmp6_;
	gint _tmp6__length1;
	gint _tmp6__length2;
	GeeSet* _tmp7_;
	Coord _tmp8_ = {0};
	gint _tmp70_;
#line 321 "../lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 324 "../lib/sudoku-board.vala"
	_tmp0_ = self->cells;
#line 324 "../lib/sudoku-board.vala"
	_tmp0__length1 = self->cells_length1;
#line 324 "../lib/sudoku-board.vala"
	_tmp0__length2 = self->cells_length2;
#line 324 "../lib/sudoku-board.vala"
	_tmp1_ = _tmp0_[(row * _tmp0__length2) + col];
#line 324 "../lib/sudoku-board.vala"
	if (_tmp1_ == 0) {
#line 325 "../lib/sudoku-board.vala"
		return;
#line 2616 "sudoku-board.c"
	}
#line 328 "../lib/sudoku-board.vala"
	if (!is_fixed) {
#line 2620 "sudoku-board.c"
		gboolean* _tmp2_;
		gint _tmp2__length1;
		gint _tmp2__length2;
		gboolean _tmp3_;
#line 329 "../lib/sudoku-board.vala"
		_tmp2_ = self->is_fixed;
#line 329 "../lib/sudoku-board.vala"
		_tmp2__length1 = self->is_fixed_length1;
#line 329 "../lib/sudoku-board.vala"
		_tmp2__length2 = self->is_fixed_length2;
#line 329 "../lib/sudoku-board.vala"
		_tmp3_ = _tmp2_[(row * _tmp2__length2) + col];
#line 329 "../lib/sudoku-board.vala"
		_vala_assert (!_tmp3_, "!this.is_fixed[row, col]");
#line 2635 "sudoku-board.c"
	}
#line 331 "../lib/sudoku-board.vala"
	_tmp4_ = self->cells;
#line 331 "../lib/sudoku-board.vala"
	_tmp4__length1 = self->cells_length1;
#line 331 "../lib/sudoku-board.vala"
	_tmp4__length2 = self->cells_length2;
#line 331 "../lib/sudoku-board.vala"
	_tmp5_ = _tmp4_[(row * _tmp4__length2) + col];
#line 331 "../lib/sudoku-board.vala"
	previous_val = _tmp5_;
#line 332 "../lib/sudoku-board.vala"
	_tmp6_ = self->cells;
#line 332 "../lib/sudoku-board.vala"
	_tmp6__length1 = self->cells_length1;
#line 332 "../lib/sudoku-board.vala"
	_tmp6__length2 = self->cells_length2;
#line 332 "../lib/sudoku-board.vala"
	_tmp6_[(row * _tmp6__length2) + col] = 0;
#line 334 "../lib/sudoku-board.vala"
	_tmp7_ = self->broken_coords;
#line 334 "../lib/sudoku-board.vala"
	coord_init (&_tmp8_, row, col);
#line 334 "../lib/sudoku-board.vala"
	if (gee_collection_contains ((GeeCollection*) _tmp7_, &_tmp8_)) {
#line 2661 "sudoku-board.c"
		GeeList* _tmp9_;
		gpointer _tmp10_;
		GeeList* _tmp11_;
		GeeList* _tmp12_;
		gpointer _tmp13_;
		GeeList* _tmp14_;
		GeeMap* _tmp15_;
		gint _tmp16_;
		gint _tmp17_;
		Coord _tmp18_ = {0};
		gpointer _tmp19_;
		GeeList* _tmp20_;
		GeeSet* _tmp21_;
		Coord _tmp22_ = {0};
		GeeList* _tmp23_;
		gpointer _tmp24_;
		GeeList* _tmp25_;
		GeeList* _tmp26_;
		gpointer _tmp27_;
		GeeList* _tmp28_;
		GeeMap* _tmp29_;
		gint _tmp30_;
		gint _tmp31_;
		Coord _tmp32_ = {0};
		gpointer _tmp33_;
		GeeList* _tmp34_;
		gboolean* _tmp35_;
		gint _tmp35__length1;
		gint _tmp35__length2;
		GeeList* _tmp36_;
		gpointer _tmp37_;
		GeeList* _tmp38_;
		GeeSet* _tmp39_;
		GeeSet* _tmp40_;
		gint _tmp41_;
		gint _tmp42_;
		gboolean* _tmp43_;
		gint _tmp43__length1;
		gint _tmp43__length2;
		GeeList* _tmp44_;
		gpointer _tmp45_;
		GeeList* _tmp46_;
		GeeSet* _tmp47_;
		GeeSet* _tmp48_;
		gint _tmp49_;
		gint _tmp50_;
		gboolean* _tmp51_;
		gint _tmp51__length1;
		gint _tmp51__length2;
		gint _tmp51__length3;
		gint _tmp52_;
		gint _tmp53_;
		GeeMap* _tmp54_;
		gint _tmp55_;
		gint _tmp56_;
		Coord _tmp57_ = {0};
		gpointer _tmp58_;
		GeeList* _tmp59_;
		GeeSet* _tmp60_;
		GeeSet* _tmp61_;
		gint _tmp62_;
		gint _tmp63_;
#line 337 "../lib/sudoku-board.vala"
		_tmp9_ = self->coords_for_row;
#line 337 "../lib/sudoku-board.vala"
		_tmp10_ = gee_list_get (_tmp9_, row);
#line 337 "../lib/sudoku-board.vala"
		_tmp11_ = (GeeList*) _tmp10_;
#line 337 "../lib/sudoku-board.vala"
		sudoku_board_remove_breakages_for (self, _tmp11_, previous_val);
#line 337 "../lib/sudoku-board.vala"
		_g_object_unref0 (_tmp11_);
#line 338 "../lib/sudoku-board.vala"
		_tmp12_ = self->coords_for_col;
#line 338 "../lib/sudoku-board.vala"
		_tmp13_ = gee_list_get (_tmp12_, col);
#line 338 "../lib/sudoku-board.vala"
		_tmp14_ = (GeeList*) _tmp13_;
#line 338 "../lib/sudoku-board.vala"
		sudoku_board_remove_breakages_for (self, _tmp14_, previous_val);
#line 338 "../lib/sudoku-board.vala"
		_g_object_unref0 (_tmp14_);
#line 339 "../lib/sudoku-board.vala"
		_tmp15_ = self->coords_for_block;
#line 339 "../lib/sudoku-board.vala"
		_tmp16_ = self->priv->_block_rows;
#line 339 "../lib/sudoku-board.vala"
		_tmp17_ = self->priv->_block_cols;
#line 339 "../lib/sudoku-board.vala"
		coord_init (&_tmp18_, row / _tmp16_, col / _tmp17_);
#line 339 "../lib/sudoku-board.vala"
		_tmp19_ = gee_map_get (_tmp15_, &_tmp18_);
#line 339 "../lib/sudoku-board.vala"
		_tmp20_ = (GeeList*) _tmp19_;
#line 339 "../lib/sudoku-board.vala"
		sudoku_board_remove_breakages_for (self, _tmp20_, previous_val);
#line 339 "../lib/sudoku-board.vala"
		_g_object_unref0 (_tmp20_);
#line 340 "../lib/sudoku-board.vala"
		_tmp21_ = self->broken_coords;
#line 340 "../lib/sudoku-board.vala"
		coord_init (&_tmp22_, row, col);
#line 340 "../lib/sudoku-board.vala"
		gee_collection_remove ((GeeCollection*) _tmp21_, &_tmp22_);
#line 343 "../lib/sudoku-board.vala"
		_tmp23_ = self->coords_for_row;
#line 343 "../lib/sudoku-board.vala"
		_tmp24_ = gee_list_get (_tmp23_, row);
#line 343 "../lib/sudoku-board.vala"
		_tmp25_ = (GeeList*) _tmp24_;
#line 343 "../lib/sudoku-board.vala"
		sudoku_board_mark_breakages_for (self, _tmp25_, previous_val);
#line 343 "../lib/sudoku-board.vala"
		_g_object_unref0 (_tmp25_);
#line 344 "../lib/sudoku-board.vala"
		_tmp26_ = self->coords_for_col;
#line 344 "../lib/sudoku-board.vala"
		_tmp27_ = gee_list_get (_tmp26_, col);
#line 344 "../lib/sudoku-board.vala"
		_tmp28_ = (GeeList*) _tmp27_;
#line 344 "../lib/sudoku-board.vala"
		sudoku_board_mark_breakages_for (self, _tmp28_, previous_val);
#line 344 "../lib/sudoku-board.vala"
		_g_object_unref0 (_tmp28_);
#line 345 "../lib/sudoku-board.vala"
		_tmp29_ = self->coords_for_block;
#line 345 "../lib/sudoku-board.vala"
		_tmp30_ = self->priv->_block_rows;
#line 345 "../lib/sudoku-board.vala"
		_tmp31_ = self->priv->_block_cols;
#line 345 "../lib/sudoku-board.vala"
		coord_init (&_tmp32_, row / _tmp30_, col / _tmp31_);
#line 345 "../lib/sudoku-board.vala"
		_tmp33_ = gee_map_get (_tmp29_, &_tmp32_);
#line 345 "../lib/sudoku-board.vala"
		_tmp34_ = (GeeList*) _tmp33_;
#line 345 "../lib/sudoku-board.vala"
		sudoku_board_mark_breakages_for (self, _tmp34_, previous_val);
#line 345 "../lib/sudoku-board.vala"
		_g_object_unref0 (_tmp34_);
#line 348 "../lib/sudoku-board.vala"
		_tmp35_ = self->priv->possible_in_row;
#line 348 "../lib/sudoku-board.vala"
		_tmp35__length1 = self->priv->possible_in_row_length1;
#line 348 "../lib/sudoku-board.vala"
		_tmp35__length2 = self->priv->possible_in_row_length2;
#line 348 "../lib/sudoku-board.vala"
		_tmp36_ = self->coords_for_row;
#line 348 "../lib/sudoku-board.vala"
		_tmp37_ = gee_list_get (_tmp36_, row);
#line 348 "../lib/sudoku-board.vala"
		_tmp38_ = (GeeList*) _tmp37_;
#line 348 "../lib/sudoku-board.vala"
		_tmp39_ = sudoku_board_get_occurances (self, _tmp38_, previous_val);
#line 348 "../lib/sudoku-board.vala"
		_tmp40_ = _tmp39_;
#line 348 "../lib/sudoku-board.vala"
		_tmp41_ = gee_collection_get_size ((GeeCollection*) _tmp40_);
#line 348 "../lib/sudoku-board.vala"
		_tmp42_ = _tmp41_;
#line 348 "../lib/sudoku-board.vala"
		_tmp35_[(row * _tmp35__length2) + (previous_val - 1)] = _tmp42_ == 0;
#line 348 "../lib/sudoku-board.vala"
		_g_object_unref0 (_tmp40_);
#line 348 "../lib/sudoku-board.vala"
		_g_object_unref0 (_tmp38_);
#line 349 "../lib/sudoku-board.vala"
		_tmp43_ = self->priv->possible_in_col;
#line 349 "../lib/sudoku-board.vala"
		_tmp43__length1 = self->priv->possible_in_col_length1;
#line 349 "../lib/sudoku-board.vala"
		_tmp43__length2 = self->priv->possible_in_col_length2;
#line 349 "../lib/sudoku-board.vala"
		_tmp44_ = self->coords_for_col;
#line 349 "../lib/sudoku-board.vala"
		_tmp45_ = gee_list_get (_tmp44_, col);
#line 349 "../lib/sudoku-board.vala"
		_tmp46_ = (GeeList*) _tmp45_;
#line 349 "../lib/sudoku-board.vala"
		_tmp47_ = sudoku_board_get_occurances (self, _tmp46_, previous_val);
#line 349 "../lib/sudoku-board.vala"
		_tmp48_ = _tmp47_;
#line 349 "../lib/sudoku-board.vala"
		_tmp49_ = gee_collection_get_size ((GeeCollection*) _tmp48_);
#line 349 "../lib/sudoku-board.vala"
		_tmp50_ = _tmp49_;
#line 349 "../lib/sudoku-board.vala"
		_tmp43_[(col * _tmp43__length2) + (previous_val - 1)] = _tmp50_ == 0;
#line 349 "../lib/sudoku-board.vala"
		_g_object_unref0 (_tmp48_);
#line 349 "../lib/sudoku-board.vala"
		_g_object_unref0 (_tmp46_);
#line 350 "../lib/sudoku-board.vala"
		_tmp51_ = self->priv->possible_in_block;
#line 350 "../lib/sudoku-board.vala"
		_tmp51__length1 = self->priv->possible_in_block_length1;
#line 350 "../lib/sudoku-board.vala"
		_tmp51__length2 = self->priv->possible_in_block_length2;
#line 350 "../lib/sudoku-board.vala"
		_tmp51__length3 = self->priv->possible_in_block_length3;
#line 350 "../lib/sudoku-board.vala"
		_tmp52_ = self->priv->_block_cols;
#line 350 "../lib/sudoku-board.vala"
		_tmp53_ = self->priv->_block_rows;
#line 350 "../lib/sudoku-board.vala"
		_tmp54_ = self->coords_for_block;
#line 350 "../lib/sudoku-board.vala"
		_tmp55_ = self->priv->_block_rows;
#line 350 "../lib/sudoku-board.vala"
		_tmp56_ = self->priv->_block_cols;
#line 350 "../lib/sudoku-board.vala"
		coord_init (&_tmp57_, row / _tmp55_, col / _tmp56_);
#line 350 "../lib/sudoku-board.vala"
		_tmp58_ = gee_map_get (_tmp54_, &_tmp57_);
#line 350 "../lib/sudoku-board.vala"
		_tmp59_ = (GeeList*) _tmp58_;
#line 350 "../lib/sudoku-board.vala"
		_tmp60_ = sudoku_board_get_occurances (self, _tmp59_, previous_val);
#line 350 "../lib/sudoku-board.vala"
		_tmp61_ = _tmp60_;
#line 350 "../lib/sudoku-board.vala"
		_tmp62_ = gee_collection_get_size ((GeeCollection*) _tmp61_);
#line 350 "../lib/sudoku-board.vala"
		_tmp63_ = _tmp62_;
#line 350 "../lib/sudoku-board.vala"
		_tmp51_[((((row / _tmp52_) * _tmp51__length2) + (col / _tmp53_)) * _tmp51__length3) + (previous_val - 1)] = _tmp63_ == 0;
#line 350 "../lib/sudoku-board.vala"
		_g_object_unref0 (_tmp61_);
#line 350 "../lib/sudoku-board.vala"
		_g_object_unref0 (_tmp59_);
#line 2892 "sudoku-board.c"
	} else {
		gint _tmp64_;
		gboolean* _tmp65_;
		gint _tmp65__length1;
		gint _tmp65__length2;
		gboolean* _tmp66_;
		gint _tmp66__length1;
		gint _tmp66__length2;
		gboolean* _tmp67_;
		gint _tmp67__length1;
		gint _tmp67__length2;
		gint _tmp67__length3;
		gint _tmp68_;
		gint _tmp69_;
#line 354 "../lib/sudoku-board.vala"
		_tmp64_ = previous_val;
#line 354 "../lib/sudoku-board.vala"
		previous_val = _tmp64_ - 1;
#line 356 "../lib/sudoku-board.vala"
		_tmp65_ = self->priv->possible_in_row;
#line 356 "../lib/sudoku-board.vala"
		_tmp65__length1 = self->priv->possible_in_row_length1;
#line 356 "../lib/sudoku-board.vala"
		_tmp65__length2 = self->priv->possible_in_row_length2;
#line 356 "../lib/sudoku-board.vala"
		_tmp65_[(row * _tmp65__length2) + previous_val] = TRUE;
#line 357 "../lib/sudoku-board.vala"
		_tmp66_ = self->priv->possible_in_col;
#line 357 "../lib/sudoku-board.vala"
		_tmp66__length1 = self->priv->possible_in_col_length1;
#line 357 "../lib/sudoku-board.vala"
		_tmp66__length2 = self->priv->possible_in_col_length2;
#line 357 "../lib/sudoku-board.vala"
		_tmp66_[(col * _tmp66__length2) + previous_val] = TRUE;
#line 358 "../lib/sudoku-board.vala"
		_tmp67_ = self->priv->possible_in_block;
#line 358 "../lib/sudoku-board.vala"
		_tmp67__length1 = self->priv->possible_in_block_length1;
#line 358 "../lib/sudoku-board.vala"
		_tmp67__length2 = self->priv->possible_in_block_length2;
#line 358 "../lib/sudoku-board.vala"
		_tmp67__length3 = self->priv->possible_in_block_length3;
#line 358 "../lib/sudoku-board.vala"
		_tmp68_ = self->priv->_block_cols;
#line 358 "../lib/sudoku-board.vala"
		_tmp69_ = self->priv->_block_rows;
#line 358 "../lib/sudoku-board.vala"
		_tmp67_[((((row / _tmp68_) * _tmp67__length2) + (col / _tmp69_)) * _tmp67__length3) + previous_val] = TRUE;
#line 2941 "sudoku-board.c"
	}
#line 361 "../lib/sudoku-board.vala"
	_tmp70_ = self->priv->_filled;
#line 361 "../lib/sudoku-board.vala"
	sudoku_board_set_filled (self, _tmp70_ - 1);
#line 363 "../lib/sudoku-board.vala"
	if (is_fixed) {
#line 2949 "sudoku-board.c"
		gint _tmp71_;
#line 364 "../lib/sudoku-board.vala"
		_tmp71_ = self->priv->_fixed;
#line 364 "../lib/sudoku-board.vala"
		sudoku_board_set_fixed (self, _tmp71_ - 1);
#line 2955 "sudoku-board.c"
	}
}

gint
sudoku_board_count_solutions_limited (SudokuBoard* self)
{
	gint result = 0;
	gint* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
#line 367 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 369 "../lib/sudoku-board.vala"
	_tmp0_ = self->cells;
#line 369 "../lib/sudoku-board.vala"
	_tmp0__length1 = self->cells_length1;
#line 369 "../lib/sudoku-board.vala"
	_tmp0__length2 = self->cells_length2;
#line 369 "../lib/sudoku-board.vala"
	result = qqwing_count_solutions_limited ((gint*) _tmp0_);
#line 369 "../lib/sudoku-board.vala"
	return result;
#line 2978 "sudoku-board.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 375 "../lib/sudoku-board.vala"
	return self ? g_object_ref (self) : NULL;
#line 2986 "sudoku-board.c"
}

GeeSet*
sudoku_board_get_occurances (SudokuBoard* self,
                             GeeList* coords,
                             gint val)
{
	GeeSet* result = NULL;
	GeeSet* occurances = NULL;
	GeeHashSet* _tmp0_;
#line 372 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 372 "../lib/sudoku-board.vala"
	g_return_val_if_fail (coords != NULL, NULL);
#line 374 "../lib/sudoku-board.vala"
	_tmp0_ = gee_hash_set_new (TYPE_COORD, (GBoxedCopyFunc) coord_dup, (GDestroyNotify) coord_free, (GeeHashDataFunc) coord_hash, NULL, NULL, (GeeEqualDataFunc) coord_equal, NULL, NULL);
#line 374 "../lib/sudoku-board.vala"
	occurances = (GeeSet*) _tmp0_;
#line 3005 "sudoku-board.c"
	{
		GeeList* _coord_list = NULL;
		GeeList* _tmp1_;
		gint _coord_size = 0;
		GeeList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _coord_index = 0;
#line 375 "../lib/sudoku-board.vala"
		_tmp1_ = _g_object_ref0 (coords);
#line 375 "../lib/sudoku-board.vala"
		_coord_list = _tmp1_;
#line 375 "../lib/sudoku-board.vala"
		_tmp2_ = _coord_list;
#line 375 "../lib/sudoku-board.vala"
		_tmp3_ = gee_collection_get_size ((GeeCollection*) _tmp2_);
#line 375 "../lib/sudoku-board.vala"
		_tmp4_ = _tmp3_;
#line 375 "../lib/sudoku-board.vala"
		_coord_size = _tmp4_;
#line 375 "../lib/sudoku-board.vala"
		_coord_index = -1;
#line 375 "../lib/sudoku-board.vala"
		while (TRUE) {
#line 3030 "sudoku-board.c"
			Coord coord = {0};
			GeeList* _tmp5_;
			gpointer _tmp6_;
			Coord* _tmp7_;
			Coord _tmp8_;
			gint* _tmp9_;
			gint _tmp9__length1;
			gint _tmp9__length2;
			Coord _tmp10_;
			Coord _tmp11_;
			gint _tmp12_;
#line 375 "../lib/sudoku-board.vala"
			_coord_index = _coord_index + 1;
#line 375 "../lib/sudoku-board.vala"
			if (!(_coord_index < _coord_size)) {
#line 375 "../lib/sudoku-board.vala"
				break;
#line 3048 "sudoku-board.c"
			}
#line 375 "../lib/sudoku-board.vala"
			_tmp5_ = _coord_list;
#line 375 "../lib/sudoku-board.vala"
			_tmp6_ = gee_list_get (_tmp5_, _coord_index);
#line 375 "../lib/sudoku-board.vala"
			_tmp7_ = (Coord*) _tmp6_;
#line 375 "../lib/sudoku-board.vala"
			_tmp8_ = *_tmp7_;
#line 375 "../lib/sudoku-board.vala"
			_coord_free0 (_tmp7_);
#line 375 "../lib/sudoku-board.vala"
			coord = _tmp8_;
#line 376 "../lib/sudoku-board.vala"
			_tmp9_ = self->cells;
#line 376 "../lib/sudoku-board.vala"
			_tmp9__length1 = self->cells_length1;
#line 376 "../lib/sudoku-board.vala"
			_tmp9__length2 = self->cells_length2;
#line 376 "../lib/sudoku-board.vala"
			_tmp10_ = coord;
#line 376 "../lib/sudoku-board.vala"
			_tmp11_ = coord;
#line 376 "../lib/sudoku-board.vala"
			_tmp12_ = _tmp9_[(_tmp10_.row * _tmp9__length2) + _tmp11_.col];
#line 376 "../lib/sudoku-board.vala"
			if (_tmp12_ == val) {
#line 3076 "sudoku-board.c"
				GeeSet* _tmp13_;
				Coord _tmp14_;
#line 377 "../lib/sudoku-board.vala"
				_tmp13_ = occurances;
#line 377 "../lib/sudoku-board.vala"
				_tmp14_ = coord;
#line 377 "../lib/sudoku-board.vala"
				gee_collection_add ((GeeCollection*) _tmp13_, &_tmp14_);
#line 3085 "sudoku-board.c"
			}
		}
#line 375 "../lib/sudoku-board.vala"
		_g_object_unref0 (_coord_list);
#line 3090 "sudoku-board.c"
	}
#line 379 "../lib/sudoku-board.vala"
	result = occurances;
#line 379 "../lib/sudoku-board.vala"
	return result;
#line 3096 "sudoku-board.c"
}

gboolean
sudoku_board_row_contains (SudokuBoard* self,
                           gint row,
                           gint val)
{
	gboolean result = FALSE;
	GeeList* _tmp0_;
	gpointer _tmp1_;
	GeeList* _tmp2_;
	GeeSet* _tmp3_;
	GeeSet* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	gboolean _tmp7_;
#line 382 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 384 "../lib/sudoku-board.vala"
	_tmp0_ = self->coords_for_row;
#line 384 "../lib/sudoku-board.vala"
	_tmp1_ = gee_list_get (_tmp0_, row);
#line 384 "../lib/sudoku-board.vala"
	_tmp2_ = (GeeList*) _tmp1_;
#line 384 "../lib/sudoku-board.vala"
	_tmp3_ = sudoku_board_get_occurances (self, _tmp2_, val);
#line 384 "../lib/sudoku-board.vala"
	_tmp4_ = _tmp3_;
#line 384 "../lib/sudoku-board.vala"
	_tmp5_ = gee_collection_get_size ((GeeCollection*) _tmp4_);
#line 384 "../lib/sudoku-board.vala"
	_tmp6_ = _tmp5_;
#line 384 "../lib/sudoku-board.vala"
	_tmp7_ = _tmp6_ != 0;
#line 384 "../lib/sudoku-board.vala"
	_g_object_unref0 (_tmp4_);
#line 384 "../lib/sudoku-board.vala"
	_g_object_unref0 (_tmp2_);
#line 384 "../lib/sudoku-board.vala"
	result = _tmp7_;
#line 384 "../lib/sudoku-board.vala"
	return result;
#line 3139 "sudoku-board.c"
}

gboolean
sudoku_board_col_contains (SudokuBoard* self,
                           gint col,
                           gint val)
{
	gboolean result = FALSE;
	GeeList* _tmp0_;
	gpointer _tmp1_;
	GeeList* _tmp2_;
	GeeSet* _tmp3_;
	GeeSet* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	gboolean _tmp7_;
#line 387 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 389 "../lib/sudoku-board.vala"
	_tmp0_ = self->coords_for_col;
#line 389 "../lib/sudoku-board.vala"
	_tmp1_ = gee_list_get (_tmp0_, col);
#line 389 "../lib/sudoku-board.vala"
	_tmp2_ = (GeeList*) _tmp1_;
#line 389 "../lib/sudoku-board.vala"
	_tmp3_ = sudoku_board_get_occurances (self, _tmp2_, val);
#line 389 "../lib/sudoku-board.vala"
	_tmp4_ = _tmp3_;
#line 389 "../lib/sudoku-board.vala"
	_tmp5_ = gee_collection_get_size ((GeeCollection*) _tmp4_);
#line 389 "../lib/sudoku-board.vala"
	_tmp6_ = _tmp5_;
#line 389 "../lib/sudoku-board.vala"
	_tmp7_ = _tmp6_ != 0;
#line 389 "../lib/sudoku-board.vala"
	_g_object_unref0 (_tmp4_);
#line 389 "../lib/sudoku-board.vala"
	_g_object_unref0 (_tmp2_);
#line 389 "../lib/sudoku-board.vala"
	result = _tmp7_;
#line 389 "../lib/sudoku-board.vala"
	return result;
#line 3182 "sudoku-board.c"
}

gboolean
sudoku_board_block_contains (SudokuBoard* self,
                             Coord* block,
                             gint val)
{
	gboolean result = FALSE;
	GeeMap* _tmp0_;
	Coord _tmp1_;
	gpointer _tmp2_;
	GeeList* _tmp3_;
	GeeSet* _tmp4_;
	GeeSet* _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	gboolean _tmp8_;
#line 392 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 392 "../lib/sudoku-board.vala"
	g_return_val_if_fail (block != NULL, FALSE);
#line 394 "../lib/sudoku-board.vala"
	_tmp0_ = self->coords_for_block;
#line 394 "../lib/sudoku-board.vala"
	_tmp1_ = *block;
#line 394 "../lib/sudoku-board.vala"
	_tmp2_ = gee_map_get (_tmp0_, &_tmp1_);
#line 394 "../lib/sudoku-board.vala"
	_tmp3_ = (GeeList*) _tmp2_;
#line 394 "../lib/sudoku-board.vala"
	_tmp4_ = sudoku_board_get_occurances (self, _tmp3_, val);
#line 394 "../lib/sudoku-board.vala"
	_tmp5_ = _tmp4_;
#line 394 "../lib/sudoku-board.vala"
	_tmp6_ = gee_collection_get_size ((GeeCollection*) _tmp5_);
#line 394 "../lib/sudoku-board.vala"
	_tmp7_ = _tmp6_;
#line 394 "../lib/sudoku-board.vala"
	_tmp8_ = _tmp7_ != 0;
#line 394 "../lib/sudoku-board.vala"
	_g_object_unref0 (_tmp5_);
#line 394 "../lib/sudoku-board.vala"
	_g_object_unref0 (_tmp3_);
#line 394 "../lib/sudoku-board.vala"
	result = _tmp8_;
#line 394 "../lib/sudoku-board.vala"
	return result;
#line 3230 "sudoku-board.c"
}

static void
sudoku_board_remove_breakages_for (SudokuBoard* self,
                                   GeeList* coords,
                                   gint val)
{
#line 397 "../lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 397 "../lib/sudoku-board.vala"
	g_return_if_fail (coords != NULL);
#line 3242 "sudoku-board.c"
	{
		GeeList* _coord_list = NULL;
		GeeList* _tmp0_;
		gint _coord_size = 0;
		GeeList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _coord_index = 0;
#line 399 "../lib/sudoku-board.vala"
		_tmp0_ = _g_object_ref0 (coords);
#line 399 "../lib/sudoku-board.vala"
		_coord_list = _tmp0_;
#line 399 "../lib/sudoku-board.vala"
		_tmp1_ = _coord_list;
#line 399 "../lib/sudoku-board.vala"
		_tmp2_ = gee_collection_get_size ((GeeCollection*) _tmp1_);
#line 399 "../lib/sudoku-board.vala"
		_tmp3_ = _tmp2_;
#line 399 "../lib/sudoku-board.vala"
		_coord_size = _tmp3_;
#line 399 "../lib/sudoku-board.vala"
		_coord_index = -1;
#line 399 "../lib/sudoku-board.vala"
		while (TRUE) {
#line 3267 "sudoku-board.c"
			Coord coord = {0};
			GeeList* _tmp4_;
			gpointer _tmp5_;
			Coord* _tmp6_;
			Coord _tmp7_;
			gboolean _tmp8_ = FALSE;
			gint* _tmp9_;
			gint _tmp9__length1;
			gint _tmp9__length2;
			Coord _tmp10_;
			Coord _tmp11_;
			gint _tmp12_;
#line 399 "../lib/sudoku-board.vala"
			_coord_index = _coord_index + 1;
#line 399 "../lib/sudoku-board.vala"
			if (!(_coord_index < _coord_size)) {
#line 399 "../lib/sudoku-board.vala"
				break;
#line 3286 "sudoku-board.c"
			}
#line 399 "../lib/sudoku-board.vala"
			_tmp4_ = _coord_list;
#line 399 "../lib/sudoku-board.vala"
			_tmp5_ = gee_list_get (_tmp4_, _coord_index);
#line 399 "../lib/sudoku-board.vala"
			_tmp6_ = (Coord*) _tmp5_;
#line 399 "../lib/sudoku-board.vala"
			_tmp7_ = *_tmp6_;
#line 399 "../lib/sudoku-board.vala"
			_coord_free0 (_tmp6_);
#line 399 "../lib/sudoku-board.vala"
			coord = _tmp7_;
#line 400 "../lib/sudoku-board.vala"
			_tmp9_ = self->cells;
#line 400 "../lib/sudoku-board.vala"
			_tmp9__length1 = self->cells_length1;
#line 400 "../lib/sudoku-board.vala"
			_tmp9__length2 = self->cells_length2;
#line 400 "../lib/sudoku-board.vala"
			_tmp10_ = coord;
#line 400 "../lib/sudoku-board.vala"
			_tmp11_ = coord;
#line 400 "../lib/sudoku-board.vala"
			_tmp12_ = _tmp9_[(_tmp10_.row * _tmp9__length2) + _tmp11_.col];
#line 400 "../lib/sudoku-board.vala"
			if (_tmp12_ == val) {
#line 3314 "sudoku-board.c"
				GeeSet* _tmp13_;
				Coord _tmp14_;
#line 400 "../lib/sudoku-board.vala"
				_tmp13_ = self->broken_coords;
#line 400 "../lib/sudoku-board.vala"
				_tmp14_ = coord;
#line 400 "../lib/sudoku-board.vala"
				_tmp8_ = gee_collection_contains ((GeeCollection*) _tmp13_, &_tmp14_);
#line 3323 "sudoku-board.c"
			} else {
#line 400 "../lib/sudoku-board.vala"
				_tmp8_ = FALSE;
#line 3327 "sudoku-board.c"
			}
#line 400 "../lib/sudoku-board.vala"
			if (_tmp8_) {
#line 3331 "sudoku-board.c"
				GeeSet* _tmp15_;
				Coord _tmp16_;
#line 401 "../lib/sudoku-board.vala"
				_tmp15_ = self->broken_coords;
#line 401 "../lib/sudoku-board.vala"
				_tmp16_ = coord;
#line 401 "../lib/sudoku-board.vala"
				gee_collection_remove ((GeeCollection*) _tmp15_, &_tmp16_);
#line 3340 "sudoku-board.c"
			}
		}
#line 399 "../lib/sudoku-board.vala"
		_g_object_unref0 (_coord_list);
#line 3345 "sudoku-board.c"
	}
}

static void
sudoku_board_mark_breakages_for (SudokuBoard* self,
                                 GeeList* coords,
                                 gint val)
{
	GeeSet* occurances = NULL;
	GeeSet* _tmp0_;
	GeeSet* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
#line 405 "../lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 405 "../lib/sudoku-board.vala"
	g_return_if_fail (coords != NULL);
#line 407 "../lib/sudoku-board.vala"
	_tmp0_ = sudoku_board_get_occurances (self, coords, val);
#line 407 "../lib/sudoku-board.vala"
	occurances = _tmp0_;
#line 408 "../lib/sudoku-board.vala"
	_tmp1_ = occurances;
#line 408 "../lib/sudoku-board.vala"
	_tmp2_ = gee_collection_get_size ((GeeCollection*) _tmp1_);
#line 408 "../lib/sudoku-board.vala"
	_tmp3_ = _tmp2_;
#line 408 "../lib/sudoku-board.vala"
	if (_tmp3_ != 1) {
#line 3375 "sudoku-board.c"
		GeeSet* _tmp4_;
		GeeSet* _tmp5_;
#line 409 "../lib/sudoku-board.vala"
		_tmp4_ = self->broken_coords;
#line 409 "../lib/sudoku-board.vala"
		_tmp5_ = occurances;
#line 409 "../lib/sudoku-board.vala"
		gee_collection_add_all ((GeeCollection*) _tmp4_, (GeeCollection*) _tmp5_);
#line 3384 "sudoku-board.c"
	}
#line 405 "../lib/sudoku-board.vala"
	_g_object_unref0 (occurances);
#line 3388 "sudoku-board.c"
}

void
sudoku_board_to_initial_state (SudokuBoard* self)
{
#line 412 "../lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 3396 "sudoku-board.c"
	{
		gint l1 = 0;
#line 414 "../lib/sudoku-board.vala"
		l1 = 0;
#line 3401 "sudoku-board.c"
		{
			gboolean _tmp0_ = FALSE;
#line 414 "../lib/sudoku-board.vala"
			_tmp0_ = TRUE;
#line 414 "../lib/sudoku-board.vala"
			while (TRUE) {
#line 3408 "sudoku-board.c"
				gint _tmp2_;
#line 414 "../lib/sudoku-board.vala"
				if (!_tmp0_) {
#line 3412 "sudoku-board.c"
					gint _tmp1_;
#line 414 "../lib/sudoku-board.vala"
					_tmp1_ = l1;
#line 414 "../lib/sudoku-board.vala"
					l1 = _tmp1_ + 1;
#line 3418 "sudoku-board.c"
				}
#line 414 "../lib/sudoku-board.vala"
				_tmp0_ = FALSE;
#line 414 "../lib/sudoku-board.vala"
				_tmp2_ = self->priv->_rows;
#line 414 "../lib/sudoku-board.vala"
				if (!(l1 < _tmp2_)) {
#line 414 "../lib/sudoku-board.vala"
					break;
#line 3428 "sudoku-board.c"
				}
				{
					gint l2 = 0;
#line 415 "../lib/sudoku-board.vala"
					l2 = 0;
#line 3434 "sudoku-board.c"
					{
						gboolean _tmp3_ = FALSE;
#line 415 "../lib/sudoku-board.vala"
						_tmp3_ = TRUE;
#line 415 "../lib/sudoku-board.vala"
						while (TRUE) {
#line 3441 "sudoku-board.c"
							gint _tmp5_;
							gboolean* _tmp6_;
							gint _tmp6__length1;
							gint _tmp6__length2;
							gboolean _tmp7_;
#line 415 "../lib/sudoku-board.vala"
							if (!_tmp3_) {
#line 3449 "sudoku-board.c"
								gint _tmp4_;
#line 415 "../lib/sudoku-board.vala"
								_tmp4_ = l2;
#line 415 "../lib/sudoku-board.vala"
								l2 = _tmp4_ + 1;
#line 3455 "sudoku-board.c"
							}
#line 415 "../lib/sudoku-board.vala"
							_tmp3_ = FALSE;
#line 415 "../lib/sudoku-board.vala"
							_tmp5_ = self->priv->_cols;
#line 415 "../lib/sudoku-board.vala"
							if (!(l2 < _tmp5_)) {
#line 415 "../lib/sudoku-board.vala"
								break;
#line 3465 "sudoku-board.c"
							}
#line 416 "../lib/sudoku-board.vala"
							_tmp6_ = self->is_fixed;
#line 416 "../lib/sudoku-board.vala"
							_tmp6__length1 = self->is_fixed_length1;
#line 416 "../lib/sudoku-board.vala"
							_tmp6__length2 = self->is_fixed_length2;
#line 416 "../lib/sudoku-board.vala"
							_tmp7_ = _tmp6_[(l1 * _tmp6__length2) + l2];
#line 416 "../lib/sudoku-board.vala"
							if (!_tmp7_) {
#line 417 "../lib/sudoku-board.vala"
								sudoku_board_remove (self, l1, l2, FALSE);
#line 3479 "sudoku-board.c"
							}
						}
					}
				}
			}
		}
	}
}

void
sudoku_board_print (SudokuBoard* self,
                    gint indent)
{
	FILE* _tmp14_;
#line 420 "../lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 3496 "sudoku-board.c"
	{
		gint l1 = 0;
#line 422 "../lib/sudoku-board.vala"
		l1 = 0;
#line 3501 "sudoku-board.c"
		{
			gboolean _tmp0_ = FALSE;
#line 422 "../lib/sudoku-board.vala"
			_tmp0_ = TRUE;
#line 422 "../lib/sudoku-board.vala"
			while (TRUE) {
#line 3508 "sudoku-board.c"
				FILE* _tmp13_;
#line 422 "../lib/sudoku-board.vala"
				if (!_tmp0_) {
#line 3512 "sudoku-board.c"
					gint _tmp1_;
#line 422 "../lib/sudoku-board.vala"
					_tmp1_ = l1;
#line 422 "../lib/sudoku-board.vala"
					l1 = _tmp1_ + 1;
#line 3518 "sudoku-board.c"
				}
#line 422 "../lib/sudoku-board.vala"
				_tmp0_ = FALSE;
#line 422 "../lib/sudoku-board.vala"
				if (!(l1 < 9)) {
#line 422 "../lib/sudoku-board.vala"
					break;
#line 3526 "sudoku-board.c"
				}
				{
					gint i = 0;
#line 424 "../lib/sudoku-board.vala"
					i = 0;
#line 3532 "sudoku-board.c"
					{
						gboolean _tmp2_ = FALSE;
#line 424 "../lib/sudoku-board.vala"
						_tmp2_ = TRUE;
#line 424 "../lib/sudoku-board.vala"
						while (TRUE) {
#line 3539 "sudoku-board.c"
							FILE* _tmp4_;
#line 424 "../lib/sudoku-board.vala"
							if (!_tmp2_) {
#line 3543 "sudoku-board.c"
								gint _tmp3_;
#line 424 "../lib/sudoku-board.vala"
								_tmp3_ = i;
#line 424 "../lib/sudoku-board.vala"
								i = _tmp3_ + 1;
#line 3549 "sudoku-board.c"
							}
#line 424 "../lib/sudoku-board.vala"
							_tmp2_ = FALSE;
#line 424 "../lib/sudoku-board.vala"
							if (!(i < indent)) {
#line 424 "../lib/sudoku-board.vala"
								break;
#line 3557 "sudoku-board.c"
							}
#line 425 "../lib/sudoku-board.vala"
							_tmp4_ = stdout;
#line 425 "../lib/sudoku-board.vala"
							fprintf (_tmp4_, " ");
#line 3563 "sudoku-board.c"
						}
					}
				}
				{
					gint l2 = 0;
#line 426 "../lib/sudoku-board.vala"
					l2 = 0;
#line 3571 "sudoku-board.c"
					{
						gboolean _tmp5_ = FALSE;
#line 426 "../lib/sudoku-board.vala"
						_tmp5_ = TRUE;
#line 426 "../lib/sudoku-board.vala"
						while (TRUE) {
#line 3578 "sudoku-board.c"
							gint* _tmp7_;
							gint _tmp7__length1;
							gint _tmp7__length2;
							gint _tmp8_;
#line 426 "../lib/sudoku-board.vala"
							if (!_tmp5_) {
#line 3585 "sudoku-board.c"
								gint _tmp6_;
#line 426 "../lib/sudoku-board.vala"
								_tmp6_ = l2;
#line 426 "../lib/sudoku-board.vala"
								l2 = _tmp6_ + 1;
#line 3591 "sudoku-board.c"
							}
#line 426 "../lib/sudoku-board.vala"
							_tmp5_ = FALSE;
#line 426 "../lib/sudoku-board.vala"
							if (!(l2 < 9)) {
#line 426 "../lib/sudoku-board.vala"
								break;
#line 3599 "sudoku-board.c"
							}
#line 428 "../lib/sudoku-board.vala"
							_tmp7_ = self->cells;
#line 428 "../lib/sudoku-board.vala"
							_tmp7__length1 = self->cells_length1;
#line 428 "../lib/sudoku-board.vala"
							_tmp7__length2 = self->cells_length2;
#line 428 "../lib/sudoku-board.vala"
							_tmp8_ = _tmp7_[(l1 * _tmp7__length2) + l2];
#line 428 "../lib/sudoku-board.vala"
							if (_tmp8_ != 0) {
#line 3611 "sudoku-board.c"
								FILE* _tmp9_;
								gint* _tmp10_;
								gint _tmp10__length1;
								gint _tmp10__length2;
								gint _tmp11_;
#line 429 "../lib/sudoku-board.vala"
								_tmp9_ = stdout;
#line 429 "../lib/sudoku-board.vala"
								_tmp10_ = self->cells;
#line 429 "../lib/sudoku-board.vala"
								_tmp10__length1 = self->cells_length1;
#line 429 "../lib/sudoku-board.vala"
								_tmp10__length2 = self->cells_length2;
#line 429 "../lib/sudoku-board.vala"
								_tmp11_ = _tmp10_[(l1 * _tmp10__length2) + l2];
#line 429 "../lib/sudoku-board.vala"
								fprintf (_tmp9_, "%d ", _tmp11_);
#line 3629 "sudoku-board.c"
							} else {
								FILE* _tmp12_;
#line 431 "../lib/sudoku-board.vala"
								_tmp12_ = stdout;
#line 431 "../lib/sudoku-board.vala"
								fprintf (_tmp12_, "  ");
#line 3636 "sudoku-board.c"
							}
						}
					}
				}
#line 433 "../lib/sudoku-board.vala"
				_tmp13_ = stdout;
#line 433 "../lib/sudoku-board.vala"
				fprintf (_tmp13_, "\n");
#line 3645 "sudoku-board.c"
			}
		}
	}
#line 435 "../lib/sudoku-board.vala"
	_tmp14_ = stdout;
#line 435 "../lib/sudoku-board.vala"
	fflush (_tmp14_);
#line 3653 "sudoku-board.c"
}

void
sudoku_board_get_string (SudokuBoard* self)
{
	FILE* _tmp0_;
	FILE* _tmp12_;
#line 438 "../lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 440 "../lib/sudoku-board.vala"
	_tmp0_ = stdout;
#line 440 "../lib/sudoku-board.vala"
	fprintf (_tmp0_, "[ ");
#line 3667 "sudoku-board.c"
	{
		gint l1 = 0;
#line 441 "../lib/sudoku-board.vala"
		l1 = 0;
#line 3672 "sudoku-board.c"
		{
			gboolean _tmp1_ = FALSE;
#line 441 "../lib/sudoku-board.vala"
			_tmp1_ = TRUE;
#line 441 "../lib/sudoku-board.vala"
			while (TRUE) {
#line 3679 "sudoku-board.c"
				FILE* _tmp3_;
				FILE* _tmp10_;
#line 441 "../lib/sudoku-board.vala"
				if (!_tmp1_) {
#line 3684 "sudoku-board.c"
					gint _tmp2_;
#line 441 "../lib/sudoku-board.vala"
					_tmp2_ = l1;
#line 441 "../lib/sudoku-board.vala"
					l1 = _tmp2_ + 1;
#line 3690 "sudoku-board.c"
				}
#line 441 "../lib/sudoku-board.vala"
				_tmp1_ = FALSE;
#line 441 "../lib/sudoku-board.vala"
				if (!(l1 < 9)) {
#line 441 "../lib/sudoku-board.vala"
					break;
#line 3698 "sudoku-board.c"
				}
#line 443 "../lib/sudoku-board.vala"
				_tmp3_ = stdout;
#line 443 "../lib/sudoku-board.vala"
				fprintf (_tmp3_, "[ ");
#line 3704 "sudoku-board.c"
				{
					gint l2 = 0;
#line 444 "../lib/sudoku-board.vala"
					l2 = 0;
#line 3709 "sudoku-board.c"
					{
						gboolean _tmp4_ = FALSE;
#line 444 "../lib/sudoku-board.vala"
						_tmp4_ = TRUE;
#line 444 "../lib/sudoku-board.vala"
						while (TRUE) {
#line 3716 "sudoku-board.c"
							FILE* _tmp6_;
							gint* _tmp7_;
							gint _tmp7__length1;
							gint _tmp7__length2;
							gint _tmp8_;
#line 444 "../lib/sudoku-board.vala"
							if (!_tmp4_) {
#line 3724 "sudoku-board.c"
								gint _tmp5_;
#line 444 "../lib/sudoku-board.vala"
								_tmp5_ = l2;
#line 444 "../lib/sudoku-board.vala"
								l2 = _tmp5_ + 1;
#line 3730 "sudoku-board.c"
							}
#line 444 "../lib/sudoku-board.vala"
							_tmp4_ = FALSE;
#line 444 "../lib/sudoku-board.vala"
							if (!(l2 < 9)) {
#line 444 "../lib/sudoku-board.vala"
								break;
#line 3738 "sudoku-board.c"
							}
#line 446 "../lib/sudoku-board.vala"
							_tmp6_ = stdout;
#line 446 "../lib/sudoku-board.vala"
							_tmp7_ = self->cells;
#line 446 "../lib/sudoku-board.vala"
							_tmp7__length1 = self->cells_length1;
#line 446 "../lib/sudoku-board.vala"
							_tmp7__length2 = self->cells_length2;
#line 446 "../lib/sudoku-board.vala"
							_tmp8_ = _tmp7_[(l1 * _tmp7__length2) + l2];
#line 446 "../lib/sudoku-board.vala"
							fprintf (_tmp6_, "%d", _tmp8_);
#line 447 "../lib/sudoku-board.vala"
							if (l2 != 8) {
#line 3754 "sudoku-board.c"
								FILE* _tmp9_;
#line 448 "../lib/sudoku-board.vala"
								_tmp9_ = stdout;
#line 448 "../lib/sudoku-board.vala"
								fprintf (_tmp9_, ",");
#line 3760 "sudoku-board.c"
							}
						}
					}
				}
#line 450 "../lib/sudoku-board.vala"
				_tmp10_ = stdout;
#line 450 "../lib/sudoku-board.vala"
				fprintf (_tmp10_, " ]");
#line 451 "../lib/sudoku-board.vala"
				if (l1 != 8) {
#line 3771 "sudoku-board.c"
					FILE* _tmp11_;
#line 452 "../lib/sudoku-board.vala"
					_tmp11_ = stdout;
#line 452 "../lib/sudoku-board.vala"
					fprintf (_tmp11_, ",");
#line 3777 "sudoku-board.c"
				}
			}
		}
	}
#line 454 "../lib/sudoku-board.vala"
	_tmp12_ = stdout;
#line 454 "../lib/sudoku-board.vala"
	fprintf (_tmp12_, " ]");
#line 3786 "sudoku-board.c"
}

gchar*
sudoku_board_to_string (SudokuBoard* self,
                        gboolean get_original_state)
{
	gchar* result = NULL;
	gchar* board_string = NULL;
	gchar* _tmp0_;
#line 457 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 459 "../lib/sudoku-board.vala"
	_tmp0_ = g_strdup ("");
#line 459 "../lib/sudoku-board.vala"
	board_string = _tmp0_;
#line 3802 "sudoku-board.c"
	{
		gint i = 0;
#line 460 "../lib/sudoku-board.vala"
		i = 0;
#line 3807 "sudoku-board.c"
		{
			gboolean _tmp1_ = FALSE;
#line 460 "../lib/sudoku-board.vala"
			_tmp1_ = TRUE;
#line 460 "../lib/sudoku-board.vala"
			while (TRUE) {
#line 3814 "sudoku-board.c"
				gint _tmp3_;
#line 460 "../lib/sudoku-board.vala"
				if (!_tmp1_) {
#line 3818 "sudoku-board.c"
					gint _tmp2_;
#line 460 "../lib/sudoku-board.vala"
					_tmp2_ = i;
#line 460 "../lib/sudoku-board.vala"
					i = _tmp2_ + 1;
#line 3824 "sudoku-board.c"
				}
#line 460 "../lib/sudoku-board.vala"
				_tmp1_ = FALSE;
#line 460 "../lib/sudoku-board.vala"
				_tmp3_ = self->priv->_rows;
#line 460 "../lib/sudoku-board.vala"
				if (!(i < _tmp3_)) {
#line 460 "../lib/sudoku-board.vala"
					break;
#line 3834 "sudoku-board.c"
				}
				{
					gint j = 0;
#line 462 "../lib/sudoku-board.vala"
					j = 0;
#line 3840 "sudoku-board.c"
					{
						gboolean _tmp4_ = FALSE;
#line 462 "../lib/sudoku-board.vala"
						_tmp4_ = TRUE;
#line 462 "../lib/sudoku-board.vala"
						while (TRUE) {
#line 3847 "sudoku-board.c"
							gint _tmp6_;
							gboolean* _tmp7_;
							gint _tmp7__length1;
							gint _tmp7__length2;
							gboolean _tmp8_;
#line 462 "../lib/sudoku-board.vala"
							if (!_tmp4_) {
#line 3855 "sudoku-board.c"
								gint _tmp5_;
#line 462 "../lib/sudoku-board.vala"
								_tmp5_ = j;
#line 462 "../lib/sudoku-board.vala"
								j = _tmp5_ + 1;
#line 3861 "sudoku-board.c"
							}
#line 462 "../lib/sudoku-board.vala"
							_tmp4_ = FALSE;
#line 462 "../lib/sudoku-board.vala"
							_tmp6_ = self->priv->_cols;
#line 462 "../lib/sudoku-board.vala"
							if (!(j < _tmp6_)) {
#line 462 "../lib/sudoku-board.vala"
								break;
#line 3871 "sudoku-board.c"
							}
#line 464 "../lib/sudoku-board.vala"
							_tmp7_ = self->is_fixed;
#line 464 "../lib/sudoku-board.vala"
							_tmp7__length1 = self->is_fixed_length1;
#line 464 "../lib/sudoku-board.vala"
							_tmp7__length2 = self->is_fixed_length2;
#line 464 "../lib/sudoku-board.vala"
							_tmp8_ = _tmp7_[(i * _tmp7__length2) + j];
#line 464 "../lib/sudoku-board.vala"
							if (_tmp8_) {
#line 3883 "sudoku-board.c"
								const gchar* _tmp9_;
								gint* _tmp10_;
								gint _tmp10__length1;
								gint _tmp10__length2;
								gint _tmp11_;
								gchar* _tmp12_;
								gchar* _tmp13_;
								gchar* _tmp14_;
#line 465 "../lib/sudoku-board.vala"
								_tmp9_ = board_string;
#line 465 "../lib/sudoku-board.vala"
								_tmp10_ = self->cells;
#line 465 "../lib/sudoku-board.vala"
								_tmp10__length1 = self->cells_length1;
#line 465 "../lib/sudoku-board.vala"
								_tmp10__length2 = self->cells_length2;
#line 465 "../lib/sudoku-board.vala"
								_tmp11_ = _tmp10_[(i * _tmp10__length2) + j];
#line 465 "../lib/sudoku-board.vala"
								_tmp12_ = g_strdup_printf ("%i", _tmp11_);
#line 465 "../lib/sudoku-board.vala"
								_tmp13_ = _tmp12_;
#line 465 "../lib/sudoku-board.vala"
								_tmp14_ = g_strconcat (_tmp9_, _tmp13_, NULL);
#line 465 "../lib/sudoku-board.vala"
								_g_free0 (board_string);
#line 465 "../lib/sudoku-board.vala"
								board_string = _tmp14_;
#line 465 "../lib/sudoku-board.vala"
								_g_free0 (_tmp13_);
#line 3914 "sudoku-board.c"
							} else {
								gchar* _tmp15_ = NULL;
								const gchar* _tmp20_;
								gchar* _tmp21_;
#line 467 "../lib/sudoku-board.vala"
								if (get_original_state) {
#line 3921 "sudoku-board.c"
									gchar* _tmp16_;
#line 467 "../lib/sudoku-board.vala"
									_tmp16_ = g_strdup ("0");
#line 467 "../lib/sudoku-board.vala"
									_g_free0 (_tmp15_);
#line 467 "../lib/sudoku-board.vala"
									_tmp15_ = _tmp16_;
#line 3929 "sudoku-board.c"
								} else {
									gint* _tmp17_;
									gint _tmp17__length1;
									gint _tmp17__length2;
									gint _tmp18_;
									gchar* _tmp19_;
#line 467 "../lib/sudoku-board.vala"
									_tmp17_ = self->cells;
#line 467 "../lib/sudoku-board.vala"
									_tmp17__length1 = self->cells_length1;
#line 467 "../lib/sudoku-board.vala"
									_tmp17__length2 = self->cells_length2;
#line 467 "../lib/sudoku-board.vala"
									_tmp18_ = _tmp17_[(i * _tmp17__length2) + j];
#line 467 "../lib/sudoku-board.vala"
									_tmp19_ = g_strdup_printf ("%i", _tmp18_);
#line 467 "../lib/sudoku-board.vala"
									_g_free0 (_tmp15_);
#line 467 "../lib/sudoku-board.vala"
									_tmp15_ = _tmp19_;
#line 3950 "sudoku-board.c"
								}
#line 467 "../lib/sudoku-board.vala"
								_tmp20_ = board_string;
#line 467 "../lib/sudoku-board.vala"
								_tmp21_ = g_strconcat (_tmp20_, _tmp15_, NULL);
#line 467 "../lib/sudoku-board.vala"
								_g_free0 (board_string);
#line 467 "../lib/sudoku-board.vala"
								board_string = _tmp21_;
#line 464 "../lib/sudoku-board.vala"
								_g_free0 (_tmp15_);
#line 3962 "sudoku-board.c"
							}
						}
					}
				}
			}
		}
	}
#line 470 "../lib/sudoku-board.vala"
	result = board_string;
#line 470 "../lib/sudoku-board.vala"
	return result;
#line 3974 "sudoku-board.c"
}

static gint*
_vala_array_dup8 (gint* self,
                  int length)
{
#line 475 "../lib/sudoku-board.vala"
	return g_memdup (self, length * sizeof (gint));
#line 3983 "sudoku-board.c"
}

gint*
sudoku_board_get_cells (SudokuBoard* self,
                        gint* result_length1,
                        gint* result_length2)
{
	gint* result = NULL;
	gint* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	gint* _tmp1_;
	gint _tmp1__length1;
	gint _tmp1__length2;
	gint* _tmp2_;
	gint _tmp2__length1;
	gint _tmp2__length2;
#line 473 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 475 "../lib/sudoku-board.vala"
	_tmp0_ = self->cells;
#line 475 "../lib/sudoku-board.vala"
	_tmp0__length1 = self->cells_length1;
#line 475 "../lib/sudoku-board.vala"
	_tmp0__length2 = self->cells_length2;
#line 475 "../lib/sudoku-board.vala"
	_tmp1_ = (_tmp0_ != NULL) ? _vala_array_dup8 (_tmp0_, _tmp0__length1 * _tmp0__length2) : ((gpointer) _tmp0_);
#line 475 "../lib/sudoku-board.vala"
	_tmp1__length1 = _tmp0__length1;
#line 475 "../lib/sudoku-board.vala"
	_tmp1__length2 = _tmp0__length2;
#line 475 "../lib/sudoku-board.vala"
	_tmp2_ = _tmp1_;
#line 475 "../lib/sudoku-board.vala"
	_tmp2__length1 = _tmp1__length1;
#line 475 "../lib/sudoku-board.vala"
	_tmp2__length2 = _tmp1__length2;
#line 475 "../lib/sudoku-board.vala"
	if (result_length1) {
#line 475 "../lib/sudoku-board.vala"
		*result_length1 = _tmp2__length1;
#line 4025 "sudoku-board.c"
	}
#line 475 "../lib/sudoku-board.vala"
	if (result_length2) {
#line 475 "../lib/sudoku-board.vala"
		*result_length2 = _tmp2__length2;
#line 4031 "sudoku-board.c"
	}
#line 475 "../lib/sudoku-board.vala"
	result = _tmp2_;
#line 475 "../lib/sudoku-board.vala"
	return result;
#line 4037 "sudoku-board.c"
}

GeeHashMap*
sudoku_board_calculate_open_squares (SudokuBoard* self)
{
	GeeHashMap* result = NULL;
	GeeHashMap* possibilities = NULL;
	GeeHashMap* _tmp0_;
#line 478 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 480 "../lib/sudoku-board.vala"
	_tmp0_ = gee_hash_map_new (TYPE_COORD, (GBoxedCopyFunc) coord_dup, (GDestroyNotify) coord_free, GEE_TYPE_LIST, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, (GeeHashDataFunc) coord_hash, NULL, NULL, (GeeEqualDataFunc) coord_equal, NULL, NULL, NULL, NULL, NULL);
#line 480 "../lib/sudoku-board.vala"
	possibilities = _tmp0_;
#line 4052 "sudoku-board.c"
	{
		gint l1 = 0;
#line 481 "../lib/sudoku-board.vala"
		l1 = 0;
#line 4057 "sudoku-board.c"
		{
			gboolean _tmp1_ = FALSE;
#line 481 "../lib/sudoku-board.vala"
			_tmp1_ = TRUE;
#line 481 "../lib/sudoku-board.vala"
			while (TRUE) {
#line 4064 "sudoku-board.c"
				gint _tmp3_;
#line 481 "../lib/sudoku-board.vala"
				if (!_tmp1_) {
#line 4068 "sudoku-board.c"
					gint _tmp2_;
#line 481 "../lib/sudoku-board.vala"
					_tmp2_ = l1;
#line 481 "../lib/sudoku-board.vala"
					l1 = _tmp2_ + 1;
#line 4074 "sudoku-board.c"
				}
#line 481 "../lib/sudoku-board.vala"
				_tmp1_ = FALSE;
#line 481 "../lib/sudoku-board.vala"
				_tmp3_ = self->priv->_rows;
#line 481 "../lib/sudoku-board.vala"
				if (!(l1 < _tmp3_)) {
#line 481 "../lib/sudoku-board.vala"
					break;
#line 4084 "sudoku-board.c"
				}
				{
					gint l2 = 0;
#line 483 "../lib/sudoku-board.vala"
					l2 = 0;
#line 4090 "sudoku-board.c"
					{
						gboolean _tmp4_ = FALSE;
#line 483 "../lib/sudoku-board.vala"
						_tmp4_ = TRUE;
#line 483 "../lib/sudoku-board.vala"
						while (TRUE) {
#line 4097 "sudoku-board.c"
							gint _tmp6_;
							gint* _tmp7_;
							gint _tmp7__length1;
							gint _tmp7__length2;
							gint _tmp8_;
#line 483 "../lib/sudoku-board.vala"
							if (!_tmp4_) {
#line 4105 "sudoku-board.c"
								gint _tmp5_;
#line 483 "../lib/sudoku-board.vala"
								_tmp5_ = l2;
#line 483 "../lib/sudoku-board.vala"
								l2 = _tmp5_ + 1;
#line 4111 "sudoku-board.c"
							}
#line 483 "../lib/sudoku-board.vala"
							_tmp4_ = FALSE;
#line 483 "../lib/sudoku-board.vala"
							_tmp6_ = self->priv->_cols;
#line 483 "../lib/sudoku-board.vala"
							if (!(l2 < _tmp6_)) {
#line 483 "../lib/sudoku-board.vala"
								break;
#line 4121 "sudoku-board.c"
							}
#line 485 "../lib/sudoku-board.vala"
							_tmp7_ = self->cells;
#line 485 "../lib/sudoku-board.vala"
							_tmp7__length1 = self->cells_length1;
#line 485 "../lib/sudoku-board.vala"
							_tmp7__length2 = self->cells_length2;
#line 485 "../lib/sudoku-board.vala"
							_tmp8_ = _tmp7_[(l1 * _tmp7__length2) + l2];
#line 485 "../lib/sudoku-board.vala"
							if (_tmp8_ == 0) {
#line 4133 "sudoku-board.c"
								GeeList* possArrayList = NULL;
								GeeArrayList* _tmp9_;
								gint* possArray = NULL;
								gint _tmp10_ = 0;
								gint* _tmp11_;
								gint possArray_length1;
								gint _possArray_size_;
								gint* _tmp12_;
								gint _tmp12__length1;
								GeeHashMap* _tmp14_;
								Coord _tmp15_ = {0};
								GeeList* _tmp16_;
#line 487 "../lib/sudoku-board.vala"
								_tmp9_ = gee_array_list_new (G_TYPE_INT, NULL, NULL, NULL, NULL, NULL);
#line 487 "../lib/sudoku-board.vala"
								possArrayList = (GeeList*) _tmp9_;
#line 488 "../lib/sudoku-board.vala"
								_tmp11_ = sudoku_board_get_possibilities (self, l1, l2, &_tmp10_);
#line 488 "../lib/sudoku-board.vala"
								possArray = _tmp11_;
#line 488 "../lib/sudoku-board.vala"
								possArray_length1 = _tmp10_;
#line 488 "../lib/sudoku-board.vala"
								_possArray_size_ = possArray_length1;
#line 489 "../lib/sudoku-board.vala"
								_tmp12_ = possArray;
#line 489 "../lib/sudoku-board.vala"
								_tmp12__length1 = possArray_length1;
#line 4162 "sudoku-board.c"
								{
									gint* i_collection = NULL;
									gint i_collection_length1 = 0;
									gint _i_collection_size_ = 0;
									gint i_it = 0;
#line 489 "../lib/sudoku-board.vala"
									i_collection = _tmp12_;
#line 489 "../lib/sudoku-board.vala"
									i_collection_length1 = _tmp12__length1;
#line 489 "../lib/sudoku-board.vala"
									for (i_it = 0; i_it < _tmp12__length1; i_it = i_it + 1) {
#line 4174 "sudoku-board.c"
										gint i = 0;
#line 489 "../lib/sudoku-board.vala"
										i = i_collection[i_it];
#line 4178 "sudoku-board.c"
										{
											GeeList* _tmp13_;
#line 490 "../lib/sudoku-board.vala"
											_tmp13_ = possArrayList;
#line 490 "../lib/sudoku-board.vala"
											gee_collection_add ((GeeCollection*) _tmp13_, (gpointer) ((gintptr) i));
#line 4185 "sudoku-board.c"
										}
									}
								}
#line 491 "../lib/sudoku-board.vala"
								_tmp14_ = possibilities;
#line 491 "../lib/sudoku-board.vala"
								coord_init (&_tmp15_, l1, l2);
#line 491 "../lib/sudoku-board.vala"
								_tmp16_ = possArrayList;
#line 491 "../lib/sudoku-board.vala"
								gee_abstract_map_set ((GeeAbstractMap*) _tmp14_, &_tmp15_, _tmp16_);
#line 485 "../lib/sudoku-board.vala"
								possArray = (g_free (possArray), NULL);
#line 485 "../lib/sudoku-board.vala"
								_g_object_unref0 (possArrayList);
#line 4201 "sudoku-board.c"
							}
						}
					}
				}
			}
		}
	}
#line 495 "../lib/sudoku-board.vala"
	result = possibilities;
#line 495 "../lib/sudoku-board.vala"
	return result;
#line 4213 "sudoku-board.c"
}

gboolean
sudoku_board_is_finished (SudokuBoard* self)
{
	gboolean result = FALSE;
	gchar* board_string = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* finishgame_file = NULL;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	GFile* file = NULL;
	GFile* _tmp7_;
#line 498 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 500 "../lib/sudoku-board.vala"
	_tmp0_ = sudoku_board_to_string (self, TRUE);
#line 500 "../lib/sudoku-board.vala"
	_tmp1_ = _tmp0_;
#line 500 "../lib/sudoku-board.vala"
	_tmp2_ = g_strconcat (_tmp1_, ".save", NULL);
#line 500 "../lib/sudoku-board.vala"
	_tmp3_ = _tmp2_;
#line 500 "../lib/sudoku-board.vala"
	_g_free0 (_tmp1_);
#line 500 "../lib/sudoku-board.vala"
	board_string = _tmp3_;
#line 501 "../lib/sudoku-board.vala"
	_tmp4_ = sudoku_saver_get_finishgame_dir ();
#line 501 "../lib/sudoku-board.vala"
	_tmp5_ = _tmp4_;
#line 501 "../lib/sudoku-board.vala"
	_tmp6_ = g_build_path (G_DIR_SEPARATOR_S, _tmp5_, board_string, NULL);
#line 501 "../lib/sudoku-board.vala"
	finishgame_file = _tmp6_;
#line 502 "../lib/sudoku-board.vala"
	_tmp7_ = g_file_new_for_path (finishgame_file);
#line 502 "../lib/sudoku-board.vala"
	file = _tmp7_;
#line 504 "../lib/sudoku-board.vala"
	result = g_file_query_exists (file, NULL);
#line 504 "../lib/sudoku-board.vala"
	_g_object_unref0 (file);
#line 504 "../lib/sudoku-board.vala"
	_g_free0 (finishgame_file);
#line 504 "../lib/sudoku-board.vala"
	_g_free0 (board_string);
#line 504 "../lib/sudoku-board.vala"
	return result;
#line 4267 "sudoku-board.c"
}

gchar*
sudoku_board_get_earmarks_string (SudokuBoard* self,
                                  gint row,
                                  gint col)
{
	gchar* result = NULL;
	gchar* s = NULL;
	gchar* _tmp0_;
#line 507 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 509 "../lib/sudoku-board.vala"
	_tmp0_ = g_strdup ("");
#line 509 "../lib/sudoku-board.vala"
	s = _tmp0_;
#line 4284 "sudoku-board.c"
	{
		gint i = 0;
#line 510 "../lib/sudoku-board.vala"
		i = 1;
#line 4289 "sudoku-board.c"
		{
			gboolean _tmp1_ = FALSE;
#line 510 "../lib/sudoku-board.vala"
			_tmp1_ = TRUE;
#line 510 "../lib/sudoku-board.vala"
			while (TRUE) {
#line 4296 "sudoku-board.c"
				gint _tmp3_;
				gint _tmp4_;
				gboolean* _tmp5_;
				gint _tmp5__length1;
				gint _tmp5__length2;
				gint _tmp5__length3;
				gboolean _tmp6_;
#line 510 "../lib/sudoku-board.vala"
				if (!_tmp1_) {
#line 4306 "sudoku-board.c"
					gint _tmp2_;
#line 510 "../lib/sudoku-board.vala"
					_tmp2_ = i;
#line 510 "../lib/sudoku-board.vala"
					i = _tmp2_ + 1;
#line 4312 "sudoku-board.c"
				}
#line 510 "../lib/sudoku-board.vala"
				_tmp1_ = FALSE;
#line 510 "../lib/sudoku-board.vala"
				_tmp3_ = sudoku_board_get_max_val (self);
#line 510 "../lib/sudoku-board.vala"
				_tmp4_ = _tmp3_;
#line 510 "../lib/sudoku-board.vala"
				if (!(i <= _tmp4_)) {
#line 510 "../lib/sudoku-board.vala"
					break;
#line 4324 "sudoku-board.c"
				}
#line 511 "../lib/sudoku-board.vala"
				_tmp5_ = self->priv->earmarks;
#line 511 "../lib/sudoku-board.vala"
				_tmp5__length1 = self->priv->earmarks_length1;
#line 511 "../lib/sudoku-board.vala"
				_tmp5__length2 = self->priv->earmarks_length2;
#line 511 "../lib/sudoku-board.vala"
				_tmp5__length3 = self->priv->earmarks_length3;
#line 511 "../lib/sudoku-board.vala"
				_tmp6_ = _tmp5_[(((row * _tmp5__length2) + col) * _tmp5__length3) + (i - 1)];
#line 511 "../lib/sudoku-board.vala"
				if (_tmp6_) {
#line 4338 "sudoku-board.c"
					const gchar* _tmp7_;
					gchar* _tmp8_;
					gchar* _tmp9_;
					gchar* _tmp10_;
#line 512 "../lib/sudoku-board.vala"
					_tmp7_ = s;
#line 512 "../lib/sudoku-board.vala"
					_tmp8_ = g_strdup_printf ("%i", i);
#line 512 "../lib/sudoku-board.vala"
					_tmp9_ = _tmp8_;
#line 512 "../lib/sudoku-board.vala"
					_tmp10_ = g_strconcat (_tmp7_, _tmp9_, NULL);
#line 512 "../lib/sudoku-board.vala"
					_g_free0 (s);
#line 512 "../lib/sudoku-board.vala"
					s = _tmp10_;
#line 512 "../lib/sudoku-board.vala"
					_g_free0 (_tmp9_);
#line 4357 "sudoku-board.c"
				}
			}
		}
	}
#line 514 "../lib/sudoku-board.vala"
	result = s;
#line 514 "../lib/sudoku-board.vala"
	return result;
#line 4366 "sudoku-board.c"
}

gdouble
sudoku_board_get_previous_played_time (SudokuBoard* self)
{
	gdouble result;
#line 37 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 37 "../lib/sudoku-board.vala"
	result = self->priv->_previous_played_time;
#line 37 "../lib/sudoku-board.vala"
	return result;
#line 4379 "sudoku-board.c"
}

void
sudoku_board_set_previous_played_time (SudokuBoard* self,
                                       gdouble value)
{
#line 37 "../lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 37 "../lib/sudoku-board.vala"
	if (sudoku_board_get_previous_played_time (self) != value) {
#line 37 "../lib/sudoku-board.vala"
		self->priv->_previous_played_time = value;
#line 37 "../lib/sudoku-board.vala"
		g_object_notify_by_pspec ((GObject *) self, sudoku_board_properties[SUDOKU_BOARD_PREVIOUS_PLAYED_TIME_PROPERTY]);
#line 4394 "sudoku-board.c"
	}
}

DifficultyCategory
sudoku_board_get_difficulty_category (SudokuBoard* self)
{
	DifficultyCategory result;
	DifficultyCategory _tmp0_;
#line 39 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 39 "../lib/sudoku-board.vala"
	_tmp0_ = self->priv->_difficulty_category;
#line 39 "../lib/sudoku-board.vala"
	result = _tmp0_;
#line 39 "../lib/sudoku-board.vala"
	return result;
#line 4411 "sudoku-board.c"
}

void
sudoku_board_set_difficulty_category (SudokuBoard* self,
                                      DifficultyCategory value)
{
#line 39 "../lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 39 "../lib/sudoku-board.vala"
	if (sudoku_board_get_difficulty_category (self) != value) {
#line 39 "../lib/sudoku-board.vala"
		self->priv->_difficulty_category = value;
#line 39 "../lib/sudoku-board.vala"
		g_object_notify_by_pspec ((GObject *) self, sudoku_board_properties[SUDOKU_BOARD_DIFFICULTY_CATEGORY_PROPERTY]);
#line 4426 "sudoku-board.c"
	}
}

gint
sudoku_board_get_block_rows (SudokuBoard* self)
{
	gint result;
#line 42 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 42 "../lib/sudoku-board.vala"
	result = self->priv->_block_rows;
#line 42 "../lib/sudoku-board.vala"
	return result;
#line 4440 "sudoku-board.c"
}

static void
sudoku_board_set_block_rows (SudokuBoard* self,
                             gint value)
{
#line 42 "../lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 42 "../lib/sudoku-board.vala"
	if (sudoku_board_get_block_rows (self) != value) {
#line 42 "../lib/sudoku-board.vala"
		self->priv->_block_rows = value;
#line 42 "../lib/sudoku-board.vala"
		g_object_notify_by_pspec ((GObject *) self, sudoku_board_properties[SUDOKU_BOARD_BLOCK_ROWS_PROPERTY]);
#line 4455 "sudoku-board.c"
	}
}

gint
sudoku_board_get_block_cols (SudokuBoard* self)
{
	gint result;
#line 45 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 45 "../lib/sudoku-board.vala"
	result = self->priv->_block_cols;
#line 45 "../lib/sudoku-board.vala"
	return result;
#line 4469 "sudoku-board.c"
}

static void
sudoku_board_set_block_cols (SudokuBoard* self,
                             gint value)
{
#line 45 "../lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 45 "../lib/sudoku-board.vala"
	if (sudoku_board_get_block_cols (self) != value) {
#line 45 "../lib/sudoku-board.vala"
		self->priv->_block_cols = value;
#line 45 "../lib/sudoku-board.vala"
		g_object_notify_by_pspec ((GObject *) self, sudoku_board_properties[SUDOKU_BOARD_BLOCK_COLS_PROPERTY]);
#line 4484 "sudoku-board.c"
	}
}

gint
sudoku_board_get_rows (SudokuBoard* self)
{
	gint result;
#line 48 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 48 "../lib/sudoku-board.vala"
	result = self->priv->_rows;
#line 48 "../lib/sudoku-board.vala"
	return result;
#line 4498 "sudoku-board.c"
}

static void
sudoku_board_set_rows (SudokuBoard* self,
                       gint value)
{
#line 48 "../lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 48 "../lib/sudoku-board.vala"
	if (sudoku_board_get_rows (self) != value) {
#line 48 "../lib/sudoku-board.vala"
		self->priv->_rows = value;
#line 48 "../lib/sudoku-board.vala"
		g_object_notify_by_pspec ((GObject *) self, sudoku_board_properties[SUDOKU_BOARD_ROWS_PROPERTY]);
#line 4513 "sudoku-board.c"
	}
}

gint
sudoku_board_get_cols (SudokuBoard* self)
{
	gint result;
#line 51 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 51 "../lib/sudoku-board.vala"
	result = self->priv->_cols;
#line 51 "../lib/sudoku-board.vala"
	return result;
#line 4527 "sudoku-board.c"
}

static void
sudoku_board_set_cols (SudokuBoard* self,
                       gint value)
{
#line 51 "../lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 51 "../lib/sudoku-board.vala"
	if (sudoku_board_get_cols (self) != value) {
#line 51 "../lib/sudoku-board.vala"
		self->priv->_cols = value;
#line 51 "../lib/sudoku-board.vala"
		g_object_notify_by_pspec ((GObject *) self, sudoku_board_properties[SUDOKU_BOARD_COLS_PROPERTY]);
#line 4542 "sudoku-board.c"
	}
}

gint
sudoku_board_get_max_val (SudokuBoard* self)
{
	gint result;
	gint _tmp0_;
	gint _tmp1_;
#line 56 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 56 "../lib/sudoku-board.vala"
	_tmp0_ = self->priv->_block_rows;
#line 56 "../lib/sudoku-board.vala"
	_tmp1_ = self->priv->_block_cols;
#line 56 "../lib/sudoku-board.vala"
	result = _tmp0_ * _tmp1_;
#line 56 "../lib/sudoku-board.vala"
	return result;
#line 4562 "sudoku-board.c"
}

gboolean
sudoku_board_get_broken (SudokuBoard* self)
{
	gboolean result;
	GeeSet* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 61 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 61 "../lib/sudoku-board.vala"
	_tmp0_ = self->broken_coords;
#line 61 "../lib/sudoku-board.vala"
	_tmp1_ = gee_collection_get_size ((GeeCollection*) _tmp0_);
#line 61 "../lib/sudoku-board.vala"
	_tmp2_ = _tmp1_;
#line 61 "../lib/sudoku-board.vala"
	result = _tmp2_ != 0;
#line 61 "../lib/sudoku-board.vala"
	return result;
#line 4584 "sudoku-board.c"
}

gint
sudoku_board_get_filled (SudokuBoard* self)
{
	gint result;
#line 65 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 65 "../lib/sudoku-board.vala"
	result = self->priv->_filled;
#line 65 "../lib/sudoku-board.vala"
	return result;
#line 4597 "sudoku-board.c"
}

static void
sudoku_board_set_filled (SudokuBoard* self,
                         gint value)
{
#line 65 "../lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 65 "../lib/sudoku-board.vala"
	if (sudoku_board_get_filled (self) != value) {
#line 65 "../lib/sudoku-board.vala"
		self->priv->_filled = value;
#line 65 "../lib/sudoku-board.vala"
		g_object_notify_by_pspec ((GObject *) self, sudoku_board_properties[SUDOKU_BOARD_FILLED_PROPERTY]);
#line 4612 "sudoku-board.c"
	}
}

gint
sudoku_board_get_fixed (SudokuBoard* self)
{
	gint result;
#line 68 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 68 "../lib/sudoku-board.vala"
	result = self->priv->_fixed;
#line 68 "../lib/sudoku-board.vala"
	return result;
#line 4626 "sudoku-board.c"
}

static void
sudoku_board_set_fixed (SudokuBoard* self,
                        gint value)
{
#line 68 "../lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 68 "../lib/sudoku-board.vala"
	if (sudoku_board_get_fixed (self) != value) {
#line 68 "../lib/sudoku-board.vala"
		self->priv->_fixed = value;
#line 68 "../lib/sudoku-board.vala"
		g_object_notify_by_pspec ((GObject *) self, sudoku_board_properties[SUDOKU_BOARD_FIXED_PROPERTY]);
#line 4641 "sudoku-board.c"
	}
}

gint
sudoku_board_get_size (SudokuBoard* self)
{
	gint result;
	gint _tmp0_;
	gint _tmp1_;
#line 72 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 72 "../lib/sudoku-board.vala"
	_tmp0_ = self->priv->_rows;
#line 72 "../lib/sudoku-board.vala"
	_tmp1_ = self->priv->_cols;
#line 72 "../lib/sudoku-board.vala"
	result = _tmp0_ * _tmp1_;
#line 72 "../lib/sudoku-board.vala"
	return result;
#line 4661 "sudoku-board.c"
}

gboolean
sudoku_board_get_complete (SudokuBoard* self)
{
	gboolean result;
	gboolean _tmp0_ = FALSE;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
#line 77 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 77 "../lib/sudoku-board.vala"
	_tmp1_ = self->priv->_filled;
#line 77 "../lib/sudoku-board.vala"
	_tmp2_ = self->priv->_cols;
#line 77 "../lib/sudoku-board.vala"
	_tmp3_ = self->priv->_rows;
#line 77 "../lib/sudoku-board.vala"
	if (_tmp1_ == (_tmp2_ * _tmp3_)) {
#line 4682 "sudoku-board.c"
		gboolean _tmp4_;
		gboolean _tmp5_;
#line 77 "../lib/sudoku-board.vala"
		_tmp4_ = sudoku_board_get_broken (self);
#line 77 "../lib/sudoku-board.vala"
		_tmp5_ = _tmp4_;
#line 77 "../lib/sudoku-board.vala"
		_tmp0_ = !_tmp5_;
#line 4691 "sudoku-board.c"
	} else {
#line 77 "../lib/sudoku-board.vala"
		_tmp0_ = FALSE;
#line 4695 "sudoku-board.c"
	}
#line 77 "../lib/sudoku-board.vala"
	result = _tmp0_;
#line 77 "../lib/sudoku-board.vala"
	return result;
#line 4701 "sudoku-board.c"
}

static void
sudoku_board_class_init (SudokuBoardClass * klass,
                         gpointer klass_data)
{
#line 24 "../lib/sudoku-board.vala"
	sudoku_board_parent_class = g_type_class_peek_parent (klass);
#line 24 "../lib/sudoku-board.vala"
	g_type_class_adjust_private_offset (klass, &SudokuBoard_private_offset);
#line 24 "../lib/sudoku-board.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_sudoku_board_get_property;
#line 24 "../lib/sudoku-board.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_sudoku_board_set_property;
#line 24 "../lib/sudoku-board.vala"
	G_OBJECT_CLASS (klass)->finalize = sudoku_board_finalize;
#line 24 "../lib/sudoku-board.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_BOARD_PREVIOUS_PLAYED_TIME_PROPERTY, sudoku_board_properties[SUDOKU_BOARD_PREVIOUS_PLAYED_TIME_PROPERTY] = g_param_spec_double ("previous-played-time", "previous-played-time", "previous-played-time", -G_MAXDOUBLE, G_MAXDOUBLE, (gdouble) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../lib/sudoku-board.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_BOARD_DIFFICULTY_CATEGORY_PROPERTY, sudoku_board_properties[SUDOKU_BOARD_DIFFICULTY_CATEGORY_PROPERTY] = g_param_spec_enum ("difficulty-category", "difficulty-category", "difficulty-category", TYPE_DIFFICULTY_CATEGORY, DIFFICULTY_CATEGORY_UNKNOWN, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../lib/sudoku-board.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_BOARD_BLOCK_ROWS_PROPERTY, sudoku_board_properties[SUDOKU_BOARD_BLOCK_ROWS_PROPERTY] = g_param_spec_int ("block-rows", "block-rows", "block-rows", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 24 "../lib/sudoku-board.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_BOARD_BLOCK_COLS_PROPERTY, sudoku_board_properties[SUDOKU_BOARD_BLOCK_COLS_PROPERTY] = g_param_spec_int ("block-cols", "block-cols", "block-cols", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 24 "../lib/sudoku-board.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_BOARD_ROWS_PROPERTY, sudoku_board_properties[SUDOKU_BOARD_ROWS_PROPERTY] = g_param_spec_int ("rows", "rows", "rows", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 24 "../lib/sudoku-board.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_BOARD_COLS_PROPERTY, sudoku_board_properties[SUDOKU_BOARD_COLS_PROPERTY] = g_param_spec_int ("cols", "cols", "cols", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 24 "../lib/sudoku-board.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_BOARD_MAX_VAL_PROPERTY, sudoku_board_properties[SUDOKU_BOARD_MAX_VAL_PROPERTY] = g_param_spec_int ("max-val", "max-val", "max-val", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 24 "../lib/sudoku-board.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_BOARD_BROKEN_PROPERTY, sudoku_board_properties[SUDOKU_BOARD_BROKEN_PROPERTY] = g_param_spec_boolean ("broken", "broken", "broken", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 24 "../lib/sudoku-board.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_BOARD_FILLED_PROPERTY, sudoku_board_properties[SUDOKU_BOARD_FILLED_PROPERTY] = g_param_spec_int ("filled", "filled", "filled", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 24 "../lib/sudoku-board.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_BOARD_FIXED_PROPERTY, sudoku_board_properties[SUDOKU_BOARD_FIXED_PROPERTY] = g_param_spec_int ("fixed", "fixed", "fixed", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 24 "../lib/sudoku-board.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_BOARD_SIZE_PROPERTY, sudoku_board_properties[SUDOKU_BOARD_SIZE_PROPERTY] = g_param_spec_int ("size", "size", "size", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 24 "../lib/sudoku-board.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_BOARD_COMPLETE_PROPERTY, sudoku_board_properties[SUDOKU_BOARD_COMPLETE_PROPERTY] = g_param_spec_boolean ("complete", "complete", "complete", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 24 "../lib/sudoku-board.vala"
	sudoku_board_signals[SUDOKU_BOARD_COMPLETED_SIGNAL] = g_signal_new ("completed", TYPE_SUDOKU_BOARD, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 4744 "sudoku-board.c"
}

static void
sudoku_board_instance_init (SudokuBoard * self,
                            gpointer klass)
{
#line 24 "../lib/sudoku-board.vala"
	self->priv = sudoku_board_get_instance_private (self);
#line 37 "../lib/sudoku-board.vala"
	self->priv->_previous_played_time = (gdouble) 0;
#line 39 "../lib/sudoku-board.vala"
	self->priv->_difficulty_category = DIFFICULTY_CATEGORY_UNKNOWN;
#line 4757 "sudoku-board.c"
}

static void
sudoku_board_finalize (GObject * obj)
{
	SudokuBoard * self;
#line 24 "../lib/sudoku-board.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SUDOKU_BOARD, SudokuBoard);
#line 28 "../lib/sudoku-board.vala"
	self->cells = (g_free (self->cells), NULL);
#line 29 "../lib/sudoku-board.vala"
	self->is_fixed = (g_free (self->is_fixed), NULL);
#line 30 "../lib/sudoku-board.vala"
	self->priv->possible_in_row = (g_free (self->priv->possible_in_row), NULL);
#line 31 "../lib/sudoku-board.vala"
	self->priv->possible_in_col = (g_free (self->priv->possible_in_col), NULL);
#line 32 "../lib/sudoku-board.vala"
	self->priv->possible_in_block = (g_free (self->priv->possible_in_block), NULL);
#line 34 "../lib/sudoku-board.vala"
	self->priv->earmarks = (g_free (self->priv->earmarks), NULL);
#line 93 "../lib/sudoku-board.vala"
	_g_object_unref0 (self->broken_coords);
#line 96 "../lib/sudoku-board.vala"
	_g_object_unref0 (self->coords_for_col);
#line 99 "../lib/sudoku-board.vala"
	_g_object_unref0 (self->coords_for_row);
#line 102 "../lib/sudoku-board.vala"
	_g_object_unref0 (self->coords_for_block);
#line 24 "../lib/sudoku-board.vala"
	G_OBJECT_CLASS (sudoku_board_parent_class)->finalize (obj);
#line 4788 "sudoku-board.c"
}

GType
sudoku_board_get_type (void)
{
	static volatile gsize sudoku_board_type_id__volatile = 0;
	if (g_once_init_enter (&sudoku_board_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SudokuBoardClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sudoku_board_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SudokuBoard), 0, (GInstanceInitFunc) sudoku_board_instance_init, NULL };
		GType sudoku_board_type_id;
		sudoku_board_type_id = g_type_register_static (G_TYPE_OBJECT, "SudokuBoard", &g_define_type_info, 0);
		SudokuBoard_private_offset = g_type_add_instance_private (sudoku_board_type_id, sizeof (SudokuBoardPrivate));
		g_once_init_leave (&sudoku_board_type_id__volatile, sudoku_board_type_id);
	}
	return sudoku_board_type_id__volatile;
}

static void
_vala_sudoku_board_get_property (GObject * object,
                                 guint property_id,
                                 GValue * value,
                                 GParamSpec * pspec)
{
	SudokuBoard * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SUDOKU_BOARD, SudokuBoard);
#line 24 "../lib/sudoku-board.vala"
	switch (property_id) {
#line 24 "../lib/sudoku-board.vala"
		case SUDOKU_BOARD_PREVIOUS_PLAYED_TIME_PROPERTY:
#line 24 "../lib/sudoku-board.vala"
		g_value_set_double (value, sudoku_board_get_previous_played_time (self));
#line 24 "../lib/sudoku-board.vala"
		break;
#line 24 "../lib/sudoku-board.vala"
		case SUDOKU_BOARD_DIFFICULTY_CATEGORY_PROPERTY:
#line 24 "../lib/sudoku-board.vala"
		g_value_set_enum (value, sudoku_board_get_difficulty_category (self));
#line 24 "../lib/sudoku-board.vala"
		break;
#line 24 "../lib/sudoku-board.vala"
		case SUDOKU_BOARD_BLOCK_ROWS_PROPERTY:
#line 24 "../lib/sudoku-board.vala"
		g_value_set_int (value, sudoku_board_get_block_rows (self));
#line 24 "../lib/sudoku-board.vala"
		break;
#line 24 "../lib/sudoku-board.vala"
		case SUDOKU_BOARD_BLOCK_COLS_PROPERTY:
#line 24 "../lib/sudoku-board.vala"
		g_value_set_int (value, sudoku_board_get_block_cols (self));
#line 24 "../lib/sudoku-board.vala"
		break;
#line 24 "../lib/sudoku-board.vala"
		case SUDOKU_BOARD_ROWS_PROPERTY:
#line 24 "../lib/sudoku-board.vala"
		g_value_set_int (value, sudoku_board_get_rows (self));
#line 24 "../lib/sudoku-board.vala"
		break;
#line 24 "../lib/sudoku-board.vala"
		case SUDOKU_BOARD_COLS_PROPERTY:
#line 24 "../lib/sudoku-board.vala"
		g_value_set_int (value, sudoku_board_get_cols (self));
#line 24 "../lib/sudoku-board.vala"
		break;
#line 24 "../lib/sudoku-board.vala"
		case SUDOKU_BOARD_MAX_VAL_PROPERTY:
#line 24 "../lib/sudoku-board.vala"
		g_value_set_int (value, sudoku_board_get_max_val (self));
#line 24 "../lib/sudoku-board.vala"
		break;
#line 24 "../lib/sudoku-board.vala"
		case SUDOKU_BOARD_BROKEN_PROPERTY:
#line 24 "../lib/sudoku-board.vala"
		g_value_set_boolean (value, sudoku_board_get_broken (self));
#line 24 "../lib/sudoku-board.vala"
		break;
#line 24 "../lib/sudoku-board.vala"
		case SUDOKU_BOARD_FILLED_PROPERTY:
#line 24 "../lib/sudoku-board.vala"
		g_value_set_int (value, sudoku_board_get_filled (self));
#line 24 "../lib/sudoku-board.vala"
		break;
#line 24 "../lib/sudoku-board.vala"
		case SUDOKU_BOARD_FIXED_PROPERTY:
#line 24 "../lib/sudoku-board.vala"
		g_value_set_int (value, sudoku_board_get_fixed (self));
#line 24 "../lib/sudoku-board.vala"
		break;
#line 24 "../lib/sudoku-board.vala"
		case SUDOKU_BOARD_SIZE_PROPERTY:
#line 24 "../lib/sudoku-board.vala"
		g_value_set_int (value, sudoku_board_get_size (self));
#line 24 "../lib/sudoku-board.vala"
		break;
#line 24 "../lib/sudoku-board.vala"
		case SUDOKU_BOARD_COMPLETE_PROPERTY:
#line 24 "../lib/sudoku-board.vala"
		g_value_set_boolean (value, sudoku_board_get_complete (self));
#line 24 "../lib/sudoku-board.vala"
		break;
#line 4887 "sudoku-board.c"
		default:
#line 24 "../lib/sudoku-board.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../lib/sudoku-board.vala"
		break;
#line 4893 "sudoku-board.c"
	}
}

static void
_vala_sudoku_board_set_property (GObject * object,
                                 guint property_id,
                                 const GValue * value,
                                 GParamSpec * pspec)
{
	SudokuBoard * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SUDOKU_BOARD, SudokuBoard);
#line 24 "../lib/sudoku-board.vala"
	switch (property_id) {
#line 24 "../lib/sudoku-board.vala"
		case SUDOKU_BOARD_PREVIOUS_PLAYED_TIME_PROPERTY:
#line 24 "../lib/sudoku-board.vala"
		sudoku_board_set_previous_played_time (self, g_value_get_double (value));
#line 24 "../lib/sudoku-board.vala"
		break;
#line 24 "../lib/sudoku-board.vala"
		case SUDOKU_BOARD_DIFFICULTY_CATEGORY_PROPERTY:
#line 24 "../lib/sudoku-board.vala"
		sudoku_board_set_difficulty_category (self, g_value_get_enum (value));
#line 24 "../lib/sudoku-board.vala"
		break;
#line 24 "../lib/sudoku-board.vala"
		case SUDOKU_BOARD_BLOCK_ROWS_PROPERTY:
#line 24 "../lib/sudoku-board.vala"
		sudoku_board_set_block_rows (self, g_value_get_int (value));
#line 24 "../lib/sudoku-board.vala"
		break;
#line 24 "../lib/sudoku-board.vala"
		case SUDOKU_BOARD_BLOCK_COLS_PROPERTY:
#line 24 "../lib/sudoku-board.vala"
		sudoku_board_set_block_cols (self, g_value_get_int (value));
#line 24 "../lib/sudoku-board.vala"
		break;
#line 24 "../lib/sudoku-board.vala"
		case SUDOKU_BOARD_ROWS_PROPERTY:
#line 24 "../lib/sudoku-board.vala"
		sudoku_board_set_rows (self, g_value_get_int (value));
#line 24 "../lib/sudoku-board.vala"
		break;
#line 24 "../lib/sudoku-board.vala"
		case SUDOKU_BOARD_COLS_PROPERTY:
#line 24 "../lib/sudoku-board.vala"
		sudoku_board_set_cols (self, g_value_get_int (value));
#line 24 "../lib/sudoku-board.vala"
		break;
#line 24 "../lib/sudoku-board.vala"
		case SUDOKU_BOARD_FILLED_PROPERTY:
#line 24 "../lib/sudoku-board.vala"
		sudoku_board_set_filled (self, g_value_get_int (value));
#line 24 "../lib/sudoku-board.vala"
		break;
#line 24 "../lib/sudoku-board.vala"
		case SUDOKU_BOARD_FIXED_PROPERTY:
#line 24 "../lib/sudoku-board.vala"
		sudoku_board_set_fixed (self, g_value_get_int (value));
#line 24 "../lib/sudoku-board.vala"
		break;
#line 4955 "sudoku-board.c"
		default:
#line 24 "../lib/sudoku-board.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../lib/sudoku-board.vala"
		break;
#line 4961 "sudoku-board.c"
	}
}

GType
house_get_type (void)
{
	static volatile gsize house_type_id__volatile = 0;
	if (g_once_init_enter (&house_type_id__volatile)) {
		static const GEnumValue values[] = {{HOUSE_ROW, "HOUSE_ROW", "row"}, {HOUSE_COLUMN, "HOUSE_COLUMN", "column"}, {HOUSE_BLOCK, "HOUSE_BLOCK", "block"}, {0, NULL, NULL}};
		GType house_type_id;
		house_type_id = g_enum_register_static ("House", values);
		g_once_init_leave (&house_type_id__volatile, house_type_id);
	}
	return house_type_id__volatile;
}

void
coord_init (Coord *self,
            gint row,
            gint col)
{
#line 530 "../lib/sudoku-board.vala"
	memset (self, 0, sizeof (Coord));
#line 532 "../lib/sudoku-board.vala"
	(*self).row = row;
#line 533 "../lib/sudoku-board.vala"
	(*self).col = col;
#line 4989 "sudoku-board.c"
}

gint
coord_hash (Coord* coord)
{
	gint result = 0;
	Coord _tmp0_;
	Coord _tmp1_;
#line 536 "../lib/sudoku-board.vala"
	g_return_val_if_fail (coord != NULL, 0);
#line 538 "../lib/sudoku-board.vala"
	_tmp0_ = *coord;
#line 538 "../lib/sudoku-board.vala"
	_tmp1_ = *coord;
#line 538 "../lib/sudoku-board.vala"
	result = (_tmp0_.row * 33) ^ _tmp1_.col;
#line 538 "../lib/sudoku-board.vala"
	return result;
#line 5008 "sudoku-board.c"
}

gboolean
coord_equal (Coord* a,
             Coord* b)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	Coord _tmp1_;
	Coord _tmp2_;
#line 541 "../lib/sudoku-board.vala"
	g_return_val_if_fail (a != NULL, FALSE);
#line 541 "../lib/sudoku-board.vala"
	g_return_val_if_fail (b != NULL, FALSE);
#line 543 "../lib/sudoku-board.vala"
	_tmp1_ = *a;
#line 543 "../lib/sudoku-board.vala"
	_tmp2_ = *b;
#line 543 "../lib/sudoku-board.vala"
	if (_tmp1_.row == _tmp2_.row) {
#line 5029 "sudoku-board.c"
		Coord _tmp3_;
		Coord _tmp4_;
#line 543 "../lib/sudoku-board.vala"
		_tmp3_ = *a;
#line 543 "../lib/sudoku-board.vala"
		_tmp4_ = *b;
#line 543 "../lib/sudoku-board.vala"
		_tmp0_ = _tmp3_.col == _tmp4_.col;
#line 5038 "sudoku-board.c"
	} else {
#line 543 "../lib/sudoku-board.vala"
		_tmp0_ = FALSE;
#line 5042 "sudoku-board.c"
	}
#line 543 "../lib/sudoku-board.vala"
	result = _tmp0_;
#line 543 "../lib/sudoku-board.vala"
	return result;
#line 5048 "sudoku-board.c"
}

Coord*
coord_dup (const Coord* self)
{
	Coord* dup;
#line 525 "../lib/sudoku-board.vala"
	dup = g_new0 (Coord, 1);
#line 525 "../lib/sudoku-board.vala"
	memcpy (dup, self, sizeof (Coord));
#line 525 "../lib/sudoku-board.vala"
	return dup;
#line 5061 "sudoku-board.c"
}

void
coord_free (Coord* self)
{
#line 525 "../lib/sudoku-board.vala"
	g_free (self);
#line 5069 "sudoku-board.c"
}

GType
coord_get_type (void)
{
	static volatile gsize coord_type_id__volatile = 0;
	if (g_once_init_enter (&coord_type_id__volatile)) {
		GType coord_type_id;
		coord_type_id = g_boxed_type_register_static ("Coord", (GBoxedCopyFunc) coord_dup, (GBoxedFreeFunc) coord_free);
		g_once_init_leave (&coord_type_id__volatile, coord_type_id);
	}
	return coord_type_id__volatile;
}

void
cell_init (Cell *self,
           Coord* coord,
           gint val)
{
	Coord _tmp0_;
#line 552 "../lib/sudoku-board.vala"
	g_return_if_fail (coord != NULL);
#line 552 "../lib/sudoku-board.vala"
	memset (self, 0, sizeof (Cell));
#line 554 "../lib/sudoku-board.vala"
	_tmp0_ = *coord;
#line 554 "../lib/sudoku-board.vala"
	(*self).coord = _tmp0_;
#line 555 "../lib/sudoku-board.vala"
	(*self).val = val;
#line 5100 "sudoku-board.c"
}

gint
cell_hash (Cell* cell)
{
	gint result = 0;
	Cell _tmp0_;
	Coord _tmp1_;
	Cell _tmp2_;
#line 558 "../lib/sudoku-board.vala"
	g_return_val_if_fail (cell != NULL, 0);
#line 560 "../lib/sudoku-board.vala"
	_tmp0_ = *cell;
#line 560 "../lib/sudoku-board.vala"
	_tmp1_ = _tmp0_.coord;
#line 560 "../lib/sudoku-board.vala"
	_tmp2_ = *cell;
#line 560 "../lib/sudoku-board.vala"
	result = (coord_hash (&_tmp1_) * 33) ^ _tmp2_.val;
#line 560 "../lib/sudoku-board.vala"
	return result;
#line 5122 "sudoku-board.c"
}

gboolean
cell_equal (Cell* a,
            Cell* b)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	Cell _tmp1_;
	Coord _tmp2_;
	Cell _tmp3_;
	Coord _tmp4_;
#line 563 "../lib/sudoku-board.vala"
	g_return_val_if_fail (a != NULL, FALSE);
#line 563 "../lib/sudoku-board.vala"
	g_return_val_if_fail (b != NULL, FALSE);
#line 565 "../lib/sudoku-board.vala"
	_tmp1_ = *a;
#line 565 "../lib/sudoku-board.vala"
	_tmp2_ = _tmp1_.coord;
#line 565 "../lib/sudoku-board.vala"
	_tmp3_ = *b;
#line 565 "../lib/sudoku-board.vala"
	_tmp4_ = _tmp3_.coord;
#line 565 "../lib/sudoku-board.vala"
	if (coord_equal (&_tmp2_, &_tmp4_)) {
#line 5149 "sudoku-board.c"
		Cell _tmp5_;
		Cell _tmp6_;
#line 565 "../lib/sudoku-board.vala"
		_tmp5_ = *a;
#line 565 "../lib/sudoku-board.vala"
		_tmp6_ = *b;
#line 565 "../lib/sudoku-board.vala"
		_tmp0_ = _tmp5_.val == _tmp6_.val;
#line 5158 "sudoku-board.c"
	} else {
#line 565 "../lib/sudoku-board.vala"
		_tmp0_ = FALSE;
#line 5162 "sudoku-board.c"
	}
#line 565 "../lib/sudoku-board.vala"
	result = _tmp0_;
#line 565 "../lib/sudoku-board.vala"
	return result;
#line 5168 "sudoku-board.c"
}

Cell*
cell_dup (const Cell* self)
{
	Cell* dup;
#line 547 "../lib/sudoku-board.vala"
	dup = g_new0 (Cell, 1);
#line 547 "../lib/sudoku-board.vala"
	memcpy (dup, self, sizeof (Cell));
#line 547 "../lib/sudoku-board.vala"
	return dup;
#line 5181 "sudoku-board.c"
}

void
cell_free (Cell* self)
{
#line 547 "../lib/sudoku-board.vala"
	g_free (self);
#line 5189 "sudoku-board.c"
}

GType
cell_get_type (void)
{
	static volatile gsize cell_type_id__volatile = 0;
	if (g_once_init_enter (&cell_type_id__volatile)) {
		GType cell_type_id;
		cell_type_id = g_boxed_type_register_static ("Cell", (GBoxedCopyFunc) cell_dup, (GBoxedFreeFunc) cell_free);
		g_once_init_leave (&cell_type_id__volatile, cell_type_id);
	}
	return cell_type_id__volatile;
}

gchar*
difficulty_category_to_string (DifficultyCategory self)
{
	gchar* result = NULL;
#line 580 "../lib/sudoku-board.vala"
	switch (self) {
#line 580 "../lib/sudoku-board.vala"
		case DIFFICULTY_CATEGORY_UNKNOWN:
#line 5212 "sudoku-board.c"
		{
			gchar* _tmp0_;
#line 583 "../lib/sudoku-board.vala"
			_tmp0_ = g_strdup (_ ("Unknown Difficulty"));
#line 583 "../lib/sudoku-board.vala"
			result = _tmp0_;
#line 583 "../lib/sudoku-board.vala"
			return result;
#line 5221 "sudoku-board.c"
		}
#line 580 "../lib/sudoku-board.vala"
		case DIFFICULTY_CATEGORY_EASY:
#line 5225 "sudoku-board.c"
		{
			gchar* _tmp1_;
#line 585 "../lib/sudoku-board.vala"
			_tmp1_ = g_strdup (_ ("Easy Difficulty"));
#line 585 "../lib/sudoku-board.vala"
			result = _tmp1_;
#line 585 "../lib/sudoku-board.vala"
			return result;
#line 5234 "sudoku-board.c"
		}
#line 580 "../lib/sudoku-board.vala"
		case DIFFICULTY_CATEGORY_MEDIUM:
#line 5238 "sudoku-board.c"
		{
			gchar* _tmp2_;
#line 587 "../lib/sudoku-board.vala"
			_tmp2_ = g_strdup (_ ("Medium Difficulty"));
#line 587 "../lib/sudoku-board.vala"
			result = _tmp2_;
#line 587 "../lib/sudoku-board.vala"
			return result;
#line 5247 "sudoku-board.c"
		}
#line 580 "../lib/sudoku-board.vala"
		case DIFFICULTY_CATEGORY_HARD:
#line 5251 "sudoku-board.c"
		{
			gchar* _tmp3_;
#line 589 "../lib/sudoku-board.vala"
			_tmp3_ = g_strdup (_ ("Hard Difficulty"));
#line 589 "../lib/sudoku-board.vala"
			result = _tmp3_;
#line 589 "../lib/sudoku-board.vala"
			return result;
#line 5260 "sudoku-board.c"
		}
#line 580 "../lib/sudoku-board.vala"
		case DIFFICULTY_CATEGORY_VERY_HARD:
#line 5264 "sudoku-board.c"
		{
			gchar* _tmp4_;
#line 591 "../lib/sudoku-board.vala"
			_tmp4_ = g_strdup (_ ("Very Hard Difficulty"));
#line 591 "../lib/sudoku-board.vala"
			result = _tmp4_;
#line 591 "../lib/sudoku-board.vala"
			return result;
#line 5273 "sudoku-board.c"
		}
#line 580 "../lib/sudoku-board.vala"
		case DIFFICULTY_CATEGORY_CUSTOM:
#line 5277 "sudoku-board.c"
		{
			gchar* _tmp5_;
#line 593 "../lib/sudoku-board.vala"
			_tmp5_ = g_strdup (_ ("Custom Puzzle"));
#line 593 "../lib/sudoku-board.vala"
			result = _tmp5_;
#line 593 "../lib/sudoku-board.vala"
			return result;
#line 5286 "sudoku-board.c"
		}
		default:
		{
#line 595 "../lib/sudoku-board.vala"
			g_assert_not_reached ();
#line 5292 "sudoku-board.c"
		}
	}
}

gchar*
difficulty_category_to_untranslated_string (DifficultyCategory self)
{
	gchar* result = NULL;
#line 601 "../lib/sudoku-board.vala"
	switch (self) {
#line 601 "../lib/sudoku-board.vala"
		case DIFFICULTY_CATEGORY_UNKNOWN:
#line 5305 "sudoku-board.c"
		{
			gchar* _tmp0_;
#line 604 "../lib/sudoku-board.vala"
			_tmp0_ = g_strdup ("Unknown Difficulty");
#line 604 "../lib/sudoku-board.vala"
			result = _tmp0_;
#line 604 "../lib/sudoku-board.vala"
			return result;
#line 5314 "sudoku-board.c"
		}
#line 601 "../lib/sudoku-board.vala"
		case DIFFICULTY_CATEGORY_EASY:
#line 5318 "sudoku-board.c"
		{
			gchar* _tmp1_;
#line 606 "../lib/sudoku-board.vala"
			_tmp1_ = g_strdup ("Easy Difficulty");
#line 606 "../lib/sudoku-board.vala"
			result = _tmp1_;
#line 606 "../lib/sudoku-board.vala"
			return result;
#line 5327 "sudoku-board.c"
		}
#line 601 "../lib/sudoku-board.vala"
		case DIFFICULTY_CATEGORY_MEDIUM:
#line 5331 "sudoku-board.c"
		{
			gchar* _tmp2_;
#line 608 "../lib/sudoku-board.vala"
			_tmp2_ = g_strdup ("Medium Difficulty");
#line 608 "../lib/sudoku-board.vala"
			result = _tmp2_;
#line 608 "../lib/sudoku-board.vala"
			return result;
#line 5340 "sudoku-board.c"
		}
#line 601 "../lib/sudoku-board.vala"
		case DIFFICULTY_CATEGORY_HARD:
#line 5344 "sudoku-board.c"
		{
			gchar* _tmp3_;
#line 610 "../lib/sudoku-board.vala"
			_tmp3_ = g_strdup ("Hard Difficulty");
#line 610 "../lib/sudoku-board.vala"
			result = _tmp3_;
#line 610 "../lib/sudoku-board.vala"
			return result;
#line 5353 "sudoku-board.c"
		}
#line 601 "../lib/sudoku-board.vala"
		case DIFFICULTY_CATEGORY_VERY_HARD:
#line 5357 "sudoku-board.c"
		{
			gchar* _tmp4_;
#line 612 "../lib/sudoku-board.vala"
			_tmp4_ = g_strdup ("Very Hard Difficulty");
#line 612 "../lib/sudoku-board.vala"
			result = _tmp4_;
#line 612 "../lib/sudoku-board.vala"
			return result;
#line 5366 "sudoku-board.c"
		}
#line 601 "../lib/sudoku-board.vala"
		case DIFFICULTY_CATEGORY_CUSTOM:
#line 5370 "sudoku-board.c"
		{
			gchar* _tmp5_;
#line 614 "../lib/sudoku-board.vala"
			_tmp5_ = g_strdup ("Custom Puzzle");
#line 614 "../lib/sudoku-board.vala"
			result = _tmp5_;
#line 614 "../lib/sudoku-board.vala"
			return result;
#line 5379 "sudoku-board.c"
		}
		default:
		{
#line 616 "../lib/sudoku-board.vala"
			g_assert_not_reached ();
#line 5385 "sudoku-board.c"
		}
	}
}

DifficultyCategory
difficulty_category_from_string (const gchar* input)
{
	DifficultyCategory result = 0;
	const gchar* _tmp0_;
	GQuark _tmp2_ = 0U;
#line 622 "../lib/sudoku-board.vala"
	static GQuark _tmp1_label0 = 0;
#line 622 "../lib/sudoku-board.vala"
	static GQuark _tmp1_label1 = 0;
#line 622 "../lib/sudoku-board.vala"
	static GQuark _tmp1_label2 = 0;
#line 622 "../lib/sudoku-board.vala"
	static GQuark _tmp1_label3 = 0;
#line 622 "../lib/sudoku-board.vala"
	static GQuark _tmp1_label4 = 0;
#line 622 "../lib/sudoku-board.vala"
	static GQuark _tmp1_label5 = 0;
#line 620 "../lib/sudoku-board.vala"
	g_return_val_if_fail (input != NULL, 0);
#line 622 "../lib/sudoku-board.vala"
	_tmp0_ = input;
#line 622 "../lib/sudoku-board.vala"
	_tmp2_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
#line 622 "../lib/sudoku-board.vala"
	if (_tmp2_ == ((0 != _tmp1_label0) ? _tmp1_label0 : (_tmp1_label0 = g_quark_from_static_string ("Unknown Difficulty")))) {
#line 622 "../lib/sudoku-board.vala"
		switch (0) {
#line 5418 "sudoku-board.c"
			default:
			{
#line 625 "../lib/sudoku-board.vala"
				result = DIFFICULTY_CATEGORY_UNKNOWN;
#line 625 "../lib/sudoku-board.vala"
				return result;
#line 5425 "sudoku-board.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label1) ? _tmp1_label1 : (_tmp1_label1 = g_quark_from_static_string ("Easy Difficulty")))) {
#line 622 "../lib/sudoku-board.vala"
		switch (0) {
#line 5431 "sudoku-board.c"
			default:
			{
#line 627 "../lib/sudoku-board.vala"
				result = DIFFICULTY_CATEGORY_EASY;
#line 627 "../lib/sudoku-board.vala"
				return result;
#line 5438 "sudoku-board.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label2) ? _tmp1_label2 : (_tmp1_label2 = g_quark_from_static_string ("Medium Difficulty")))) {
#line 622 "../lib/sudoku-board.vala"
		switch (0) {
#line 5444 "sudoku-board.c"
			default:
			{
#line 629 "../lib/sudoku-board.vala"
				result = DIFFICULTY_CATEGORY_MEDIUM;
#line 629 "../lib/sudoku-board.vala"
				return result;
#line 5451 "sudoku-board.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label3) ? _tmp1_label3 : (_tmp1_label3 = g_quark_from_static_string ("Hard Difficulty")))) {
#line 622 "../lib/sudoku-board.vala"
		switch (0) {
#line 5457 "sudoku-board.c"
			default:
			{
#line 631 "../lib/sudoku-board.vala"
				result = DIFFICULTY_CATEGORY_HARD;
#line 631 "../lib/sudoku-board.vala"
				return result;
#line 5464 "sudoku-board.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label4) ? _tmp1_label4 : (_tmp1_label4 = g_quark_from_static_string ("Very Hard Difficulty")))) {
#line 622 "../lib/sudoku-board.vala"
		switch (0) {
#line 5470 "sudoku-board.c"
			default:
			{
#line 633 "../lib/sudoku-board.vala"
				result = DIFFICULTY_CATEGORY_VERY_HARD;
#line 633 "../lib/sudoku-board.vala"
				return result;
#line 5477 "sudoku-board.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label5) ? _tmp1_label5 : (_tmp1_label5 = g_quark_from_static_string ("Custom Puzzle")))) {
#line 622 "../lib/sudoku-board.vala"
		switch (0) {
#line 5483 "sudoku-board.c"
			default:
			{
#line 635 "../lib/sudoku-board.vala"
				result = DIFFICULTY_CATEGORY_CUSTOM;
#line 635 "../lib/sudoku-board.vala"
				return result;
#line 5490 "sudoku-board.c"
			}
		}
	} else {
#line 622 "../lib/sudoku-board.vala"
		switch (0) {
#line 5496 "sudoku-board.c"
			default:
			{
#line 637 "../lib/sudoku-board.vala"
				g_warning ("sudoku-board.vala:637: Could not parse difficulty level. Falling back " \
"to Easy difficulty");
#line 638 "../lib/sudoku-board.vala"
				result = DIFFICULTY_CATEGORY_EASY;
#line 638 "../lib/sudoku-board.vala"
				return result;
#line 5505 "sudoku-board.c"
			}
		}
	}
}

GType
difficulty_category_get_type (void)
{
	static volatile gsize difficulty_category_type_id__volatile = 0;
	if (g_once_init_enter (&difficulty_category_type_id__volatile)) {
		static const GEnumValue values[] = {{DIFFICULTY_CATEGORY_UNKNOWN, "DIFFICULTY_CATEGORY_UNKNOWN", "unknown"}, {DIFFICULTY_CATEGORY_EASY, "DIFFICULTY_CATEGORY_EASY", "easy"}, {DIFFICULTY_CATEGORY_MEDIUM, "DIFFICULTY_CATEGORY_MEDIUM", "medium"}, {DIFFICULTY_CATEGORY_HARD, "DIFFICULTY_CATEGORY_HARD", "hard"}, {DIFFICULTY_CATEGORY_VERY_HARD, "DIFFICULTY_CATEGORY_VERY_HARD", "very-hard"}, {DIFFICULTY_CATEGORY_CUSTOM, "DIFFICULTY_CATEGORY_CUSTOM", "custom"}, {0, NULL, NULL}};
		GType difficulty_category_type_id;
		difficulty_category_type_id = g_enum_register_static ("DifficultyCategory", values);
		g_once_init_leave (&difficulty_category_type_id__volatile, difficulty_category_type_id);
	}
	return difficulty_category_type_id__volatile;
}

